<?xml version="1.0"?>

<xsl:stylesheet
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	version="1.0">
	
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
	
	<xsl:template match="/">
		<xsl:element name="html">
			<xsl:call-template name="htmlHead"/>
			<xsl:call-template name="htmlBody"/>
		</xsl:element>
	</xsl:template>
	
	<xsl:template name="htmlHead">
		<xsl:element name="head">
			<xsl:element name="title">
				<xsl:value-of select="//heading"/>
			</xsl:element>
			<xsl:element name="link">
				<xsl:attribute name="href">resources/styles/HelloWorld.css</xsl:attribute>
				<xsl:attribute name="rel">stylesheet</xsl:attribute>
				<xsl:attribute name="type">text/css</xsl:attribute>
			</xsl:element>
		</xsl:element>
	</xsl:template>
	
	<xsl:template name="htmlBody">
		<xsl:element name="body">
			<xsl:apply-templates mode="inline-text"/>
		</xsl:element>
	</xsl:template>
	
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	
	<xsl:template match="heading" mode="inline-text">
		<xsl:element name="div">
			<xsl:attribute name="class">heading</xsl:attribute>
			<xsl:apply-templates mode="inline-text"/>
		</xsl:element>
	</xsl:template>
	
	<xsl:template match="p" mode="inline-text">
		<xsl:element name="div">
			<xsl:attribute name="class">normalPara</xsl:attribute>
			<xsl:apply-templates mode="inline-text"/>
		</xsl:element>
	</xsl:template>
	
</xsl:stylesheet>

