<?php
 
class Paloose {
      
   
      
   private $gSitemap;
   
   private $gRequestParameterModule;
   
   
   
    
    function __construct()
    {
      
      
      include_once( PALOOSE_LIB_DIRECTORY . "/environment/StringResolver.php" );
      
      
      include_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
      include_once( PALOOSE_LIB_DIRECTORY . "/environment/Utilities.php" );
      
      
      
      $this->setEnvironment();
      
      
      Environment::$isPalooseClient = ( Environment::$configuration[ 'client' ] == 'yes' );
      
      
      
      Environment::$configuration[ 'palooseVersion' ] = "1.5.2b5-c";
      
      
      
      
      Environment::$modules = array();
      
      include_once( PALOOSE_LIB_DIRECTORY . "/environment/RequestParameterModule.php" );
      $this->gRequestParameterModule = new RequestParameterModule( 'request-param' );
      Environment::$modules[ $this->gRequestParameterModule->getName() ] = $this->gRequestParameterModule;
      
      include_once( PALOOSE_LIB_DIRECTORY . "/environment/FlowModule.php" );
      $flowModule = new FlowModule( 'flow' );
      Environment::$modules[ $flowModule->getName() ] = $flowModule;
      
      include_once( PALOOSE_LIB_DIRECTORY . "/environment/ParameterModule.php" );
      $paramsModule = new ParameterModule( 'params' );
      Environment::$modules[ $paramsModule->getName() ] = $paramsModule;
      
      include_once( PALOOSE_LIB_DIRECTORY . "/environment/CookiesModule.php" );
      $cookiesModule = new CookiesModule( 'cookies' );
      Environment::$modules[ $cookiesModule->getName() ] = $cookiesModule;
      Environment::$gCookiesActive = false; 
      
      include_once( PALOOSE_LIB_DIRECTORY . "/environment/GlobalModule.php" );
      $globalsModule = new ParameterModule( 'global' );
      Environment::$modules[ $globalsModule->getName() ] = $globalsModule;
      
      
      
      
      include_once( PALOOSE_LIB_DIRECTORY . "/sitemap/Sitemap.php" );
      include_once( PALOOSE_LIB_DIRECTORY . "/sitemap/SitemapStack.php" );
      Environment::$sitemapStack = new SitemapStack();
      
      
      
      if ( Environment::$configuration[ 'sessionsRequired' ] == "yes" ) {
        ini_set( 'arg_separator.output','&amp;' );
        include_once( PALOOSE_LIB_DIRECTORY . "/environment/SessionModule.php" );
        $sessionModule = new SessionModule( 'session' );
        Environment::$modules[ $sessionModule->getName() ] = $sessionModule;
        
        include_once( PALOOSE_LIB_DIRECTORY . "/environment/Sessions.php" );
        Environment::$sessionHandler = new Sessions();
      }
      
      
      
      include_once( PALOOSE_LIB_DIRECTORY . "/sitemap/VariableStack.php" );
      Environment::$variableStack = new VariableStack();
      
      include_once( PALOOSE_LIB_DIRECTORY . "/serialization/OutputStream.php" );
      include_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/PalooseException.php" );
      include_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/InternalException.php" );
      include_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/UserException.php" );
      include_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/RunException.php" );
      include_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/ExitException.php" );
      include_once( PALOOSE_LIB_DIRECTORY . "/error-handling/ErrorPage.php" );
      
      require_once( PALOOSE_LIB_DIRECTORY . "/environment/Browser.php" );
   } 
    
   
   
   
    
   function run( $inRequestURI, $inQueryString )
   {
      Environment::$gRequestURI = $inRequestURI;
      Environment::$gQueryString = $inQueryString;
      
      $this->gRequestParameterModule->parseQuery( Environment::$gQueryString );
      $rootSitemapDir = Environment::$configuration[ 'siteRootDirectory' ];
      
      
      if ( substr( $rootSitemapDir, strlen( $rootSitemapDir ) - 1, 1 ) == Environment::getPathSeparator() ) {
         $rootSitemapDir = substr( $rootSitemapDir, 0, strlen( $rootSitemapDir ) - 1 );
      }
      
      
      
      if ( Environment::$isPalooseClient ) {
         
         $urlString = Environment::$gRequestURI;
         if ( strpos( $urlString, "?" ) ) {
            $matchableURI = substr( $urlString, 0, strpos( $urlString, "?" ) );
         } else {
            $matchableURI = $urlString;
         }
      } else {
         
         $matchableURI = Utilities::correctURI();
         $this->gRequestParameterModule = Environment::$modules[ 'request-param' ];
         $this->gRequestParameterModule->add( "resource", $matchableURI );
      }
      Environment::$modules[ 'global' ]->add( "query-string", Environment::$gQueryString );
      $browser = new Browser();
      Environment::$modules[ 'global' ]->add( "browser-user-agent", $browser->getName() );
         
      
      try {
         
         ob_start();
         $outputStream = new OutputStream( OutputStream::STANDARD_OUTPUT );
         
         
         Environment::$gRootSitemapDir = $rootSitemapDir;
         $this->gSitemap = new Sitemap( $rootSitemapDir, Environment::$configuration[ 'rootSiteMap' ], NULL, $outputStream );
         Environment::$sitemapStack->push( $this->gSitemap );
         $this->gSitemap->parse();
         
         $this->gSitemap->run( $matchableURI, Environment::$gQueryString, false );
         Environment::$sitemapStack->pop();
      } catch ( ExitException $e ) {
         
         
         
      } catch( InternalException $e ) {
         $errorPage = new ErrorPage( $e->getMessage(), $e->getCode(), NULL );
         $errorPage->display();
      } catch( UserException $e ) {
         $errorPage = new ErrorPage( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
         $errorPage->display();
      } catch( RunException $e ) {
         $errorPage = new ErrorPage( $e->getMessage(), $e->getCode(), NULL );
         $errorPage->display();
      }
      ob_end_flush();
   } 
   
   
   
   private function setEnvironment()
   {
      Environment::$configuration[ 'siteRootDirectory' ] = defined( 'PALOOSE_SITE_ROOT_DIRECTORY' ) ? PALOOSE_SITE_ROOT_DIRECTORY : "." ;
      Environment::$configuration[ 'rootSiteMap' ] = defined( 'PALOOSE_ROOT_SITEMAP' ) ? PALOOSE_ROOT_SITEMAP : "sitemap.xmap";
      
      Environment::$configuration[ 'cacheDir' ] = defined( 'PALOOSE_CACHE_DIR' ) ? PALOOSE_CACHE_DIR : "";
      Environment::$configuration[ 'timeZone' ] = defined( 'TIME_ZONE' ) ? TIME_ZONE : "Europe/London" ;
      Environment::$configuration[ 'userExceptionPage' ] = defined( 'PALOOSE_USER_EXCEPTION_PAGE' ) ? PALOOSE_USER_EXCEPTION_PAGE : "resource://resources/errorHandling/userError.html";
      Environment::$configuration[ 'userExceptionTransform' ] = defined( 'PALOOSE_USER_EXCEPTION_TRANSFORM' ) ? PALOOSE_USER_EXCEPTION_TRANSFORM : "resource://resources/transforms/errorPage2html.xsl";
      Environment::$configuration[ 'userExceptionStyle' ] = defined( 'PALOOSE_USER_EXCEPTION_STYLE' ) ? PALOOSE_USER_EXCEPTION_STYLE : "/paloose/resources/styles/userError.css";
      Environment::$configuration[ 'internalExceptionPage' ] = defined( 'PALOOSE_INTERNAL_EXCEPTION_PAGE' ) ? PALOOSE_INTERNAL_EXCEPTION_PAGE : "resource://resources/errorHandling/internalError.html";
      Environment::$configuration[ 'internalExceptionTransform' ] = defined( 'PALOOSE_INTERNAL_EXCEPTION_TRANSFORM' ) ? PALOOSE_INTERNAL_EXCEPTION_TRANSFORM : "resource://resources/transforms/errorPage2html.xsl";
      Environment::$configuration[ 'internalExceptionStyle' ] = defined( 'PALOOSE_INTERNAL_EXCEPTION_STYLE' ) ? PALOOSE_INTERNAL_EXCEPTION_STYLE : "/paloose/resources/styles/internalError.css";
      Environment::$configuration[ 'sitemapNamespace' ] = defined( 'PALOOSE_SITEMAP_NAMESPACE' ) ? PALOOSE_SITEMAP_NAMESPACE : "http://apache.org/cocoon/sitemap/1.0";
      Environment::$configuration[ 'sourceNamespace' ] = defined( 'PALOOSE_SOURCE_NAMESPACE' ) ? PALOOSE_SOURCE_NAMESPACE : "http://apache.org/cocoon/source/1.0";
      Environment::$configuration[ 'dirNamespace' ] = defined( 'PALOOSE_DIR_NAMESPACE' ) ? PALOOSE_DIR_NAMESPACE : "http://apache.org/cocoon/directory/2.0";
      Environment::$configuration[ 'i18nNamespace' ] = defined( 'PALOOSE_I18N_NAMESPACE' ) ? PALOOSE_I18N_NAMESPACE : "http://apache.org/cocoon/i18n/2.1";
      Environment::$configuration[ 'sqlNamespace' ] = defined( 'PALOOSE_SQL_QUERY_NAMESPACE' ) ? PALOOSE_SQL_QUERY_NAMESPACE : "http://apache.org/cocoon/SQL/2.0";
      Environment::$configuration[ 'pageHitTransform' ] = defined( 'PALOOSE_PAGE_HIT_TRANSFORM' ) ? PALOOSE_PAGE_HIT_TRANSFORM : "resource://resources/transforms/PageHit.xsl";
      Environment::$configuration[ 'palooseNamespace' ] = defined( 'PALOOSE_NAMESPACE' ) ? PALOOSE_NAMESPACE : "http://www.paloose.org/schemas/Paloose/1.0";
      Environment::$configuration[ 'XHTMLNamespace' ] = defined( 'PALOOSE_XHTML_NAMESPACE' ) ? PALOOSE_XHTML_NAMESPACE : "http://www.w3.org/1999/xhtml";
      Environment::$configuration[ 'galleryIndex' ] = defined( 'PALOOSE_GALLERY_INDEX' ) ? PALOOSE_GALLERY_INDEX : "gallery.xml";
      Environment::$configuration[ 'ImageMagickBin' ] = defined( 'PALOOSE_IMAGEMAGICK_BIN' ) ? PALOOSE_IMAGEMAGICK_BIN : "";
      Environment::$configuration[ 'sessionsRequired' ] = defined( 'PALOOSE_SESSIONS_REQUIRED' ) ? PALOOSE_SESSIONS_REQUIRED : "no";
      Environment::$configuration[ 'client' ] = defined( 'PALOOSE_CLIENT' ) ? PALOOSE_CLIENT : "no";
   } 
   
   
   
    
   function __destruct()
   {
      
   }
}
?>
