<?php
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/MatcherException.php" );
class WildcardURIMatcher {
   
   const MATCH_FILE = -1;
   
   const MATCH_PATH = -2;
   
   const MATCH_BEGIN = -4;
   
   const MATCH_THEEND = -5;
   
   const MATCH_END = -3;
    
   private $gHashMap;
    
      
   
   
   
   public function __construct()
   {
        $this->gHashMap = array();
   }
   
   
   
   private function compilePattern( $inData )
   {
   	$expr = "";
      unset( $expr );
      $buff = $this->toCharArray( $inData );
      
      
      $y = 0;
      $slash = false;
      
      
      $expr[ $y++ ] = self::MATCH_BEGIN;
      
      if ( sizeof( $buff ) > 0 ) {
         if ( $buff[ 0 ]=='\\' ) {
             $slash = true;
         } else if ( $buff[ 0 ] == '*' ) {
             $expr[ $y++ ] = self::MATCH_FILE;
         }  else {
             $expr[ $y++ ] = $buff[ 0 ];
         }
      
         
         for ( $x = 1; $x < sizeof( $buff ); $x++ ) {
             
             if ( $slash ) {
                 $expr[ $y++ ] = $buff[ $x ];
                 $slash = false;
             
             } else {
                 
                 if ( $buff[ $x ] == '\\' ) {
                     $slash = true;
                 
                 } else if ( $buff[ $x ] == '*' ) {
                     
                     if ( $expr[ $y-1 ] <= self::MATCH_FILE ) {
                         $expr[ $y-1 ] = self::MATCH_PATH;
                     } else {
                         $expr[ $y++ ] = self::MATCH_FILE;
                     }
                 } else {
                     $expr[ $y++ ]=$buff[ $x ];
                 }
             }
         }
      }
      
      $expr[ $y ] = self::MATCH_THEEND;
      return $expr;
   }
   
   
   
   public function match( $inData, $inPattern )
   {
      $globalsModule = Environment::$modules[ 'global' ];
      $preparedPattern = $this->compilePattern( $inPattern );
      
      $this->gHashMap = array(); 
      
      if ( strlen( $inData ) == 0 ) {
         throw new MatcherException( "No data provided" );
      }
      if ( sizeof( $preparedPattern ) == 0 ) {
         throw new MatcherException( "No pattern expression provided" );
      }
      $buff = $this->toCharArray( $inData );
      
      $rslt = "";  
      unset( $rslt );
      
      
      $charpos = 0;
      
      
      $exprpos = 0;
      $buffpos = 0;
      $rsltpos = 0;
      $offset = -1;
      
      
      $mcount = 0;
      
      
      $this->gHashMap[ $mcount ] = $inData;
      $globalsModule->add( "__0", $inData );
      
      
      $matchBegin = false;
      if ( $preparedPattern[ $charpos ] == self::MATCH_BEGIN ) {
         $matchBegin = true;
         $exprpos = ++$charpos;
      }
   
      
      while ( $preparedPattern[ $charpos ] >= 0 ) {
         $charpos++;
      }
      
      $exprchr = $preparedPattern[ $charpos ];
      while ( true ) {
         
         
         
         if ( $matchBegin ) {
            if ( !$this->matchArray( $preparedPattern, $exprpos, $charpos, $buff, $buffpos ) ) return false;
            $matchBegin = false;
         } else {
            $offset = $this->indexOfArray( $preparedPattern, $exprpos, $charpos, $buff, $buffpos );
            if ( $offset < 0 ) return false;
         }
         
         if ( $matchBegin ) {
            if ( $offset != 0 ) return false;
            $matchBegin = false;
         }
         
         $buffpos += ( $charpos - $exprpos );
         
         if ( $exprchr == self::MATCH_END ) {
            if ( $rsltpos > 0 && $this->gHashMap != NULL ) {
               
               
               $scrap = implode( "", $rslt );
               $scrap = substr( $scrap, 0, $rsltpos );
               $this->gHashMap[ ++$mcount ] = substr( $rslt, 0, $rsltpos ); 
               $globalsModule->add( "__$mcount", substr( $rslt, 0, $rsltpos ) );
            }
            
            return true;
         } else if ( $exprchr == self::MATCH_THEEND ) {
            if ( $rsltpos > 0 && sizeof( $this->gHashMap ) > 0 ) {
               $scrap = implode( "", $rslt );
               $scrap = substr( $scrap, 0, $rsltpos );
               $this->gHashMap[ ++$mcount ] = substr( $rslt, 0, $rsltpos );
               $globalsModule->add( "__$mcount", substr( $rslt, 0, $rsltpos ) );
            }
            
            return ( $buffpos == sizeof( $buff ) );
         }
   
         
         $exprpos = ++$charpos;
         while ( $preparedPattern[ $charpos ] >= 0 ) $charpos++;
         $prevchr = $exprchr;
         $exprchr = $preparedPattern[ $charpos ];
         
         $offset = ( $prevchr == self::MATCH_FILE ) ?
            $this->indexOfArray( $preparedPattern, $exprpos, $charpos, $buff, $buffpos ) :
            $this->lastIndexOfArray ( $preparedPattern, $exprpos, $charpos, $buff,$buffpos );
         if ( $offset < 0 ) return false;
         
        if ( $prevchr == self::MATCH_PATH ) {
             while ( $buffpos < $offset ) {
                $ch = $buff[ $buffpos++ ];
                $rslt[ $rsltpos++ ] = $ch;
             }
         } else {
             
            while ( $buffpos < $offset ) {
               if ( $buff[ $buffpos ] == '/' ) return false;
               $ch = $buff[ $buffpos++ ];
               $rslt[ $rsltpos++ ] = $ch;
            }
         }
         if ( !isset( $rslt ) ) {
            throw new MatcherException( "No pattern expression provided in sitemap expression" );
         }
         if ( $this->gHashMap != NULL ) {
            $scrap = implode( "", $rslt );
            $scrap = substr( $scrap, 0, $rsltpos );
            $this->gHashMap[ ++$mcount ] = $scrap;
            $globalsModule->add( "__$mcount", $scrap );
        }
         $rsltpos = 0;
      }
   }
   
   
   
   
    
   public function getHashMap()
   {
      return $this->gHashMap;
   }
   
   
   
   private function indexOfArray( $r, $rpos, $rend, $d, $dpos )
   {
      
      if ( $rend < $rpos ) throw new MatcherException( "rend < rpos, must be greater" );
      
      if ( $rend == $rpos ) return ( sizeof( $d ) ); 
      
      if ( ( $rend - $rpos) == 1 ) {
         
         for ( $x = $dpos; $x < sizeof( $d ); $x++ ) {
            if ( $r[ $rpos ] == $d[ $x ] ) return $x;
         }
      }
      
      
      while ( ( $dpos + $rend - $rpos ) <= sizeof( $d ) ) {
         
         $y = $dpos;
         
         for ( $x = $rpos; $x <= $rend; $x++ ) {
            if ( $x == $rend ) return ( $dpos );
            if ( $r[ $x ] != $d[ $y++ ] ) break;
         }
         
         $dpos++;
      }
      
      
      return -1;
   }
   
   
   
    
    private function lastIndexOfArray( $r, $rpos, $rend, $d, $dpos )
    {
      
      if ( $rend < $rpos ) throw new MatcherException( "rend < rpos, must be greater" );
        
       
      if ( $rend == $rpos ) return ( sizeof( $d ) ); 
        
        if ( ( $rend - $rpos ) == 1 ) {
            
            for ( $x = sizeof( $d ) - 1; $x > $dpos; $x-- ) {
                if ( $r[ $rpos ] == $d[ $x ] ) return ( $x );
            }
        }
        
        
        $l = sizeof( $d ) - ( $rend - $rpos );
        while ( $l >= $dpos ) {
            
            $y = $l;
            
            
            for ( $x = $rpos; $x <= $rend; $x++ ) {
                if ( $x == $rend ) return $l;
                if ( $r[ $x ] != $d[ $y++ ] ) break;
            }
            
            $l--;
        }
        
        
        return -1;
    }
    
   
   
   
    
   private function matchArray( $r, $rpos, $rend, $d, $dpos )
   {
      
      
      if ( sizeof( $d ) - $dpos < $rend - $rpos ) return false;
      for ( $i = $rpos; $i < $rend; $i++ ) {
         
         if ( $r[ $i ] != $d[ $dpos++ ] ) return false;
      }
      return true;
   }
   
   
   
   function  toCharArray( $inString )
   { 
      $len = strlen( $inString ); 
      for ( $j = 0; $j < strlen ( $inString ); $j++ ) { 
         $char[ $j ]  =  substr( $inString,  $j,  1 );         
      } 
      return $char; 
   } 
   
  
   
   
    
   public function toString( )
   {
      $mess = "<matcher name='{$this->gType}' src='{$this->gSrc}' package='{$this->classname( )}'/>\n";
      return $mess;
   }
}
?>
