<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Browser.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElement.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElementInterface.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/selection/Selector.php" );
class SelectorPipeElement extends PipeElement implements PipeElementInterface
{
    
    
   protected $gWhenPipes;
    
   protected $gOtherwisePipe;
   
   
   
    
   public function __construct( DOMDocument $inDOM, $inType = "", $inSrc = "", $inComponent = NULL )
   {
      parent::__construct( $inDOM, $inType, $inSrc, $inComponent );
      $this->gGenericType = PipeElement::SELECTOR;
      $this->gSrc = $inSrc;
      $this->gType = $inType;
      $this->gComponent = $inComponent;
      
      $xpath = new domxpath( $inDOM );
      $xpath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
 
      
      
      $components = $xpath->query( "/m:select[1]/*" );
      
      
      
      
      
      foreach ( $components as $node ) {
         $switchDOM = new DOMDocument;
         $switchDOM->appendChild( $switchDOM->importNode( $node, 1 ) );
         
             
         
         $pipeXPath= new domxpath( $switchDOM );
         $pipeXPath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
         $testString = $node->getAttribute( "test" );
         $pipeComponent = $pipeXPath->query( "/*/*" );
            
         if ( $node->localName == "when" ) {
         } else if ( $node->localName == "otherwise" ) {
         }
            
            $pipe = new Pipe();
   
            foreach ( $pipeComponent as $pipeNode ) {
               $name = $pipeNode->localName;
               
               switch ( $name ) {
   
                  case "select" :
                     try {
                        $selector = PipeElement::createSelector( $pipeNode );
                        
                        $pipe->addComponent( $selector );
                     } catch ( UserException $e ) {
                        throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                     }
                     break;
                  
                  case "aggregate" :
                     try {
                        $aggregator = PipeElement::createAggregator( $pipeNode );
                        
                        $pipe->addComponent( $aggregator );
                     } catch ( UserException $e ) {
                        throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                     }
                     break;
                  
                  case "generate" :
                     try {
                        $generator = PipeElement::createGenerator( $pipeNode );
                        
                        $pipe->addComponent( $generator );
                     } catch ( UserException $e ) {
                        throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                     }
                     break;
                     
                  case "transform" :
                     try {
                        $transformer = PipeElement::createTransformer( $pipeNode );
                        
                        $pipe->addComponent( $transformer );
                     } catch ( UserException $e ) {
                        throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                     }
                     break;
   
                  case "serialize" :
                     try {
                        $serializer = PipeElement::createSerializer( $pipeNode );
                        
                        $pipe->addComponent( $serializer );
                     } catch ( UserException $e ) {
                        throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                     }
                     break;
                  
                  case "read" :
                     try {
                        $reader = PipeElement::createReader( $pipeNode );
                        
                        $pipe->addComponent( $reader );
                     } catch ( UserException $e ) {
                        throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                     }
                     break;
                     
                  case "call" :
                     try {
                        $call = PipeElement::createCall( $pipeNode );
                        
                        $pipe->addComponent( $call );
                     } catch ( UserException $e ) {
                        throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                     }
                     break;
                  case "mount" :
                     try {
                        $mount = PipeElement::createMount( $pipeNode );
                        $pipe->addComponent( $mount );
                     } catch ( UserException $e ) {
                        throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                     }
                     break;
   
               }
            }
   
         if ( $node->localName == "when" ) {
                 $this->gWhenPipes[ $testString ] = $pipe;
            } else if ( $node->localName == "otherwise" ) {
               $this->gOtherwisePipe = $pipe;
            }
         }
      }
   
   
   
   public function run( VariableStack $inVariableStack, $inURL, $inQueryString, DOMDocument $inDOM )
   {
      return $inDOM;
   }
   
   
   
    
   public function toString()
   {
      if ( $this->gWhenPipes != null ) {
         $mess = "     <select type='{$this->gType}' package='" . get_class( $this ) . "'>\n";
         foreach ( $this->gWhenPipes as $test => $pipe ) {
            $mess .= "       <when test='" . $test . "'>\n";
            $mess .= $pipe->toString();
            $mess .= "       </when>\n";
         }
         if ( $this->gOtherwisePipe != null ) {
            $mess .= "       <otherwise>\n";
            $mess .= $this->gOtherwisePipe->toString();
            $mess .= "       </otherwise>\n";
         }
         $mess .= "     </select>\n";
         return $mess;
      } else {
         return "";
      }
   }
}
?>
