<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Utilities.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElement.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/StringResolver.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/InternalException.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/UserException.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/RunException.php" );
 
class AggregatorPart {
    
   private $gSrc;
    
   private $gElement;
   
    
   private $gStripRoot;
    
   
   
   
    
   public function __construct( $inNode )
   {
      $this->gSrc = $inNode->getAttribute( "src" );
      if ( strlen ( $this->gSrc ) == 0 ) {
         $dom = new DOMDocument;
         $dom->appendChild( $dom->importNode( $inNode, 1 ) );
         throw new UserException(
            "Must have an associated src attribute with aggregate part",
            PalooseException::SITEMAP_AGGREGATE_PARSE_ERROR,
            $dom );
      }
      $this->gElement = $inNode->getAttribute( "element" );
      $this->gStripRoot = $inNode->getAttribute( "strip-root" );
      if ( strlen( $this->gStripRoot ) > 0 ) {
         $this->gStripRoot = Utilities::normalizeBoolean( $this->gStripRoot );
      }
  }
   
   
   
    
   public function getSrc()
   {
      return $this->gSrc;
   }
   
   
   
    
   public function getElement()
   {
      return $this->gElement;
   }
   
   
   
    
   public function getStripRoot()
   {
      return $this->gStripRoot;
   }
   
   
   
   public function toString()
   {
      $mess = "     <part src='{$this->gSrc}' element='{$this->gElement}' strip-root='{$this->gStripRoot}'/>\n";
      return $mess;
   }
 }
?>
