<?php
 
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElement.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElementInterface.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/sitemap/Parameter.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/authentication/EncryptMD5.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/transforming/TransformerPipeElement.php" );
 
class ModuleWriteTransformer extends TransformerPipeElement implements PipeElementInterface
{
      
   
   
   
   public function __construct( DOMDocument $inDOM, $inType = "", $inSrc = "", $inComponent = NULL )
   {
       try {
          parent::__construct( $inDOM, $inType, $inSrc, $inComponent );
       } catch ( UserException $e ) {
          throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
       }
   }
   
   
   
   public function run( VariableStack $inVariableStack, $inURL, $inQueryString, DOMDocument $inDOM )
   {
      $rootNode = $inDOM->documentElement;
      $this->gTranslatedDOM = new DOMDocument();
      $elementNS = $rootNode->namespaceURI;
      $newElement = $this->gTranslatedDOM->createElementNS( $elementNS, $rootNode->nodeName );
      $this->gTranslatedDOM->appendChild( $newElement );
      $this->processNode( $inVariableStack, $rootNode, $newElement );
      return $this->gTranslatedDOM;
   }
   
   
   
   private function processNode( VariableStack $inVariableStack, DOMNode $inParentNode, DOMNode &$inNewParentNode )
   {
      
      $nsPrefix = $inParentNode->prefix;
      $namespaceURI = $inParentNode->lookupNamespaceURI( $nsPrefix );
      $deleteParentNode = false;
      if ( ( $namespaceURI == PALOOSE_NAMESPACE ) and ( $inParentNode->localName == "modules" ) ) {
         
         $children = $inParentNode->childNodes;
         
         if ( $inParentNode->hasAttribute( "name" ) ) {
            $moduleName = $inParentNode->getAttribute( "name" );
            $module = Environment::$modules[ $moduleName ];
            $children = $inParentNode->childNodes;
            foreach ( $children as $child ) {
               if ( ( $child->nodeType == XML_ELEMENT_NODE ) and ( $child->localName == "param" ) ) {
                  $module->add( $child->getAttribute( "name" ), $child->getAttribute( "value" ) );
               }
            }
         }
         $deleteParentNode = true;
      } else {
         
         if ( $inParentNode->nodeType == XML_ELEMENT_NODE ) {
            $encodedAttribs = array();
            if ( $inParentNode->hasAttributes() ) {
               foreach ( $inParentNode->attributes as $attribute ) {
                  $inNewParentNode->setAttribute( $attribute->name, $attribute->value );
               }
            }
            foreach ( $encodedAttribs as $name => $value ) {
               $inNewParentNode->setAttribute( $name, $value );
            }
         }
 
         
         
         $children = $inParentNode->childNodes;
         foreach ( $children as $child ) {
            if ( $child->nodeType == XML_ELEMENT_NODE ) {
               
               $newElementNode = $this->gTranslatedDOM->createElementNS( $child->namespaceURI, $child->nodeName );
               
               if ( !$this->processNode( $inVariableStack, $child, $newElementNode ) ) {
                  $inNewParentNode->appendChild( $newElementNode );
               }
            } else if ( $child->nodeType == XML_TEXT_NODE ) {
               
               $newTextNode = $this->gTranslatedDOM->createTextNode( $child->textContent );
               $inNewParentNode->appendChild( $newTextNode );}
         }
      }
      return $deleteParentNode;
   }
   
   
   
  
   public function toString()
   {
      return parent::toString( $this->gGenericType );
   }
}
 
class _ModuleWriteTransformer extends Transformer {
    
   
   
   
   
   public function __construct( $inName, $inSrc, DOMNode $inParameterNode, $inIsCachable )
   {
      parent::__construct( $inName, $inSrc, $inParameterNode, $inIsCachable );
      $this->gPackageName = "ModuleWriteTransformer";
   }
}
?>
