<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/acting/Action.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/acting/AuthenticationActions.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/sitemap/Parameter.php" );
class LoginAction extends AuthenticationActions
{
       
   
   
   
   public function __construct( DOMDocument $inDOM, $inType = "", $inSrc = "", $inComponent = NULL )
   {
        parent::__construct( $inDOM, $inType, $inSrc, $inComponent );
   }
   
   
   
   public function run( VariableStack $inVariableStack, $inURL, $inQueryString, DOMDocument $inDOM )
   {
      parent::run( $inVariableStack, $inURL, $inQueryString, $inDOM );
      try {
         
         $user = StringResolver::expandString( $inVariableStack, $this->gParameters->getParameter( "username" ) );
         $password = StringResolver::expandString( $inVariableStack, $this->gParameters->getParameter( "password" ) );
         
         
         $authorizationDOM = $this->gAuthenticationManager->checkAuthorization( $this->gHandler, $user, $password );
     
         $xpath = new domxpath( $authorizationDOM );
         $dataNodes = $xpath->query( "/authentication/@verify" );
         $isUserVerified = Utilities::getXPathListStringItem( 0, $xpath, "/authentication/@verify" );
         if ( $isUserVerified == "true" ) {
            
            
            
            $username = Utilities::getXPathListStringItem( 0, $xpath, "/authentication/users/user/username" );
            Environment::$sessionHandler->setVar( '__username', $username );
            Environment::$sessionHandler->start();
            
            $this->gPipe->run( $inVariableStack, $inURL, $inQueryString, $inDOM );
            
            throw new ExitException();
         } else {
            
            return $inDOM;
         }
      } catch ( ExitException $e ) {
         throw new ExitException();
      } catch ( UserException $e ) {
         throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
      } catch ( RunException $e ) {
         throw new RunException( $e->getMessage(), $e->getCode() );
      }
   }
}
 
class _LoginAction extends Action {
    
   
   
   
   
   public function __construct( $inName, $inSrc, DOMNode $inParameterNode, $inIsCachable )
   {
      parent::__construct( $inName, $inSrc, $inParameterNode, $inIsCachable );
      $this->gSMTPHost = "";
      $this->gSMTPUser = "";
      $this->gSMTPPassword = "";
      $this->gPackageName = "LoginAction";
      $parameterDOM = new DOMDocument;
      $parameterDOM->appendChild( $parameterDOM->importNode( $inParameterNode, 1 ) );
   }
   
   
   
   public function toString()
   {
      if ( $this->gParameters != NULL or strlen( $this->gSMTPHost ) > 0 or strlen( $this->gSMTPUser ) > 0 or strlen( $this->gSMTPPassword ) > 0 ) {
         $mess = "   <action name='{$this->gName}' src='{$this->gSrc}' package='{$this->gPackageName}'>\n";
         if ( $this->gParameters != NULL ) {
            while ( list( $name, $value ) = each( $this->gParameters ) ) {
               $mess .= "    <parameter name='$name' value='$value'/>\n";
            }
            reset( $this->gParameters ); 
         }
         $mess .= "   </action>\n";
      } else {
         $mess = "   <action name='{$this->gName}' src='{$this->gSrc}' package='{$this->gPackageName}'/>\n";
      }
      return $mess;
   }
}
?>
