<?php
 
 
class AuthenticationHandler {
   private $gDefault;
   
   private $gName;
   
   private $gRedirectToURI;
   private $gAuthenticationURI;
   
   private $gAuthenticator;
      
   
   
   
   public function __construct()
   {
      $this->gName = "";
      $this->gRedirectToURI = "";
      $this->gAuthenticationURI = "";
      $this->gAuthenticator = "";
   }
   
   
   
   public function parse( DOMNode $inNode )
   {
      
      $pipelinesDom = new DOMDocument;
      $pipelinesDom->appendChild( $pipelinesDom->importNode( $inNode, 1 ) );
      $xpath = new domxpath( $pipelinesDom );
      $xpath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
      $this->gName = Utilities::getXPathListStringItem( 0, $xpath, "//@name" );
      $this->gRedirectToURI = Utilities::getXPathListStringItem( 0, $xpath, "//m:redirect-to/@uri" );
      $this->gAuthenticationURI = Utilities::getXPathListStringItem( 0, $xpath, "//m:authentication/@uri" );
      $this->gAuthenticator = Utilities::getXPathListStringItem( 0, $xpath, "//m:authentication/@authenticator" );
      if ( strlen( $this->gAuthenticationURI ) == 0 and strlen( $this->gAuthenticator ) == 0 ) {
         throw new UserException( "Must have authenticator or uri declared in handler authentication",
            PalooseException::SITEMAP_ACTION_PARSE_ERROR,
            $pipelinesDom );
      }
   }
   
   
   
   public function getName()
   {
      return $this->gName;
   }
   
   
   
   public function getRedirectToURI()
   {
      return $this->gRedirectToURI;
   }
   
   
   
   public function getAuthenticationURI()
   {
      return $this->gAuthenticationURI;
   }
   
   
   
   public function getAuthenticator()
   {
      return $this->gAuthenticator;
   }
   
   
   
   public function toString()
   {
      $mess = "    <handler name='{$this->gName}'>\n";
      if ( strlen( $this->gRedirectToURI ) > 0 ) {
         $mess .= "     <redirect-to uri='{$this->gRedirectToURI}'/>\n";
      }
      if ( strlen( $this->gAuthenticationURI ) > 0 ) {
         $mess .= "     <authentication uri='{$this->gAuthenticationURI}'/>\n";
      }
      if ( strlen( $this->gAuthenticator ) > 0 ) {
         $mess .= "     <authentication uri='{$this->gAuthenticator}'/>\n";
      }
      return $mess;
   }
}
?>
