<?php
 
require_once( PALOOSE_LIB_DIRECTORY . "/authentication/AuthenticationHandler.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/InternalException.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/UserException.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/RunException.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/ExitException.php" );
 
class AuthenticationHandlers {
   
   
   private $gHandlerList;
      
   
   
   public function __construct()
   {
      $this->gHandlerList = array();
   }
   
   
   
   public function parse( DOMNode $inNode )
   {
      
      $pipelinesDom = new DOMDocument;
      $pipelinesDom->appendChild( $pipelinesDom->importNode( $inNode, 1 ) );
      $this->gXPath = new domxpath( $pipelinesDom );
      $this->gXPath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
      $nodeList = $this->gXPath->query( "//*" );
      $idx = 0;
      foreach ( $nodeList as $node ) {
         if ( $node->localName == "handler" ) {
            try {
               $manager = new AuthenticationHandler();
               $manager->parse( $node );
               $this->gHandlerList[ $manager->getName() ] = $manager;
            } catch ( UserException $e ) {
               throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
            }
         }
      }
   }
   
   
   
    
    public function getHandler( $inName )
    {
       if ( isset( $this->gHandlerList[ $inName ] ) ) {
          return $this->gHandlerList[ $inName ];
       } else {
          throw new UserException( "Handler $inName does not exist", PalooseException::SITEMAP_ACTION_PARSE_ERROR, NULL );  
       }
    }
   
   
   
   public function toString()
   {
      $mess = "   <handlers>\n";
      foreach ( $this->gHandlerList as $node ) {
         $mess .= $node->toString();
      }
      $mess .= "   </handlers>\n";
      return $mess;
   }
}
?>
