<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Modules.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Utilities.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
 
 class Sessions
 {
      
   
   
   private $gSessionId = "";
   
   
   
   public function __construct()
   {
      session_start();
      $this->gSessionId = session_id();
      $this->setVar( '__sid', $this->gSessionId );
      
      $sessionModule = Environment::$modules[ 'session' ];
      foreach ( $_SESSION as $key => $value ) {
         $sessionModule->add( $key, $value );
      }
  }
   
   
   
   
    
   public function start()
   {
   }
   
   
   
   
   public function destroy()
   {
      
      if ( session_id() != "" ) {
         $sessionModule = Environment::$modules[ 'session' ];
         $sessionModule->clear();
         $this->gSessionId = "";
         $_SESSION = array();
         session_destroy();
      }
   }
   
   
   
    
   public function setVar( $inName, $inValue )
   {
      $_SESSION[ $inName ] = $inValue;
      $sessionModule = Environment::$modules[ 'session' ];
      $sessionModule->add( $inName, $inValue );
   }
   
   
   
    
   public function getVar( $inName )
   {
      if ( $this->isSessionVarSet( $inName ) ) {
           return $_SESSION[ $inName ];
      } else {
         return "";
      }
   }
   
   
   
    
   public function isSessionVarSet( $inName )
   {
      return isset( $_SESSION[ $inName ] );
   }
   
   
   
    
   public function isValidSession()
   {
      if ( session_id() != "" ) {
         return session_id();
      } else {
         return "";
      }
   }   
   
   
   
    
   public function areCookiesEnabled()
   {
      return $this->gCookiesEnabled;
   }   
   
   
   
    
   public function encode()
   {
      return session_encode();
   }   
   
   
   
   
   public function setSessionName( $inName )
   {
      $this->gParams[ "__name" ] = $inName;
   }
   
   
   
   
   public function getSessionName()
   {
      if ( array_key_exists( '__name', $_SESSION ) ) {
         return $this->gParams[ "__name" ];
      } else {
         return "";
      }
   }
}
?>
