<?php
 
 
class Continuations {
      
      
   protected $gContinuation;
   
   private $gViolations;
   
   
   
    
   function __construct( &$inFormModel )
   {
      
      $sessionModule = Environment::$modules[ 'session' ];
      $flowModule = Environment::$modules[ 'flow' ];
      $requestParameterModule = Environment::$modules[ 'request-param' ];
      
      
      
      $sessionId = Environment::$sessionHandler->isValidSession();
      if ( $sessionId != '' ) {
      } else {
         $sessionModule = new SessionModule();
         Environment::$modules[ 'session' ] = $sessionModule;
      }
      
      $this->decodeFlowVariables( $inFormModel );
       
       
      if ( !Environment::$sessionHandler->isSessionVarSet( '__flowId' ) ) {
         $this->gContinuation = 0;
         $flowModule->add( '__flowId', time()  );
      } else {
         $flowModule->add( '__flowId', Environment::$sessionHandler->getVar( '__flowId' )  );
      }
      
      if ( strlen( $requestParameterModule->get( 'paloose-action-next' ) ) > 0 ) {
         
         $this->gContinuation = $requestParameterModule->get( 'paloose-kont' );
      } else if ( strlen( $requestParameterModule->get( 'paloose-action-prev' ) ) > 0 ) {
         
         
         $requestParameterModule->add( 'paloose-kont', $requestParameterModule->get( 'paloose-kont' ) - 2 );
         $this->gContinuation = $requestParameterModule->get( 'paloose-kont' );
      } else {
         
         $this->gContinuation = 0;
      }
      
      
      foreach ( $requestParameterModule->getParams() as $name => $value ) {
         $flowModule->add( $name, $value );
      }
      
      
      
      foreach ( $flowModule->getParams() as $name => $value ) {
         if ( array_key_exists( $name, $inFormModel ) ) {
            $inFormModel[ $name ] = $value;
         }
      }
      $this->encodeFlowVariables( $inFormModel );
   }
   
   
   
   
   private function encodeFlowVariables( &$inFormModel )
   {
      $sessionModule = Environment::$modules[ 'session' ];
      $flowModule = Environment::$modules[ 'flow' ];
        
      
      $formData = "";
      foreach ( $inFormModel as $name => $value ) {
         $formData .= $name . ":=:" .$value . ";;";
      }
      $formData = trim( $formData, ";" );
      Environment::$sessionHandler->setVar( '__dataModel', $formData );
      
      
      $flowData = "";
      foreach ( $flowModule->getParams() as $name => $value ) {
         $flowData .= $name . ":=:" .$value . ";;";
      }
      $flowData = trim( $flowData, ";" );
      Environment::$sessionHandler->setVar( '__flowData', $flowData );
      
   }
   
   
   
   private function decodeFlowVariables( &$inFormModel )
   {
      $sessionModule = Environment::$modules[ 'session' ];
      $flowModule = Environment::$modules[ 'flow' ];
        
      if ( Environment::$sessionHandler->isSessionVarSet( '__flowData' ) ) {
         $flowData = Environment::$sessionHandler->getVar( '__flowData' );
         $flowVarPairs = explode( ';;', $flowData );
         foreach ( $flowVarPairs as $pair ) {
            list( $name, $value ) = explode( ':=:', $pair );
            $flowModule->add( $name, $value );
         }
      }
        
      if ( Environment::$sessionHandler->isSessionVarSet( '__dataModel' ) ) {
         $dataModel = Environment::$sessionHandler->getVar( '__dataModel' );
         $dataVarPairs = explode( ';;', $dataModel );
         foreach ( $dataVarPairs as $pair ) {
            list( $name, $value ) = explode( ':=:', $pair );
            $inFormModel[ $name ] = $value;
         }
      }
      foreach ( $inFormModel as $name => $value ) {
      }
              
   }
   
   
   
   protected function initContinuationIfNotSet( $inValue )
   {
      if ( !isset( $this->gContinuation ) or strlen( $this->gContinuation ) == 0 ) {
          $this->gContinuation = $inValue;
       }
   }
   
   
   
   protected function resetContinuation()
   {
       unset( $this->gContinuation );
    }
   
   
   
   protected function sendPage( $inPage, &$inFormModel, $inContinuation, $inViolations )
   {
      
      $flowModule = Environment::$modules[ "flow" ];
      foreach ( $inFormModel as $name => $value ) {
         $flowModule->add( $name, $value );
      }
      $flowModule->add( "continuation.id", $inContinuation );
      
      
      
      
      
      $sessionModule = Environment::$modules[ "session" ];
      $sessionModule->add( "__violations", Utilities::arrayToXML( $inViolations, "violation-list" ) );
      $this->encodeFlowVariables( $inFormModel );
      
      $sitemap = Environment::$sitemapStack->peek();
      $sitemap->run( $inPage, "", true );
   }
}
?>
