<?php
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/GedComException.php" );
    
class GedComLine
{
    
   
   private $gLineString;
   
   private $gLineNumber = 0;
   
   private $gLineLevel = "";
   
   private $gTag = "";
   
   private $gIdentifier = "";
   
   private $gLineData = "";
   
   
   
    
   public function __construct( $inLineString, $inLineNumber  )
   {
       $this->gLineNumber = $inLineNumber;
       $this->gLineString = $inLineString;
      if ( $this->gLineNumber == 0 ) {
         throw new GedcomException( "No line number associated with this line: " . $this->gLineString, PalooseException::SITEMAP_GEDCOM_ERROR );
      }
      
      $finished = false;
      if ( preg_match( "/^(\d+)\s+([A-Z_]+)\s*(.*)$/", $this->gLineString, $matches ) ) {
         $this->gLineLevel = $matches[1];
         $this->gTag = $matches[2];
         $this->gLineData = $matches[3];
         $finished = true;
      }
      if ( $finished == false ) {
         if ( preg_match( "/^(\d+)\s+(@[^@]+@)\s*(.*)$/", $this->gLineString, $matches ) ) {
            $this->gLineLevel = $matches[1];
            $this->gIdentifier = $matches[2];
            $this->gLineData = $matches[3];
            $finished = true;
         }
      }
      if ( $finished == false ) {
         throw new GedcomException( "Could not parse line: [" . $this->gLineNumber . "] : " . $this->gLineString, PalooseException::SITEMAP_GEDCOM_ERROR );
      }
}
   
   
   
   public function getLineNumber()
   {
      return $this->gLineNumber;
   }
   
   
   
   
   public function getLevel()
   {
      return $this->gLineLevel;
   }
   
   
   
   
   public function getTag()
   {
      return $this->gTag;
   }
   
  
   
   
   public function getIdentifier()
   {
      return $this->gIdentifier;
   }
   
   
   
   
   public function getData()
   {
      return $this->gLineData;
   }
   
   
   
   
   public function toString()
   {
      if ( $this->gTag != "" ) {
         return $this->gLineLevel . " " . $this->gTag . " " . $this->gLineData;
      } else if ( $this->gIdentifier != "" ){
         return $this->gLineLevel . " @" . $this->gIdentifier . "@ " . $this->gLineData;
      } else {
         return "";
      }
   }
}
?>
