<?php
require_once( PALOOSE_LIB_DIRECTORY . "/matching/Match.php" );
class Pipeline {
   
   private $gMatchersList;
   
   private $gInternalPipeline;
   
   private $gErrorHandler;
      
   
   
   
   public function __construct()
   {
      $this->gInternalPipeline = false;
      $this->gErrorHandler = NULL;
   }
   
   
   
    
   public function parse( DOMNode $inNode )
   {
      
      $pipelineDom = new DOMDocument;
      $pipelineDom->appendChild( $pipelineDom->importNode( $inNode, 1 ) );
      
      $this->gInternalPipeline = Utilities::normalizeBoolean( $inNode->getAttribute( "internal-only" ) );
      $xpath = new domxpath( $pipelineDom );
      $xpath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
      
      $nodeList = $xpath->query( "//*" );
      $idx = 0;
      foreach ( $nodeList as $node ) {
         if ( $node->localName == "match" ) {
            $match = new SimpleMatch();
            try {
               $match->parse( $node );
               $this->gMatchersList[ $idx++ ] = $match;
            } catch ( UserException $e ) {
               throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
            }
         } else if ( $node->localName == "handle-errors" ) {
            try {
               $this->gErrorHandler = new HandleError();
               $this->gErrorHandler->parse( $node );
            } catch ( UserException $e ) {
               throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
            }
         }
      }
   }
   
   
   
   public function run( $inURL, $inQueryString, $inInternalRequest )
   {
      
      if ( $inInternalRequest === false and $this->gInternalPipeline === true ) return false;
      
      foreach( $this->gMatchersList as $node ) {
         try {
            
            if ( $node->run( $inURL, $inQueryString ) ) return true;
         } catch ( ExitException $e ) {
            throw new ExitException();
         } catch ( UserException $e ) {
            throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
         } catch ( RunException $e ) {
            
            
            if ( $this->gErrorHandler == NULL ) {
               throw new RunException( $e->getMessage(), $e->getCode(), NULL );
            } else {
               $this->gErrorHandler->run( $inURL, $e->getMessage() );
               throw new ExitException();
           }
         }
      }
      return false;
   }
   
   
   
   public function toString()
   {
      $mess = "  <pipeline";
      if ( $this->gInternalPipeline ) $mess .= " internal-only='true'";
      $mess .= ">\n";
      foreach ( $this->gMatchersList as $node ) {
         $mess .= $node->toString();
      }
      $mess .= "  </pipeline>\n";
      return $mess;
   }
}
?>
