<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElement.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElementInterface.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/reading/ReaderPipeElement.php" );
 
class ResourceReader extends ReaderPipeElement implements PipeElementInterface
{
    
   
   
   
   public function __construct( DOMDocument $inDOM, $inType = "", $inSrc = "", $inComponent = NULL )
   {
        try {
         parent::__construct( $inDOM, $inType, $inSrc, $inComponent );
        } catch ( UserException $e ) {
           throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
        }
   }
   
   
   
   public function run( VariableStack $inVariableStack, $inURL, $inQueryString, DOMDocument $inDOM )
   {
      
      $expandedString = StringResolver::expandString( $inVariableStack, $this->gSrc );
      $expandedString = StringResolver::expandPseudoProtocols( $expandedString );
      
      
      
      if ( file_exists( $expandedString ) ) {
         if ( readfile( $expandedString ) === false ) {
            throw new UserException( "Could not load resource '$expandedString'", PalooseException::SITEMAP_READER_RUN_ERROR );
         }
      } else {
           throw new RunException( "File '$expandedString' does not exist", PalooseException::SITEMAP_READER_RUN_ERROR );
      }
      return $inDOM;   
   }
   
   
   
   public function toString()
   {
      return parent::toStringWithType( $this->gGenericType );
   }
}
 
class _ResourceReader extends Reader {
    
   
   
   
   
    
   public function __construct( $inName, $inClassName, DOMNode $inParameterNode, $inIsCachable )
   {
      parent::__construct( $inName, $inClassName, $inParameterNode, $inIsCachable );
      $this->gPackageName = "ResourceReader";
      
   }
}
?>
