<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Browser.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElement.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElementInterface.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/selection/Selector.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/selection/SelectorPipeElement.php" );
class ResourceExistsSelector extends SelectorPipeElement implements PipeElementInterface
{
   
   
   
   
    
   public function __construct( DOMDocument $inDOM, $inType = "", $inSrc = "", $inComponent = NULL )
   {
      parent::__construct( $inDOM, $inType, $inSrc, $inComponent );
   }
   
   
   
   public function run( VariableStack $inVariableStack, $inURL, $inQueryString, DOMDocument $inDOM )
   {
      $prefix = $this->gParameters->getParameter( 'parameter-name' );
      if ( $prefix == NULL ) {
         $prefix = "/";
      }
      
      $testFound = false;
      
      foreach ( $this->gWhenPipes as $path => $pipe ) {
         
         $resourceFullPath = StringResolver::expandString( $inVariableStack, $path );
         $resourceFullPath = StringResolver::expandPseudoProtocols( $resourceFullPath );
         if ( file_exists( $resourceFullPath ) ) {
            $documentDOM = $pipe->run( Environment::$variableStack, $inURL, $inQueryString, $inDOM );
            return $documentDOM;
         }
      }
      if ( $this->gOtherwisePipe->getComponentListSize() > 0 ) {
         $documentDOM = $this->gOtherwisePipe->run( Environment::$variableStack, $inURL, $inQueryString, $inDOM );
      } else {
         return $inDOM;
      }
      return $documentDOM;
   }
}
 
class _ResourceExistsSelector extends Selector {
    
   
   
   private $gDefaultParameter;
   
   
   
   
   public function __construct( $inName, $inSrc, DOMNode $inParameterNode, $inIsCachable )
   {
      parent::__construct( $inName, $inSrc, $inParameterNode, $inIsCachable );
      $this->gPackageName = "ResourceExistsSelector";
      
        
      $requestParameterDOM = new DOMDocument;
      $requestParameterDOM->appendChild( $requestParameterDOM->importNode( $inParameterNode, 1 ) );
      
      $xpath = new domxpath( $requestParameterDOM );
      $xpath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
      $component = $xpath->query( "//m:selector/*" );
      
      $this->gDefaultParameter = Utilities::getXPathListStringItem( 0, $xpath, "//m:selector/m:parameter-prefix" );
  }
   
   
   
    
   public function isValid()
   {
      $parentIsValid = parent::isValid();
      
      return $parentIsValid;
   } 
   
   
   
    
   public function getDefaultPrefix()
   {
      return $this->gDefaultParameter;
   } 
   
   
   
    
   public function toString()
   {
      if ( $this->gParameters == NULL && $this->gBrowserAgent == NULL ) {
         return "   <selector name='{$this->gType}' src='{$this->gSrc}' package='{$this->gPackageName}'/>\n";
      }
      $mess = "   <selector name='{$this->gType}' src='{$this->gSrc}' package='{$this->gPackageName}'>\n";
      if ( $this->gParameters != NULL ) {
         while ( list( $name, $value ) = each( $this->gParameters ) ) {
            $mess .= "    <parameter name='$name' value='$value'/>\n";
         }
         reset( $this->gParameters );
      }
      if ( $this->gDefaultParameter != NULL ) {
         $mess .= "    <parameter-name>" . $this->gDefaultParameter . "</parameter-name>\n";
      }
      $mess .= "   </selector>\n";
      return $mess;
   }
}
?>
