<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Browser.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElement.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElementInterface.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/selection/Selector.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/selection/SelectorPipeElement.php" );
class VariableSelector extends SelectorPipeElement implements PipeElementInterface
{
    
   
   
   
    
   public function __construct( DOMDocument $inDOM, $inType = "", $inSrc = "", $inComponent = NULL )
   {
      parent::__construct( $inDOM, $inType, $inSrc, $inComponent );
   }
   
   
   
   public function run( VariableStack $inVariableStack, $inURL, $inQueryString, DOMDocument $inDOM )
   {
      
      $testValue = StringResolver::expandString( $inVariableStack, $this->gParameters->getParameter( 'test-value' ) );
      
      if ( $testValue != NULL and $this->gWhenPipes[ $testValue ] != NULL ) { 
         return $this->gWhenPipes[ $testValue ]->run( Environment::$variableStack, $inURL, $inQueryString, $inDOM );
      } else {
         if ( $this->gOtherwisePipe->getComponentListSize() > 0 ) {
            return $this->gOtherwisePipe->run( Environment::$variableStack, $inURL, $inQueryString, $inDOM );
         }
      }   
      return $inDOM;
     }
}
 
class _VariableSelector extends Selector {
    
   
   
   private $gDefaultParameter;
   
   
   
   
   public function __construct( $inName, $inSrc, DOMNode $inParameterNode, $inIsCachable )
   {
      parent::__construct( $inName, $inSrc, $inParameterNode, $inIsCachable );
      $this->gPackageName = "VariableSelector";
      
        
      $requestParameterDOM = new DOMDocument;
      $requestParameterDOM->appendChild( $requestParameterDOM->importNode( $inParameterNode, 1 ) );
        
      $xpath = new domxpath( $requestParameterDOM );
      $xpath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
      $component = $xpath->query( "//m:selector/*" );
      
      $this->gDefaultParameter = Utilities::getXPathListStringItem( 0, $xpath, "//m:selector/m:parameter-name" );
  }
   
   
   
    
   public function isValid()
   {
      $parentIsValid = parent::isValid();
      
      return $parentIsValid;
   } 
   
   
   
    
   public function getDefaultParameter()
   {
      return $this->gDefaultParameter;
   } 
   
   
   
    
   public function toString()
   {
      if ( $this->gParameters == NULL && $this->gBrowserAgent == NULL ) {
         return "   <selector name='{$this->gType}' src='{$this->gSrc}' package='{$this->gPackageName}'/>\n";
      }
      $mess = "   <selector name='{$this->gType}' src='{$this->gSrc}' package='{$this->gPackageName}'>\n";
      if ( $this->gParameters != NULL ) {
         while ( list( $name, $value ) = each( $this->gParameters ) ) {
            $mess .= "    <parameter name='$name' value='$value'/>\n";
         }
         reset( $this->gParameters );
      }
      if ( $this->gDefaultParameter != NULL ) {
         $mess .= "    <parameter-name>" . $this->gDefaultParameter . "</parameter-name>\n";
      }
      $mess .= "   </selector>\n";
      return $mess;
   }
}
?>
