<?php
class Parameter {
   
   private $gParameterList;
   
   
   
   
    
   public function __construct()
   {
       $this->gParameterList = array();
  }
   
   
   
   public function getParameterList()
   {
      return $this->gParameterList;
   }
   
   
   
   public function getParameter( $inName )
   {
      if ( array_key_exists( $inName, $this->gParameterList ) ) {
         return $this->gParameterList[ $inName ];
      }
      return NULL;
   }
   
   
   public function setParameter( $inName, $inValue )
   {
      $this->gParameterList[ $inName ] = $inValue;
      $paramsModule = Environment::$modules[ "params" ];
      $paramsModule->add( $inName, $inValue );
   }
   
   
   public function parse( $inString, $inClear = false )
   {
      if ( $inClear ) {
         $this->gParameterList = array();
      }
      $valuesArray = explode( ',', $inString );
      foreach( $valuesArray as $pair ) {
         preg_match( "/\"([^\"]+)\"\=\>\"([^\"]+)\"/", $pair, $match );
         $name = $match[1];
         $value = $match[2];
         if ( strlen( $name ) > 0 ) {
            $this->gParameterList[ $name ] = $value;
            $paramsModule = Environment::$modules[ "params" ];
            $paramsModule->add( $name, $value );
         }
      }
   }
   
   
   
   public function toArrayString()
   {
      $mess = "";
      foreach ( $this->gParameterList as $name => $value ) {
         $mess .= "\"$name\"=>\"$value\",";
      }
      return $mess;
   }
   
   
   
   
   public function getHash()
   {
      return md5( $this->toArrayString() );
   }
   
   
   
   
   public function toString()
   {
      $mess = "";
      foreach ( $this->gParameterList as $name => $value ) {
         $mess .= "<parameter name='{$name}' value='{$value}'/>\n";
      }
      return $mess;
   }
}
?>
