<?php

/*
-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

   Date                   Who    Changes
   ==========================================================================

   23rd December 2006     HSFR   Created
  
   LICENSE:
   
   This software is free software; you can redistribute it
   and/or modify it under the terms of the GNU Lesser General
   Public License as published by the Free Software Foundation;
   either version 2.1 of the License, or (at your option) any
   later version.
   
   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this software; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

*/

require_once( PALOOSE_LIB_DIRECTORY . "/flows/Continuations.php" );

// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
/**
 *
 */
 
class DeleteUser extends Continuations {

   /** Logger instance for this class */
   private $gLogger;

   /** The data model for the form. Do not use any id starting with "__".
       these are reserved for Paloose. Do not have "." within the field names
       they get changed when the form is sent via POST. */
   private $gAddFormModel = array(
      "username" => "",  // Must be the same as the query string
   );

   // -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   // -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   /**
    * Make a new instance of the continuation.
    * 
    * @throws RunException if there is no current session in progress.
    */
    
   function __construct()
   {
 		$this->gLogger = Logger::getLogger( __CLASS__ );
    	parent::__construct( $this->gAddFormModel );
   }

   // -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   // -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   /**
    */
    
   function delete()
   {
     	global $gModules;

 		$this->gLogger->debug( "Delete user, continuation: " . $this->gContinuation );
      $this->gViolations = array();

      $finished = false;
      while ( !$finished ) {
         $errors = false;
    		switch ( $this->gContinuation ) {
    		
    		   case 0 : 
    		      $this->sendPage(
    		         "deleteUser-1.html",         // The page to send to the client
    		         $this->gAddFormModel,        // The current data model to send
    		         ++$this->gContinuation,      // The continuation link for the next stage
    		         $this->gViolations );        // Array of errors (keyed by data model keys)
    		      $finished = true;
    		      break;
   
            case 1 :
               // User confirmed so write into admin user's file etc
               $this->sendPage(
                  "deleteUser-2.html",
                  $this->gAddFormModel,
                  ++$this->gContinuation,
                  $this->gViolations );
       	      $finished = true;
    		      break;
         }
      }
   }

   //-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* 
   //-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* 
   /**
    * Get the parameters as an array.
    *
	 * @return string value of variable or NULL is not exist.
    */
    
	public function toString()
	{
	   $mess = "";
	   foreach ( $this->gAddFormModel as $name => $value ) {
	      $mess .= $name . " : " . $value . "\n";
	   }
	   return $mess;
	}	

}
?>