<?xml version="1.0" encoding="UTF-8" ?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--

	Build authenticate DOM

	 Author:
		Name  : Hugh Field-Richards
		Email : hsfr@hsfr.org.uk

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

   Version   Date                   Who    Changes
   ==========================================================================

   0.0.0     19th December 2006     HSFR   Created

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- Copyright -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

	This software is published under the terms of the LGPL License
	a copy of which has been included with this distribution in the LICENSE file.
	
-->

<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   version="1.0">

   <xsl:variable name="gPassword" select="//authentication/@password" /> <!-- encrypted -->
   <xsl:variable name="gUsername" select="//authentication/@username" />

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->

   <xsl:template match="authentication">
      <authentication>
         <xsl:apply-templates select="users"/>
      </authentication>
   </xsl:template>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->

   <xsl:template match="users">
      <xsl:apply-templates select="user"/>
   </xsl:template>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->

   <xsl:template match="user">
      <xsl:if test="normalize-space( username ) = $gUsername and normalize-space( password ) = $gPassword">
         <ID><xsl:value-of select="username"/></ID>
         <data>
            <ID><xsl:value-of select="username"/></ID>
            <username><xsl:value-of select="username"/></username>
            <password><xsl:value-of select="password"/></password>
            <roles><xsl:value-of select="data/roles"/></roles>
            <fullname><xsl:value-of select="data/fullname"/></fullname>
            <xsl:if test="data/telephone">
               <telephone><xsl:value-of select="data/telephone"/></telephone>
            </xsl:if>
            <xsl:if test="data/email">
               <email><xsl:value-of select="data/email"/></email>
            </xsl:if>
            <xsl:if test="data/address">
               <address>
                  <xsl:for-each select="data/address/IntAddressLine">
                     <xsl:if test="not ( . = '' )">
                        <IntAddressLine><xsl:value-of select="."/></IntAddressLine>
                     </xsl:if>
                  </xsl:for-each>
                  <xsl:if test="data/address/Country">
                     <Country><xsl:value-of select="data/address/Country"/></Country>
                  </xsl:if>
                  <xsl:if test="data/address/InternationalPostCode">
                     <InternationalPostCode><xsl:value-of select="data/address/InternationalPostCode"/></InternationalPostCode>
                  </xsl:if>
               </address>
            </xsl:if>
         </data>
      </xsl:if>
   </xsl:template>

</xsl:stylesheet>



