<?xml version="1.0" encoding="UTF-8" ?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--
   
   Delete User
   
   Author:
      Name  : Hugh Field-Richards
      Email : hsfr@hsfr.org.uk
   
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   
   Version   Date                   Who    Changes
   ==========================================================================
   
   0.0.0     6th March 2007         HSFR   Created
   
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- Copyright -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   
   This software is published under the terms of the LGPL License
   a copy of which has been included with this distribution in the LICENSE file.
   
-->

<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   
   xmlns:xi="http://www.w3.org/2001/XInclude"
   xmlns:i18n="http://apache.org/cocoon/i18n/2.1"
   xmlns:t="http://www.hsfr.org.uk/Schema/Text"
   xmlns:page="http://www.hsfr.org.uk/Schema/Page"
   xmlns:list="http://www.hsfr.org.uk/Schema/List"
   xmlns:link="http://www.hsfr.org.uk/Schema/Link"
   xmlns:graphic="http://www.hsfr.org.uk/Schema/Graphic"
   xmlns:paloose="http://www.paloose.org/schemas/Paloose/1.0"
   xmlns:source="http://apache.org/cocoon/source/1.0"
   xmlns:pf="http://www.paloose.org/schemas/Forms/1.0"
   version="1.0" >
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      parameters from sitemap
   -->
   
   <xsl:param name="sessionUser"/>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Global variables
   -->
   
   <xsl:variable name="gCurrentUser" select="$sessionUser" />
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="/">
      <xsl:apply-templates/>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="deleteUser" >
      <xsl:apply-templates select="document( @list )" mode="processUsers" />
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="/" mode="processUsers">
      <xsl:element name="div">
         <xsl:attribute name="class">userList</xsl:attribute>
         <xsl:apply-templates select="//users/*" mode="processUsers" >
            <xsl:sort select="username"/>
         </xsl:apply-templates>
      </xsl:element>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="user" mode="processUsers">
      <xsl:element name="div">
         <xsl:attribute name="class">entry</xsl:attribute>
         <xsl:element name="div">
            <xsl:attribute name="class">listHeader</xsl:attribute>
            <xsl:value-of select="username"/>&#160;
            <xsl:if test="data/fullname">(<xsl:value-of select="data/fullname"/>)</xsl:if>
            <xsl:if test="$gCurrentUser = username"> &#x2014; current user</xsl:if>
         </xsl:element>
         
         <xsl:element name="div">
            <xsl:attribute name="class">details</xsl:attribute>
            <xsl:element name="table">
               <xsl:attribute name="border">0</xsl:attribute>
               <xsl:if test="data/email">
                  <xsl:element name="tr"> <!-- roles -->
                     <xsl:attribute name="valign">top</xsl:attribute>
                     <xsl:element name="td">
                        <xsl:attribute name="class">itemHeader</xsl:attribute>
                        <xsl:text>EMAIL:</xsl:text>
                     </xsl:element> <!-- td -->
                     <xsl:element name="td">
                        <xsl:attribute name="class">itemData</xsl:attribute>
                        <xsl:element name="a">
                           <xsl:attribute name="href">mailto:<xsl:value-of select="data/email"/></xsl:attribute>
                           <xsl:value-of select="data/email"/>
                        </xsl:element> <!-- a -->
                     </xsl:element> <!-- td -->
                  </xsl:element> <!-- tr -->
               </xsl:if>
               <xsl:if test="data/address">
                  <xsl:element name="tr"> <!-- roles -->
                     <xsl:attribute name="valign">top</xsl:attribute>
                     <xsl:element name="td">
                        <xsl:attribute name="class">itemHeader</xsl:attribute>
                        <xsl:text>Address:</xsl:text>
                     </xsl:element> <!-- td -->
                     <xsl:element name="td">
                        <xsl:attribute name="class">itemData</xsl:attribute>
                        <xsl:call-template name="outputAddress">
                           <xsl:with-param name="node" select="data/address"/>
                        </xsl:call-template>
                     </xsl:element> <!-- td -->
                  </xsl:element> <!-- tr -->
               </xsl:if>
               <xsl:element name="tr"> <!-- roles -->
                  <xsl:attribute name="valign">top</xsl:attribute>
                  <xsl:element name="td">
                     <xsl:attribute name="class">itemHeader</xsl:attribute>
                     <xsl:text>Roles:</xsl:text>
                  </xsl:element> <!-- td -->
                  <xsl:element name="td">
                     <xsl:attribute name="class">itemData</xsl:attribute>
                     <xsl:call-template name="outputRoles">
                        <xsl:with-param name="node" select="data/roles"/>
                     </xsl:call-template>
                  </xsl:element> <!-- td -->
               </xsl:element> <!-- tr -->
            </xsl:element> <!-- table -->
            <xsl:element name="div">
               <xsl:attribute name="class">controls</xsl:attribute>
               <xsl:call-template name="outputControls"/>
            </xsl:element> <!-- div : controls -->
         </xsl:element> <!-- div : details -->
      </xsl:element> <!-- div : entry -->
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- Replace with graphic buttons? -->
   
   <xsl:template name="outputControls">
      <xsl:element name="a">
         <xsl:attribute name="href">
            <xsl:value-of select="concat( 'editUser.html?user=', username )" />
         </xsl:attribute>
         [edit]</xsl:element>
      <!-- Do not allow deletion of own user -->
      <xsl:if test="not( $gCurrentUser = username )">
         <xsl:element name="a">
            <xsl:attribute name="href">
               <xsl:value-of select="concat( 'deleteUser.html?user=', username )" />
            </xsl:attribute>
            [delete]</xsl:element>
      </xsl:if>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Display the user's address
   -->
   
   <xsl:template name="outputAddress">
      <xsl:param name="node"/>
      <xsl:if test="$node/line-1"><xsl:value-of select="$node/line-1"/><xsl:element name="br"/></xsl:if>
      <xsl:if test="$node/line-2"><xsl:value-of select="$node/line-2"/><xsl:element name="br"/></xsl:if>
      <xsl:if test="$node/postcode"><xsl:value-of select="$node/postcode"/><xsl:element name="br"/></xsl:if>
      <xsl:if test="$node/country"><xsl:value-of select="$node/country"/></xsl:if>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Display what the displayed user can do
   -->
   
   <xsl:template name="outputRoles">
      <xsl:param name="node"/>
      <xsl:call-template name="outputRole">
         <xsl:with-param name="list" select="$node"/>
      </xsl:call-template>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template name="outputRole">
      <xsl:param name="list"/>
      <xsl:variable name="nlist">
         <xsl:choose>
            <xsl:when test="contains( $list, ',' )">
               <xsl:value-of select="$list"/>
            </xsl:when>
            <xsl:otherwise>
               <xsl:value-of select="concat( $list, ',' )"/>
            </xsl:otherwise>
         </xsl:choose>
      </xsl:variable>
      <xsl:variable name="first" select="substring-before( $nlist, ',' )" />
      <xsl:variable name="rest" select="substring-after( $nlist, ',' )" />
      <xsl:choose>
         <xsl:when test="$first='displayUsers'">
            <xsl:text>Display users</xsl:text>
            <xsl:element name="br"/>
         </xsl:when>
         <xsl:when test="$first='manageUsers'">
            <xsl:text>Manage users</xsl:text>
            <xsl:element name="br"/>
         </xsl:when>
         <xsl:when test="$first='editPage'">
            <xsl:text>Edit pages</xsl:text>
            <xsl:element name="br"/>
         </xsl:when>
      </xsl:choose>
      <xsl:if test="$rest">
         <xsl:call-template name="outputRole">
            <xsl:with-param name="list" select="$rest"/>
         </xsl:call-template>
      </xsl:if>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Copy everything else if not eaten by the above
   -->
   
   <xsl:template match="@*|node()">
      <xsl:copy>
         <xsl:apply-templates select="@*|node()" />
      </xsl:copy>
   </xsl:template>
   
</xsl:stylesheet>
