<?xml version="1.0"?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--

	Page to HTML Transform

	 Author:
		Name  : Hugh Field-Richards
		Email : hsfr@hsfr.org.uk

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

   Version   Date                   Who    Changes
   ==========================================================================

   0.0.0     15th May 2006          HSFR   Created

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- Copyright -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

	This software is published under the terms of the LGPL License
	a copy of which has been included with this distribution in the LICENSE file.
	
-->

<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:graphic="http://www.hsfr.org.uk/Schema/Graphic"
   xmlns:list="http://www.hsfr.org.uk/Schema/List"
   xmlns:link="http://www.hsfr.org.uk/Schema/Link"
   xmlns:text="http://www.hsfr.org.uk/Schema/Text"
   xmlns:news="http://www.hsfr.org.uk/Schema/News"
   xmlns:page="http://www.hsfr.org.uk/Schema/Page"
   xmlns:email="http://www.hsfr.org.uk/Schema/Email"
   version="1.0">

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Parameters brought in from sitemap
   -->

   <xsl:param name="page"/>
   <xsl:param name="config"/>
   <xsl:param name="locale"/>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Global variables
   -->

   <xsl:variable name="gPage" select="$page"/>
   <xsl:variable name="gConfigFile" select="$config"/>
   <xsl:variable name="gLanguage">
      <xsl:choose>
         <xsl:when test="string-length( $locale ) > 0">
            <xsl:value-of select="$locale"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:text>en</xsl:text>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->

   <xsl:template match="/">
      <xsl:element name="html">
         <xsl:attribute name="lang">
            <xsl:value-of select="$gLanguage"/>
         </xsl:attribute>
         <xsl:attribute name="xml:lang">
            <xsl:value-of select="$gLanguage"/>
         </xsl:attribute>
         <xsl:element name="head">
            <xsl:element name="meta">
               <xsl:attribute name="name">bxeNS</xsl:attribute>
               <xsl:attribute name="content">xhtml=http://www.w3.org/1999/xhtml</xsl:attribute>
            </xsl:element>
            <xsl:element name="meta">
               <xsl:attribute name="name">bxeNS</xsl:attribute>
               <xsl:attribute name="content">lenya=http://apache.org/cocoon/lenya/page-envelope/1.0</xsl:attribute>
            </xsl:element>
            <xsl:element name="meta">
               <xsl:attribute name="name">bxeNS</xsl:attribute>
               <xsl:attribute name="content">dc=http://purl.org/dc/elements/1.1/</xsl:attribute>
            </xsl:element>
            <xsl:element name="meta">
               <xsl:attribute name="name">bxeNS</xsl:attribute>
               <xsl:attribute name="content">unzih=http://unizh.ch/doctypes/elements/1.0</xsl:attribute>
            </xsl:element>
            <xsl:element name="meta">
               <xsl:attribute name="name">bxeNS</xsl:attribute>
               <xsl:attribute name="content">dcterms=http://purl.org/dc/terms/</xsl:attribute>
            </xsl:element>
            <xsl:element name="meta">
               <xsl:attribute name="http-equiv">content-type</xsl:attribute>
               <xsl:attribute name="content">text/html; charset=UTF-8</xsl:attribute>
            </xsl:element>
            <xsl:element name="link">
               <xsl:attribute name="rel">stylesheet</xsl:attribute>
               <xsl:attribute name="href">/pp/resources/styles/editor.css</xsl:attribute>
               <xsl:attribute name="type">text/css</xsl:attribute>
            </xsl:element>
            <xsl:element name="script">
               <xsl:attribute name="src">/bxe_paloose/bxeLoader.js</xsl:attribute>
               <xsl:attribute name="type">text/javascript</xsl:attribute>
            </xsl:element>
            <xsl:element name="title">
               <xsl:value-of select="concat( 'Editing ', $page )"/>
            </xsl:element>
         </xsl:element>

         <xsl:element name="body">
            <xsl:attribute name="onload">
               <xsl:text>bxe_start( '</xsl:text>
               <xsl:value-of select="$gConfigFile"/>
               <xsl:text>' )</xsl:text>
            </xsl:attribute>
            <xsl:element name="div">
               <xsl:attribute name="id">bxe_area</xsl:attribute>
               <xsl:element name="noscript">
                  <xsl:element name="span">
                     <xsl:attribute name="style">font-family: Arial; padding: 5px; background-color: #ffffff</xsl:attribute>
                     <xsl:text>You need JavaScript enabled. Otherwise nothing at all works here :)</xsl:text>
                  </xsl:element>
               </xsl:element>
            </xsl:element>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- 
		Soak up any remaining elements not processed by the above
	-->

   <xsl:template match="node()|@*" priority="-1">
      <xsl:copy>
			<xsl:apply-templates select="@*"/>
			<xsl:apply-templates/>
      </xsl:copy>
   </xsl:template>

</xsl:stylesheet>
