<?xml version="1.0" encoding="UTF-8" ?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--
   
   Extract the user from the user list. Makes sure extraneous users do not get
   passed through to later transformers.
   
   Author:
      Name  : Hugh Field-Richards
      Email : hsfr@hsfr.org.uk
   
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   
   Version   Date                   Who    Changes
   ==========================================================================
   
   0.0.0     15th March 2007        HSFR   Created
   
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- Copyright -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   
   This software is published under the terms of the LGPL License
   a copy of which has been included with this distribution in the LICENSE file.
   
-->

<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   
   xmlns:xi="http://www.w3.org/2001/XInclude"
   xmlns:i18n="http://apache.org/cocoon/i18n/2.1"
   xmlns:t="http://www.hsfr.org.uk/Schema/Text"
   xmlns:page="http://www.hsfr.org.uk/Schema/Page"
   xmlns:list="http://www.hsfr.org.uk/Schema/List"
   xmlns:link="http://www.hsfr.org.uk/Schema/Link"
   xmlns:graphic="http://www.hsfr.org.uk/Schema/Graphic"
   xmlns:paloose="http://www.paloose.org/schemas/Paloose/1.0"
   xmlns:source="http://apache.org/cocoon/source/1.0"
   xmlns:pf="http://www.paloose.org/schemas/Forms/1.0"
   version="1.0" >
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      parameters from sitemap
   -->
   
   <xsl:param name="sessionUser"/>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Global variables
   -->
   
   <xsl:variable name="gCurrentUser" select="$sessionUser" />
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- 
      
      Typical XML In
      ==========================================================================
      <authentication>
         <users>
            <user>
               <username>hsfr</username>
               <password>9f7f32c605xxxxxxxxxx4225613d30b</password>
               <data>
                  <roles>editDoc,manageUsers,displayUsers</roles>
                  <fullname>Hugh Field-Richards</fullname>
                  <email>hsfr@hsfr.org.uk</email>
               </data>
               </user>
            <user>
               <username>xxx</username>
               <password>7c51ba3xxxxxxxxxxxbed2ccafd2</password>
               <data>
                  <roles>editPage,displayUsers</roles>
                  <fullname>xxxx xxxxx</fullname>
                  <email>xxxxx@xxxxx.xxx.xx</email>
               </data>
            </user>
         </users>
      </authentication>
      ==========================================================================
      
      Typical XML Out
      ==========================================================================
      <users>
         <user>
            <username>hsfr</username>
            <password>9f7f32c605xxxxxxxxxx4225613d30b</password>
            <data>
               <roles>editDoc,manageUsers,displayUsers</roles>
               <fullname>Hugh Field-Richards</fullname>
               <email>hsfr@hsfr.org.uk</email>
            </data>
         </user>
      </users>
      ==========================================================================
   -->

   <xsl:template match="/">
      <xsl:apply-templates/>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="//authentication/users">
      <xsl:element name="users">
         <xsl:apply-templates select="user[ username = $gCurrentUser ]"/>
      </xsl:element>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Copy everything else if not eaten by the above
   -->
   
   <xsl:template match="@*|node()">
      <xsl:copy>
         <xsl:apply-templates select="@*|node()" />
      </xsl:copy>
   </xsl:template>
   
</xsl:stylesheet>
