<?xml version="1.0" encoding="UTF-8" ?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--
	
	Assemble data into the catalogue page
	
	Author:
	Name  : Hugh Field-Richards
	Email : hsfr@hsfr.org.uk
	
	-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
	-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
	
	Version   Date                   Who    Changes
	==========================================================================
	
	0.0.0    23rd March 2006        HSFR   PayPal cart cosmetics
	
	-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- Copyright -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
	
	All copyright, database rights and other intellectual property in this
	software is the property of Hugh Field-Richards. The software is being
	released free of charge for use in accordance with the terms of open
	source initiative GNU General Public Licence.
	
	-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* Disclaimer -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
	
	Hugh Field-Richards does not verify or warrant the accuracy,  completeness or
	suitability of this software for any particular purpose. Any use of this
	software whatsoever is entirely at the user's own risk and Hugh Field-Richards
	accepts no liability in relation thereto.
	
-->

<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   version="1.0">

   <xsl:param name="password"/>
   <xsl:param name="username"/>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
<!--
   Typical XML In
   ==========================================================================
      <authentication>
         ...
      </authenticate>
   ==========================================================================

   Typical XML Out
   ==========================================================================
      <authentication username="hsfr" password="******">
         ...
      </authenticate>
   ==========================================================================
-->

   <xsl:template match="//authentication">
      <xsl:element name="authentication" >
         <xsl:attribute name="username"><xsl:value-of select="$username" /></xsl:attribute>
         <xsl:attribute name="password"><xsl:value-of select="$password" /></xsl:attribute>
         <xsl:apply-templates mode="pass"/>
      </xsl:element>
   </xsl:template>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- Pass through any that aren't eaten by the normal inline stuff -->

   <xsl:template match="@*|node()" mode="pass">
      <xsl:copy>
         <xsl:apply-templates select="@*|node()" mode="pass" />
      </xsl:copy>
   </xsl:template>

</xsl:stylesheet>



