<?xml version="1.0" encoding="UTF-8" ?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--
   
   Get user
   
   Author:
      Name  : Hugh Field-Richards
      Email : hsfr@hsfr.org.uk
   
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   
   Version   Date                   Who    Changes
   ==========================================================================
   
   0.0.0     4th March 2007         HSFR   Created
   
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- Copyright -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   
   This software is published under the terms of the LGPL License
   a copy of which has been included with this distribution in the LICENSE file.
   
-->

<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:dyn="http://exslt.org/dynamic"
   
   xmlns:xi="http://www.w3.org/2001/XInclude"
   xmlns:i18n="http://apache.org/cocoon/i18n/2.1"
   xmlns:t="http://www.hsfr.org.uk/Schema/Text"
   xmlns:page="http://www.hsfr.org.uk/Schema/Page"
   xmlns:list="http://www.hsfr.org.uk/Schema/List"
   xmlns:link="http://www.hsfr.org.uk/Schema/Link"
   xmlns:graphic="http://www.hsfr.org.uk/Schema/Graphic"
   xmlns:paloose="http://www.paloose.org/schemas/Paloose/1.0"
   xmlns:source="http://apache.org/cocoon/source/1.0"
   xmlns:pf="http://www.paloose.org/schemas/Forms/1.0"
   version="1.0" >
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      parameters from sitemap
   -->
   
   <xsl:param name="username"/>
   <xsl:param name="sessionUser"/>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Global variables
   -->
   
   <xsl:variable name="gDeleteUser" select="$username" />
   <xsl:variable name="gCurrentUser" select="$sessionUser" />
   <xsl:variable name="gListFile" select="//getUser/@list" />
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="/">
      <xsl:apply-templates/>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- 
      Typical XML In
      ==========================================================================
         <getUser list="filename">
         
            <pf:output ref="username">
               <pf:label>Username:</pf:label>
            </pf:output>
            
            <pf:output ref="fullname">
               <pf:label>Full name:</pf:label>
            </pf:output>
            
            <pf:output ref="email">
               <pf:label>EMAIL:</pf:label>
            </pf:output>
            
            <pf:group ref="address">
               <pf:label>Address</pf:label>
               <pf:output ref="address-line_1">
                  <pf:label>Line 1</pf:label>
               </pf:output>
               <pf:output ref="address-line_2">
                  <pf:label>Line 2</pf:label>
               </pf:output>
               <pf:output ref="address-postcode">
                  <pf:label>Postcode</pf:label>
               </pf:output>
            </pf:group>
         
         </getUser>
      ==========================================================================
      
   
   -->
   
   <xsl:template match="getUser">
      <xsl:apply-templates mode="processUser"/>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="pf:value" mode="processUser">
      <xsl:element name="pf:value">
         <xsl:variable name="ref" select="@ref"/>
         <xsl:variable name="xPathExpr">
            <xsl:value-of select="concat( 'document( &quot;', $gListFile, '&quot;)//*[username = &quot;', $gDeleteUser, '&quot; ]//', $ref )"/>
         </xsl:variable>
         <xsl:choose>
            <xsl:when test="@ref"><xsl:value-of select="dyn:evaluate( $xPathExpr )"/></xsl:when>
            <xsl:otherwise><xsl:value-of select="."/></xsl:otherwise>
         </xsl:choose>
      </xsl:element>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="@*|node()" mode="processUser">
      <xsl:copy>
         <xsl:apply-templates select="@*|node()"  mode="processUser"/>
      </xsl:copy>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Copy everything else not eaten by the above
   -->
   
   <xsl:template match="@*|node()">
      <xsl:copy>
         <xsl:apply-templates select="@*|node()" />
      </xsl:copy>
   </xsl:template>
   
</xsl:stylesheet>
