<?xml version="1.0" encoding="UTF-8" ?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--
   
   Build authenticate DOM
   
   Author:
   Name  : Hugh Field-Richards
   Email : hsfr@hsfr.org.uk
   
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   
   Version   Date                   Who    Changes
   ==========================================================================
   
   0.0.0     6th March 2007         HSFR   Created
   
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- Copyright -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   
   This software is published under the terms of the LGPL License
   a copy of which has been included with this distribution in the LICENSE file.
   
-->

<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   
   xmlns:xi="http://www.w3.org/2001/XInclude"
   xmlns:i18n="http://apache.org/cocoon/i18n/2.1"
   xmlns:t="http://www.hsfr.org.uk/Schema/Text"
   xmlns:page="http://www.hsfr.org.uk/Schema/Page"
   xmlns:list="http://www.hsfr.org.uk/Schema/List"
   xmlns:link="http://www.hsfr.org.uk/Schema/Link"
   xmlns:graphic="http://www.hsfr.org.uk/Schema/Graphic"
   xmlns:paloose="http://www.paloose.org/schemas/Paloose/1.0"
   xmlns:source="http://apache.org/cocoon/source/1.0"
   xmlns:pf="http://www.paloose.org/schemas/Forms/1.0"
   version="1.0" >
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Parameters brought in from sitemap
   -->
   
   <xsl:param name="sessionUser"/>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Global variables
   -->
   
   <xsl:variable name="gRoles" select="//user[ child::username = $sessionUser ]//roles" />
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="/">
      <xsl:apply-templates />
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="/root/users" >
      <!-- Swallow the users -->
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Copy all and apply templates providing they have the correct 
      label
   -->
   
   <xsl:template match="@*|node()">
      <xsl:choose>
         <xsl:when test="not( @label )">
            <!-- no label so output immediately -->
            <xsl:copy>
               <xsl:apply-templates select="@*|node()"/>
            </xsl:copy>
         </xsl:when>
         <xsl:otherwise>
            <xsl:variable name="foundRole">
               <xsl:call-template name="wholeWordContains">
                  <xsl:with-param name="inList" select="$gRoles"/>
                  <xsl:with-param name="inValue" select="@label"/>
               </xsl:call-template>
            </xsl:variable>
            <xsl:if test="string-length( $foundRole ) > 0">
               <xsl:copy>
                  <xsl:apply-templates select="@*|node()"/>
               </xsl:copy>
            </xsl:if>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- 
      This rather horrid affair checks to see whether a token appears in a comma separated
      list as a complete entry, not part entry... ah, the joys of recursion.
   -->
   
   <xsl:template name="wholeWordContains">
      <xsl:param name="inList"/>
      <xsl:param name="inValue"/>
      <xsl:choose>
         <xsl:when test="contains( $inList, ',' )">
            <!-- A list not a single value -->
            <xsl:variable name="token" select="substring-before( $inList, ',')"/>
            <xsl:variable name="remainder" select="substring-after( $inList, ',')"/>
            <xsl:choose>
               <xsl:when test="$token = $inValue">
                  <!-- Found something so return value -->
                  <xsl:value-of select="$token"/>
               </xsl:when>
               <xsl:otherwise>
                  <!-- Nothing found so go down a level in he recursion -->
                  <xsl:call-template name="wholeWordContains">
                     <xsl:with-param name="inList" select="$remainder"/>
                     <xsl:with-param name="inValue" select="$inValue"/>
                  </xsl:call-template>
               </xsl:otherwise>
            </xsl:choose>
         </xsl:when>
         <xsl:otherwise>
            <!-- End of trawl through list, so check final token in list -->
            <xsl:if test="$inList = $inValue">
               <xsl:value-of select="$inValue"/>
            </xsl:if>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>
   
</xsl:stylesheet>



