<?xml version="1.0"?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--
   
   Build the menu panel
   
   Author:
      Name  : Hugh Field-Richards
      Email : hsfr@hsfr.org.uk
   
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- Copyright -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   
   All copyright, database rights and other intellectual property in this
   software is the property of Hugh Field-Richards. The software is being
   released free of charge for use in accordance with the terms of open
   source initiative GNU General Public Licence.
   
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* Disclaimer -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   
   Hugh Field-Richards does not verify or warrant the accuracy, completeness or
   suitability of this software for any particular purpose. Any use of this
   software whatsoever is entirely at the user's own risk and Hugh Field-Richards
   accepts no liability in relation thereto.
   
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:graphic="http://www.hsfr.org.uk/Schema/Graphic"
   xmlns:list="http://www.hsfr.org.uk/Schema/List" xmlns:link="http://www.hsfr.org.uk/Schema/Link"
   xmlns:text="http://www.hsfr.org.uk/Schema/Text" xmlns:news="http://www.hsfr.org.uk/Schema/News"
   xmlns:page="http://www.hsfr.org.uk/Schema/Page" xmlns:paloose="http://www.paloose.org/schemas/Paloose/1.0" version="1.0">

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- 
      The list arrives here in the following format:
      
        <list:list type="ordered" id="nav-menu">
         <list:item>
            <link:link ref="/pp/index.html" type="ref">Home</link:link>
         </list:item>
         <list:item>
            <link:link ref="/pp/documentation/introduction.html" type="ref">Introduction</link:link>
         </list:item>
         <list:item>
            <link:link ref="/pp/news.html" type="ref">News</link:link>
         </list:item>
         <list:item>
            <link:link ref="/pp/faq.html" type="ref">FAQ</link:link>
         </list:item>
         <list:item>
            <link:link ref="/pp/documentation/documentation.html" type="ref">Documentation</link:link>
            <list:list type="ordered">
               <list:item>
                  <link:link ref="/pp/documentation/install.html">Install</link:link>
               </list:item>
               <list:item>
                  <link:link ref="/pp/documentation/configure.html">Configuring</link:link>
                  <list:list>
                     <list:item>
                        <link:link ref="/pp/documentation/configure-server.html">Server</link:link>
                     </list:item>
                     <list:item>
                        <link:link ref="/pp/documentation/configure-htaccess.html">.htaccess file</link:link>
                     </list:item>
                     <list:item>
                        <link:link ref="/pp/documentation/configure-client.html">Client</link:link>
                     </list:item>
                  </list:list>
               </list:item>
               <list:item>
                  <link:link ref="/pp/documentation/sitemap.html">Sitemap</link:link>
               </list:item>
               ...
               
      </list:list>
   -->

   <xsl:template name="buildMenusPanel.menusPanel">
      <xsl:element name="div">
         <xsl:attribute name="id">menu</xsl:attribute>
         <xsl:element name="nav">
            <xsl:apply-templates select="//menus//list:list[@id = 'nav-menu']" mode="menus"/>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- 
      Top level menu items
   -->

   <xsl:template match="//menus//list:list[@id = 'nav-menu']" mode="menus">
      <xsl:element name="ul">
         <xsl:attribute name="class">dropdown</xsl:attribute>
         <xsl:apply-templates mode="topMenus"/>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->

   <xsl:template match="list:item" mode="topMenus">
      <xsl:element name="li">
         <xsl:apply-templates mode="topMenuItem"/>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->

   <xsl:template match="link:link" mode="topMenuItem">
      <xsl:element name="a">
         <xsl:attribute name="href">
            <xsl:value-of select="@ref"/>
         </xsl:attribute>
         <xsl:attribute name="class">hide</xsl:attribute>
         <xsl:value-of select="."/>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      sub menu
   -->
   
   <xsl:template match="list:list" mode="topMenuItem">
      <xsl:element name="ul">
         <xsl:attribute name="class">subMenuType</xsl:attribute>
         <xsl:apply-templates mode="subMenus"/>
      </xsl:element>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="list:item" mode="subMenus">
      <xsl:element name="li">
         <xsl:apply-templates mode="subMenusItem"/>
      </xsl:element>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="link:link" mode="subMenusItem">
      <xsl:element name="a">
         <xsl:attribute name="href">
            <xsl:value-of select="@ref"/>
         </xsl:attribute>
         <xsl:value-of select="."/>
     </xsl:element>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      subsub menu
   -->
   
   <xsl:template match="list:list" mode="subMenusItem">
      <xsl:element name="ul">
         <xsl:attribute name="class">subsubMenuType</xsl:attribute>
         <xsl:apply-templates mode="subsubMenus"/>
      </xsl:element>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="list:item" mode="subsubMenus">
      <xsl:element name="li">
         <xsl:apply-templates mode="subsubMenusItem"/>
      </xsl:element>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="link:link" mode="subsubMenusItem">
      <xsl:element name="a">
         <xsl:attribute name="href">
            <xsl:value-of select="@ref"/>
         </xsl:attribute>
         <xsl:value-of select="."/>
      </xsl:element>
   </xsl:template>
   
</xsl:stylesheet>
