<?xml version="1.0" encoding="ISO-8859-1" ?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--

	DSD-2 to HTML Pretty Printer

	This XSLT style sheet pretty prints a DSD-2 schema. It has been tested
	on the current Xalan processor and renders to most browsers (Safari, IE, 
	Mozilla, Netscape etc). It was inspire by the DSD-1 pretty printer written
	by Nils Klarlund for the original DSD-1. Note that the DSD documentation
	that is processed is not in HTML but a personal XML format - this could
	be changed if anyone cares to. The actual format is relatively easy to
	understand if you look at this file and some of my DSD schemas.

	Author:
		Name  : Hugh Field-Richards.
		Email : hsfr@hsfr.org.uk
	
    LICENSE:
    
    This software is free software; you can redistribute it
    and/or modify it under the terms of the GNU Lesser General
    Public License as published by the Free Software Foundation;
    either version 2.1 of the License, or (at your option) any
    later version.
    
    This software is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.
    
    You should have received a copy of the GNU Lesser General Public
    License along with this software; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:dsd="http://www.brics.dk/DSD/2.0"
    xmlns:xi="http://www.w3.org/2001/XInclude" xmlns:m="http://www.brics.dk/DSD/2.0/meta"
    xmlns:doc="http://www.paloose.org/schemas/DSD/DSDs/doc" xmlns:xhtml="http://www.w3.org/1999/xhtml"
    xmlns:a="http://relaxng.org/ns/annotation/1.0" xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:map="http://apache.org/cocoon/sitemap/1.0" version="1.0">

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- 3.2 DECLARATIONS *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!--
		DECLARATION  ::=  ATTRIBUTEDECL
								| <required> ATTRIBUTEDECL* </required>
								| <contents> ( REGEXP  |  NORMALIZE  |  CONTENTSDEFAULT )* </contents>
     -->

    <xsl:template name="declare-rule">
        <xsl:call-template name="render-declare-name"/>

        <xsl:for-each select="*">
            <xsl:choose>
                <xsl:when test="local-name(.) = 'contents'">
                    <xsl:call-template name="contents-decl"/>
                </xsl:when>
                <xsl:when test="local-name(.) = 'attribute'">
                    <xsl:call-template name="attribute-decl"/>
                </xsl:when>
                <xsl:when test="local-name(.) = 'required'">
                    <xsl:call-template name="required-decl"/>
                </xsl:when>
            </xsl:choose>
        </xsl:for-each>
   </xsl:template>

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

    <xsl:template name="contents-decl">

        <xsl:element name="div">
            <xsl:attribute name="class">indentedBlock</xsl:attribute>

            <xsl:call-template name="render-declare-name"/>
            <xsl:for-each select="*">
                <xsl:choose>
                    <xsl:when test="
                            local-name() = 'sequence' or
                            local-name() = 'optional' or
                            local-name() = 'complement' or
                            local-name() = 'union' or
                            local-name() = 'intersection' or
                            local-name() = 'minus' or
                            local-name() = 'repeat' or
                            local-name() = 'string' or
                            local-name() = 'char' or
                            local-name() = 'stringtype' or
                            local-name() = 'contenttype' or
                            local-name() = 'and' or
                            local-name() = 'or' or
                            local-name() = 'not' or
                            local-name() = 'imply' or
                            local-name() = 'equiv' or
                            local-name() = 'one' or
                            local-name() = 'parent' or
                            local-name() = 'ancestor' or
                            local-name() = 'child' or
                            local-name() = 'descendant' or
                            local-name() = 'this' or
                            local-name() = 'root' or
                            local-name() = 'element' or
                            local-name() = 'attribute' or
                            local-name() = 'contents' or
                            local-name() = 'boolexp'">
                        <xsl:call-template name="regexp"/>
                    </xsl:when>

                    <xsl:when test="local-name(.) = 'normalize'">
                        <xsl:call-template name="normalize"/>
                    </xsl:when>

                    <xsl:otherwise>
                        <xsl:call-template name="contents-default"/>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:for-each>
        </xsl:element>
    </xsl:template>

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

    <xsl:template name="required-decl">
        <xsl:element name="xhtml:div">
            <xsl:attribute name="class">indentedBlock</xsl:attribute>

            <xsl:call-template name="render-element-name"/>
            <xsl:for-each select="*">
                <xsl:call-template name="attribute-decl"/>
            </xsl:for-each>
        </xsl:element>
    </xsl:template>

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

    <xsl:template name="normalize">
        <xsl:element name="xhtml:div">
            <xsl:attribute name="class">indentedBlock</xsl:attribute>
            <xsl:call-template name="render-element-name"/>
            <xsl:if test="@whitespace"><xsl:value-of select="@whitespace"/>&#160;whitespace</xsl:if>
            <xsl:if test="@case"><xsl:value-of select="@case"/>&#160;case</xsl:if>
        </xsl:element>
    </xsl:template>

    <!--
		CONTENTSDEFAULT ::=  <default> ANYCONTENTS </default>
-->

    <xsl:template name="contents-default">
        <xsl:element name="xhtml:div">
            <xsl:attribute name="class">indentedBlock</xsl:attribute>
            <xsl:call-template name="render-element-name"/>
            <br/>
            <xsl:element name="xhtml:div">
                <xsl:attribute name="class">indentedBlock</xsl:attribute>
                <xsl:for-each select="*">
                    <xsl:choose>
                        <xsl:when test="*">
                            <!-- if there is content -->
                            <xsl:call-template name="render-start-element-and-attrib"/>
                            <xsl:apply-templates mode="xml-content-defaults"/>
                            <xsl:call-template name="render-end-element"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:call-template name="render-empty-element-and-attrib"/>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:for-each>
            </xsl:element>
        </xsl:element>
    </xsl:template>

    <!--
	These templates are to take content defaults which could be any XML tags and content.
	It is impossible to provide the correct indentation here so we output as best we can.
-->

    <xsl:template match="*" mode="xml-content-defaults">
        <xsl:call-template name="render-start-element-and-attrib"/>
        <xsl:apply-templates mode="xml-content-defaults"/>
        <xsl:call-template name="render-end-element"/>
    </xsl:template>

    <xsl:template name="render-start-element-and-attrib"> &lt;<xsl:value-of select="name()"/>
        <xsl:for-each select="@*">&#160;<xsl:value-of select="name()"/>=&quot;<xsl:value-of select="."
        />&quot;</xsl:for-each>&gt; </xsl:template>

    <xsl:template name="render-end-element"> &lt;/<xsl:value-of select="name()"/>&gt; </xsl:template>

    <xsl:template name="render-empty-element-and-attrib"> &lt;<xsl:value-of select="name()"/>
        <xsl:for-each select="@*">&#160;<xsl:value-of select="name()"/>=&quot;<xsl:value-of select="."
        />&quot;</xsl:for-each>/&gt; </xsl:template>

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- ATTRIBUTES *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!--
		ATTRIBUTEDECL  ::=  <attribute name="PNAME"? >
							   ( REGEXP  |  NORMALIZE  |  ATTRIBUTEDEFAULT )*
							</attribute>
-->

    <xsl:template name="attribute-decl">
        <xsl:element name="div">
            <xsl:attribute name="class">indentedBlock</xsl:attribute>

            <xsl:call-template name="render-element-attrib-name">
                <xsl:with-param name="inElementName" select="local-name(.)"/>
                <xsl:with-param name="inAttribName" select="@name"/>
            </xsl:call-template>
            <xsl:call-template name="render-namespace-attrib"/>

            <xsl:for-each select="*">
                <xsl:choose>
                    <xsl:when test="local-name(.) = 'normalize'">
                        <xsl:call-template name="normalize"/>
                    </xsl:when>
                    <xsl:when test="local-name(.) = 'default'">
                        <xsl:call-template name="attribute-default"/>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:call-template name="regexp"/>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:for-each>
        </xsl:element>
    </xsl:template>

    <!--
		ATTRIBUTEDEFAULT  ::=  <default value="VALUE" />
    -->

    <xsl:template name="attribute-default">
        <xsl:element name="xhtml:div">
            <xsl:attribute name="class">indentedBlock</xsl:attribute>
            <xsl:call-template name="render-element-name"/> "<xhtml:span class="chars"><xsl:value-of select="@value"
                /></xhtml:span>" </xsl:element>
    </xsl:template>


</xsl:stylesheet>
