<?xml version="1.0" encoding="ISO-8859-1" ?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--

	DSD-2 to HTML Pretty Printer

	This XSLT style sheet pretty prints a DSD-2 schema. It has been tested
	on the current Xalan processor and renders to most browsers (Safari, IE, 
	Mozilla, Netscape etc). It was inspire by the DSD-1 pretty printer written
	by Nils Klarlund for the original DSD-1. Note that the DSD documentation
	that is processed is not in HTML but a personal XML format - this could
	be changed if anyone cares to. The actual format is relatively easy to
	understand if you look at this file and some of my DSD schemas.

	Author:
		Name  : Hugh Field-Richards.
		Email : hsfr@hsfr.org.uk
	
    LICENSE:
    
    This software is free software; you can redistribute it
    and/or modify it under the terms of the GNU Lesser General
    Public License as published by the Free Software Foundation;
    either version 2.1 of the License, or (at your option) any
    later version.
    
    This software is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.
    
    You should have received a copy of the GNU Lesser General Public
    License along with this software; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:dsd="http://www.brics.dk/DSD/2.0"
    xmlns:xi="http://www.w3.org/2001/XInclude" xmlns:m="http://www.brics.dk/DSD/2.0/meta"
    xmlns:doc="http://www.paloose.org/schemas/DSD/DSDs/doc" xmlns:xhtml="http://www.w3.org/1999/xhtml"
    xmlns:a="http://relaxng.org/ns/annotation/1.0" xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:map="http://apache.org/cocoon/sitemap/1.0" version="1.0">

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*- 3.5 DEFINITIONS -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!--
		Definitions allow rules and regular expressions to be named for grouping and reuse:

		DEFINITION ::= <rule id="PENAME"> RULE* </rule>
					 | <contenttype id="PENAME"> REGEXP </contenttype>
				 	| <stringtype id="PENAME"> REGEXP </stringtype>
				 	| <boolexp id="PENAME"> BOOLEXP </boolexp>  
	-->

    <xsl:template match="
            *[(local-name() = 'rule'
            or local-name() = 'contenttype'
            or local-name() = 'stringtype'
            or local-name() = 'boolexp') and @id]">
        <xsl:call-template name="definitions"/>
    </xsl:template>

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!--
     -->

    <xsl:template name="definitions">

        <xsl:element name="div">
            <xsl:attribute name="class">primaryRule</xsl:attribute>
            <xsl:call-template name="outputRuleNameWithButton">
                <xsl:with-param name="inElementName" select="local-name(.)"/>
            </xsl:call-template>

            <xsl:element name="div">
                <xsl:attribute name="class">codeBlock</xsl:attribute>

                <xsl:choose>
                    <xsl:when test="local-name(.) = 'rule'">
                        <xsl:for-each select="*[not(self::m:doc) and not(self::dsd:import) and not(self::xi:include)]">
                            <xsl:call-template name="rules"/>
                        </xsl:for-each>
                    </xsl:when>

                    <xsl:when test="local-name(.) = 'contenttype'">
                        <xsl:for-each select="*[not(self::m:doc) and not(self::dsd:import) and not(self::xi:include)]">
                            <xsl:call-template name="regexp"/>
                         </xsl:for-each>
                    </xsl:when>

                    <xsl:when test="local-name(.) = 'stringtype'">
                        <xsl:for-each select="*[not(self::m:doc) and not(self::dsd:import) and not(self::xi:include)]">
                            <xsl:call-template name="regexp"/>
                        </xsl:for-each>
                    </xsl:when>

                    <xsl:when test="local-name(.) = 'boolexp'">
                        <xsl:for-each select="*[not(self::m:doc) and not(self::dsd:import) and not(self::xi:include)]">
                            <xsl:call-template name="boolexp"/>
                         </xsl:for-each>
                    </xsl:when>

                    <xsl:otherwise/>
                </xsl:choose>
            </xsl:element>

            <xsl:call-template name="outputRawXML"/>
        </xsl:element>
    </xsl:template>


</xsl:stylesheet>
