<?xml version="1.0" encoding="ISO-8859-1" ?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--
    
    DSD-2 to HTML Pretty Printer
    
    This XSLT style sheet pretty prints a DSD-2 schema. It has been tested
    on the current Xalan processor and renders to most browsers (Safari, IE, 
    Mozilla, Netscape etc). It was inspire by the DSD-1 pretty printer written
    by Nils Klarlund for the original DSD-1. Note that the DSD documentation
    that is processed is not in HTML but a personal XML format - this could
    be changed if anyone cares to. The actual format is relatively easy to
    understand if you look at this file and some of my DSD schemas.
    
    Author:
    	Name  : Hugh Field-Richards.
    	Email : hsfr@hsfr.org.uk
    
    LICENSE:
    
    This software is free software; you can redistribute it
    and/or modify it under the terms of the GNU Lesser General
    Public License as published by the Free Software Foundation;
    either version 2.1 of the License, or (at your option) any
    later version.
    
    This software is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.
    
    You should have received a copy of the GNU Lesser General Public
    License along with this software; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:dsd="http://www.brics.dk/DSD/2.0"
    xmlns:xi="http://www.w3.org/2001/XInclude" xmlns:m="http://www.brics.dk/DSD/2.0/meta"
    xmlns:doc="http://www.paloose.org/schemas/DSD/DSDs/doc" xmlns:xhtml="http://www.w3.org/1999/xhtml"
    xmlns:a="http://relaxng.org/ns/annotation/1.0" xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:map="http://apache.org/cocoon/sitemap/1.0" version="1.0">
    
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*- REGULAR EXPRESSIONS -*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!--
		Regular expressions describe sets of strings or contents sequences.
		
			REGEXP  ::= <sequence> REGEXP* </sequence>
				  	| <optional> REGEXP </optional>
				  	| <complement> REGEXP </complement>
				  	| <union> REGEXP* </union>
				  	| <intersection> REGEXP* </intersection>
				  	| <minus> REGEXP REGEXP </minus>
				  	| <repeat ( number="NUMERAL"?  |  min="NUMERAL"? max="NUMERAL"? ) > REGEXP </repeat>
				  	| <string value="VALUE"? />
				  	| <char ( set="VALUE"?  |  min="CHAR" max="CHAR" ) />
				  	| <stringtype ref="NCNAME" namespace="VALUE"? />
				  	| <contenttype ref="NCNAME" namespace="VALUE"? />
				  	| BOOLEXP
	-->
    
    <xsl:template name="regexp">
        <xsl:choose>
            <xsl:when test="local-name(.) = 'optional' or local-name(.) = 'complement'">
                <xsl:element name="xhtml:div">
                    <xsl:attribute name="class">indentedBlock</xsl:attribute>
                    <xsl:call-template name="unary-regexp"/>
                </xsl:element>
            </xsl:when>
            
            <xsl:when test="local-name(.) = 'sequence' or local-name(.) = 'union' or local-name(.) = 'intersection'">
                <xsl:element name="xhtml:div">
                    <xsl:attribute name="class">indentedBlock</xsl:attribute>
                    <xsl:call-template name="seq-regexp"/>
                </xsl:element>
            </xsl:when>
            
            <xsl:when test="local-name(.) = 'minus'">
                <xsl:element name="xhtml:div">
                    <xsl:attribute name="class">indentedBlock</xsl:attribute>
                    <xsl:call-template name="minus-regexp"/>
                </xsl:element>
            </xsl:when>
            
            <xsl:when test="local-name(.) = 'repeat'">
                <xsl:element name="xhtml:div">
                    <xsl:attribute name="class">indentedBlock</xsl:attribute>
                    <xsl:call-template name="repeat-regexp"/>
                </xsl:element>
            </xsl:when>
            
            <xsl:when test="local-name(.) = 'char'">
                <xsl:element name="xhtml:div">
                    <xsl:attribute name="class">indentedBlock</xsl:attribute>
                    
                    <xsl:call-template name="char-regexp"/>
                </xsl:element>
            </xsl:when>
            
            <xsl:when test="local-name(.) = 'string'">
                <xsl:element name="xhtml:div">
                    <xsl:attribute name="class">indentedBlock</xsl:attribute>
                    <xsl:call-template name="string-regexp"/>
                </xsl:element>
            </xsl:when>
            
            <xsl:when test="local-name(.) = 'stringtype' or local-name(.) = 'contenttype'">
                <xsl:element name="div">
                    <xsl:attribute name="class">indentedBlock</xsl:attribute>
                    <xsl:call-template name="stringtype-regexp"/>
                </xsl:element>
            </xsl:when>
            
            <xsl:otherwise>
                <xsl:call-template name="boolexp"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    
    <xsl:template name="unary-regexp">
        <xsl:call-template name="render-declare-name"/>
        <xsl:for-each select="*[not(position() > 1)]">
            <xsl:call-template name="regexp"/>
        </xsl:for-each>
    </xsl:template>
    
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    
    <xsl:template name="seq-regexp">
        <xsl:call-template name="render-element-name"/>
        <xsl:for-each select="*">
            <xsl:call-template name="regexp"/>
        </xsl:for-each>
    </xsl:template>
    
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    
    <xsl:template name="minus-regexp">
        <xsl:call-template name="render-element-name"/>
        <xsl:for-each select="*[not(position() > 2)]">
            <xsl:call-template name="regexp"/>
        </xsl:for-each>
    </xsl:template>
    
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    
    <xsl:template name="repeat-regexp">
        
        <xsl:variable name="repeatValue">
            <xsl:choose>
                <xsl:when test="@number">
                    <xsl:value-of select="concat('{', @number, ' times}')"/>
                </xsl:when>
                <xsl:when test="@min = '0' and not(@max)">
                    <xsl:value-of select="'{Zero or more times}'"/>
                </xsl:when>
                <xsl:when test="@min and not(@max)">
                    <xsl:value-of select="concat('{', @min, ' or more times}')"/>
                </xsl:when>
                <xsl:when test="@min and @max">
                    <xsl:value-of select="concat('{', @min, '..', @max, '}')"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="'{forever}'"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        
        <xsl:call-template name="outputElementWithModifier">
            <xsl:with-param name="inElementName" select="local-name(.)"/>
            <xsl:with-param name="inModifier" select="$repeatValue"/>
        </xsl:call-template>
        
        <xsl:for-each select="*">
            <xsl:call-template name="regexp"/>
        </xsl:for-each>
    </xsl:template>
    
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    
    <xsl:template name="char-regexp">
        <xsl:choose>
            <xsl:when test="@set"> [<xhtml:span class="chars"><xsl:value-of select="@set"/></xhtml:span>] </xsl:when>
            <xsl:when test="@min or @max"> [<xhtml:span class="chars"><xsl:value-of select="@min"/>..<xsl:value-of select="@max"
            /></xhtml:span>] </xsl:when>
            <xsl:otherwise>
                <xhtml:span class="chars">any character</xhtml:span>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    
    <xsl:template name="stringtype-regexp">
        <xsl:variable name="elementName" select="local-name(.)"/>
        <xsl:variable name="ruleReference" select="@ref"/>
        
        <xsl:call-template name="outputRuleWithRef">
            <xsl:with-param name="inElementName" select="$elementName"/>
            <xsl:with-param name="inRefName" select="$ruleReference"/>
        </xsl:call-template>
    </xsl:template>
    
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    
    <xsl:template name="string-regexp">
        <xsl:choose>
            <xsl:when test="@value"> "<xhtml:span class="chars"><xsl:value-of select="@value"/></xhtml:span>" </xsl:when>
            <xsl:otherwise>
                <xhtml:span class="chars">any string</xhtml:span>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
    
</xsl:stylesheet>