<?xml version="1.0" encoding="ISO-8859-1" ?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--

	DSD-2 to HTML Pretty Printer

	This XSLT style sheet pretty prints a DSD-2 schema. It has been tested
	on the current Xalan processor and renders to most browsers (Safari, IE, 
	Mozilla, Netscape etc). It was inspire by the DSD-1 pretty printer written
	by Nils Klarlund for the original DSD-1. Note that the DSD documentation
	that is processed is not in HTML but a personal XML format - this could
	be changed if anyone cares to. The actual format is relatively easy to
	understand if you look at this file and some of my DSD schemas.

	Author:
		Name  : Hugh Field-Richards.
		Email : hsfr@hsfr.org.uk
	
    LICENSE:
    
    This software is free software; you can redistribute it
    and/or modify it under the terms of the GNU Lesser General
    Public License as published by the Free Software Foundation;
    either version 2.1 of the License, or (at your option) any
    later version.
    
    This software is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.
    
    You should have received a copy of the GNU Lesser General Public
    License along with this software; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:dsd="http://www.brics.dk/DSD/2.0"
    xmlns:xi="http://www.w3.org/2001/XInclude" xmlns:m="http://www.brics.dk/DSD/2.0/meta"
    xmlns:doc="http://www.paloose.org/schemas/DSD/DSDs/doc" xmlns:xhtml="http://www.w3.org/1999/xhtml"
    xmlns:a="http://relaxng.org/ns/annotation/1.0" xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:map="http://apache.org/cocoon/sitemap/1.0" version="1.0">
    
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- 3.2 Rules -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!--
		Rules describe validity restrictions for a given element:

		RULE ::=  <declare> DECLARATION* </declare>
				| <require> BOOLEXP* </require>
				| <if> BOOLEXP RULE* </if>
				| <rule ref="PENAME"/>
				| UNIQUE
				| POINTER
     -->
    
    <xsl:template match="
        *[local-name() = 'declare'
        or local-name() = 'require'
        or local-name() = 'if'
        or (local-name() = 'rule' and @ref)
        or local-name() = 'unique'
        or local-name() = 'pointer']">
        <xsl:element name="div">
            <xsl:attribute name="class">primaryRule</xsl:attribute>
            
            <xsl:choose>
                <xsl:when test="local-name(.) = 'declare'">
                    <xsl:call-template name="declare-entry"/>
                </xsl:when>
                
                <xsl:when test="local-name(.) = 'require'">
                    <xsl:call-template name="require-entry"/>
                </xsl:when>
                
                <xsl:when test="local-name(.) = 'if'">
                    <xsl:call-template name="rule-if"/>
                </xsl:when>
                
                <xsl:when test="local-name(.) = 'unique'">
                    <xsl:call-template name="unique-rule"/>
                </xsl:when>
                
                <xsl:when test="local-name() = 'pointer'">
                    <xsl:call-template name="pointer-rule"/>
                </xsl:when>
                
                <xsl:otherwise/>
            </xsl:choose>
            
            <xsl:call-template name="outputRawXML"/>
            
        </xsl:element>
    </xsl:template>
    
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!--
        <declare> DECLARATION* </declare>
     -->
    
    
    <xsl:template name="declare-entry">
        <xsl:element name="div">
            <xsl:attribute name="class">primaryRule</xsl:attribute>
            
            <xsl:call-template name="outputElement">
                <xsl:with-param name="inElementName" select="local-name(.)"/>
            </xsl:call-template>
            
            <xsl:element name="div">
                <xsl:attribute name="class">indentedBlock</xsl:attribute>
                <xsl:for-each select="*[not(self::m:doc)]">
                    <xsl:choose>
                        <xsl:when test="local-name(.) = 'contents'">
                            <xsl:call-template name="contents-decl"/>
                        </xsl:when>
                        
                        <xsl:when test="local-name(.) = 'attribute'">
                            <xsl:call-template name="attribute-decl"/>
                        </xsl:when>
                        
                        <xsl:when test="local-name(.) = 'required'">
                            <xsl:call-template name="required-decl"/>
                        </xsl:when>
                    </xsl:choose>
                </xsl:for-each>
            </xsl:element>
        </xsl:element>
    </xsl:template>
    
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!--
		<if> BOOLEXP RULE* </if>
	-->
    
    <xsl:template name="rule-if">
        <xsl:call-template name="outputRuleNameWithButton">
            <xsl:with-param name="inElementName" select="local-name(.)"/>
        </xsl:call-template>
        
        <xsl:element name="div">
            <xsl:attribute name="class">codeBlock</xsl:attribute>
            
            <xsl:for-each select="*[not(self::m:doc)]">
                <xsl:choose>
                    
                    <!-- The first in the enclosed elements is the BOOLEXP -->
                    <xsl:when test="position() = 1">
                        <xsl:element name="div">
                            <xsl:attribute name="class">conditionBlock</xsl:attribute>
                            <xsl:call-template name="boolexp">
                                <xsl:with-param name="inIsConditionBlock" select="true()"/>
                            </xsl:call-template>
                        </xsl:element>
                    </xsl:when>
                    
                    <xsl:when test="not(self::m:doc)">
                        <xsl:call-template name="rules"/>
                    </xsl:when>
                    
                </xsl:choose>
            </xsl:for-each>
        </xsl:element>
    </xsl:template>
    
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    
    <xsl:template name="rules">
        <xsl:element name="div">
            <xsl:attribute name="class">indentedBlock</xsl:attribute>
            
            <xsl:choose>
                <xsl:when test="local-name(.) = 'declare'">
                    <xsl:call-template name="declare-rule"/>
                </xsl:when>
                
                <xsl:when test="local-name(.) = 'require'">
                    <xsl:call-template name="require-rule"/>
                </xsl:when>
                
                <xsl:when test="local-name(.) = 'if'">
                    <xsl:call-template name="if-rule"/>
                </xsl:when>
                
                <xsl:when test="local-name(.) = 'rule'">
                    <xsl:call-template name="rule-rule"/>
                </xsl:when>
                
                <xsl:when test="local-name(.) = 'unique'">
                    <xsl:call-template name="unique-rule"/>
                </xsl:when>
                
                <xsl:when test="local-name() = 'pointer'">
                    <xsl:call-template name="pointer-rule"/>
                </xsl:when>
                <xsl:otherwise/>
            </xsl:choose>
        </xsl:element>
    </xsl:template>
    
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    
    <xsl:template name="if-rule">
        <xsl:call-template name="outputElement">
            <xsl:with-param name="inElementName" select="local-name(.)"/>
        </xsl:call-template>
        
        <xsl:for-each select="*[not(self::m:doc)]">
            <xsl:choose>
                <xsl:when test="position() = 1">
                    <!--- condition boolexp -->
                    
                    <xsl:call-template name="boolexp">
                        <xsl:with-param name="inIsConditionBlock"/>
                    </xsl:call-template>
                </xsl:when>
                
                <xsl:when test="not(self::m:doc)">
                    <!-- ignore documentation -->
                    <xsl:call-template name="rules"/>
                </xsl:when>
            </xsl:choose>
        </xsl:for-each>
    </xsl:template>
    
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-* RULE DEFINITIONS -*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
     <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    
    <xsl:template name="require-rule">
        <xsl:call-template name="outputElement">
            <xsl:with-param name="inElementName" select="local-name(.)"/>
        </xsl:call-template>
        
        <xsl:element name="xhtml:div">
            <xsl:attribute name="class">indentedBlock</xsl:attribute>
            <xsl:for-each select="*">
                <xsl:call-template name="boolexp"/>
            </xsl:for-each>
        </xsl:element>
    </xsl:template>
    
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    
    <xsl:template name="require-entry">
        <xsl:call-template name="render-element-name"/>
        <xsl:for-each select="*[not(self::m:doc)]">
            <xsl:call-template name="boolexp"/>
        </xsl:for-each>
    </xsl:template>
    
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    
    <xsl:template name="rule-rule">
        <xsl:variable name="elementName" select="local-name(.)"/>
        <xsl:variable name="ruleReference" select="@ref"/>
        
        <xsl:call-template name="outputRuleWithRef">
            <xsl:with-param name="inElementName" select="$elementName"/>
            <xsl:with-param name="inRefName" select="$ruleReference"/>
        </xsl:call-template>
    </xsl:template>
    
    
</xsl:stylesheet>