<?xml version="1.0" encoding="ISO-8859-1" ?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--
    
    DSD-2 to HTML Pretty Printer
    
    This XSLT style sheet pretty prints a DSD-2 schema. It has been tested
    on the current Xalan processor and renders to most browsers (Safari, IE, 
    Mozilla, Netscape etc). It was inspire by the DSD-1 pretty printer written
    by Nils Klarlund for the original DSD-1. Note that the DSD documentation
    that is processed is not in HTML but a personal XML format - this could
    be changed if anyone cares to. The actual format is relatively easy to
    understand if you look at this file and some of my DSD schemas.
    
    Author:
    	Name  : Hugh Field-Richards.
    	Email : hsfr@hsfr.org.uk
    
    LICENSE:
    
    This software is free software; you can redistribute it
    and/or modify it under the terms of the GNU Lesser General
    Public License as published by the Free Software Foundation;
    either version 2.1 of the License, or (at your option) any
    later version.
    
    This software is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.
    
    You should have received a copy of the GNU Lesser General Public
    License along with this software; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:dsd="http://www.brics.dk/DSD/2.0"
    xmlns:xi="http://www.w3.org/2001/XInclude" xmlns:m="http://www.brics.dk/DSD/2.0/meta"
    xmlns:doc="http://www.paloose.org/schemas/DSD/DSDs/doc" xmlns:xhtml="http://www.w3.org/1999/xhtml"
    xmlns:a="http://relaxng.org/ns/annotation/1.0" xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:map="http://apache.org/cocoon/sitemap/1.0" version="1.0">

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*- UTILITY TEMPLATES -*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!-- 
		Output a definition with value of that definition 		   
	-->

    <xsl:template name="outputDefinitionAndValue">
        <xsl:param name="inElementName"/>
        <xsl:param name="inValue"/>

        <xsl:element name="div">
            <xsl:attribute name="class">ruleTag</xsl:attribute>
            <xsl:element name="span">
                <xsl:attribute name="class">element-name</xsl:attribute>
                <xsl:value-of select="local-name(.)"/>
            </xsl:element>

            <xsl:if test="$inValue">
                <xsl:text>:&#160;</xsl:text>

                <xsl:element name="span">
                    <xsl:attribute name="class">keyword</xsl:attribute>
                    <xsl:attribute name="id">
                        <xsl:value-of select="$inValue"/>
                    </xsl:attribute>
                                     <xsl:value-of select="$inValue"/>
                </xsl:element>
            </xsl:if>
        </xsl:element>
    </xsl:template>

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!--
		Output a single element
		
		param inElementName the name of the element to be output.
	-->

    <xsl:template name="outputElement">
        <xsl:param name="inElementName"/>

        <xsl:element name="div">
            <xsl:attribute name="class">ruleTag</xsl:attribute>

            <xsl:element name="span">
                <xsl:attribute name="class">element-name</xsl:attribute>
                <xsl:value-of select="$inElementName"/>
            </xsl:element>
        </xsl:element>
    </xsl:template>

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!--
		Output a single element not as rule
		
		param inElementName the name of the element to be output.
	-->

    <xsl:template name="outputElementNoRule">
        <xsl:param name="inElementName"/>

        <xsl:element name="span">
            <xsl:attribute name="class">element-name</xsl:attribute>
            <xsl:value-of select="$inElementName"/>
        </xsl:element>
    </xsl:template>

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!--
		Output a rule with reference value.
		
		param inElementName the name of the element to be output.
	-->

    <xsl:template name="outputRuleWithRef">
        <xsl:param name="inElementName"/>
        <xsl:param name="inRefName"/>

        <xsl:element name="div">
            <xsl:attribute name="class">ruleTag</xsl:attribute>

            <xsl:value-of select="$inElementName"/>
            <xsl:text>&#160;&#x2192;&#160;</xsl:text>
            <xsl:element name="span">
                <xsl:attribute name="class">keyword</xsl:attribute>
                <xsl:element name="a">
                    <xsl:attribute name="href">
                        <xsl:value-of select="concat('#', $inRefName)"/>
                    </xsl:attribute>
                    <xsl:value-of select="$inRefName"/>
                </xsl:element>
            </xsl:element>
        </xsl:element>
    </xsl:template>

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!--
		Output a rule with highlighted with button for raw XML.
		
		param inElementName the name of the element to be output.
	-->

    <xsl:template name="outputRuleNameWithButton">
        <xsl:param name="inElementName"/>

        <xsl:element name="div">
            <xsl:attribute name="class">ruleTag</xsl:attribute>

            <xsl:element name="div">
                <xsl:attribute name="class">ruleTag-left</xsl:attribute>

                <xsl:value-of select="$inElementName"/>
                <xsl:choose>
                    <xsl:when test="@id">
                        <xsl:text>:&#160;</xsl:text>
                          <xsl:element name="span">
                            <xsl:attribute name="class">keyword</xsl:attribute>
                            <xsl:attribute name="id">
                                <xsl:value-of select="@id"/>
                            </xsl:attribute>    
                              
                            <xsl:value-of select="@id"/>
                        </xsl:element>
                    </xsl:when>

                    <xsl:when test="@key">
                        <xsl:text>:&#160;</xsl:text>
                        <xsl:element name="span">
                            <xsl:attribute name="class">keyword</xsl:attribute>
                            <xsl:attribute name="id">
                                <xsl:value-of select="@key"/>
                            </xsl:attribute>
                            
                            <xsl:value-of select="@key"/>
                        </xsl:element>
                    </xsl:when>

                    <xsl:when test="@ref">
                        <xsl:text>&#160;&#x2192;&#160;</xsl:text>
                        <xsl:element name="span">
                            <xsl:attribute name="class">keyword</xsl:attribute>
                            <xsl:attribute name="id">
                                <xsl:value-of select="@ref"/>
                            </xsl:attribute>    
                            
                            <xsl:value-of select="@ref"/>
                        </xsl:element>
                        
                    </xsl:when>
                </xsl:choose>
            </xsl:element>

            <xsl:element name="div">
                <xsl:attribute name="class">ruleTag-right</xsl:attribute>
                <xsl:element name="div">
                    <xsl:attribute name="class">switchButton rawButton</xsl:attribute>
                </xsl:element>
            </xsl:element>
        </xsl:element>
    </xsl:template>

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!--
		Output a single element
		
		param inElementName the name of the element to be output.
		param inModifier the element modifier (such as repeat value).
	-->

    <xsl:template name="outputElementWithModifier">
        <xsl:param name="inElementName"/>
        <xsl:param name="inModifier"/>

        <xsl:element name="div">
            <xsl:attribute name="class">ruleTag</xsl:attribute>

            <xsl:element name="span">
                <xsl:attribute name="class">element-name</xsl:attribute>
                <xsl:value-of select="$inElementName"/>
            </xsl:element>
            <xsl:text>:&#160;</xsl:text>
            <xsl:element name="span">
                <xsl:attribute name="class">keyword</xsl:attribute>
                <xsl:value-of select="$inModifier"/>
            </xsl:element>

        </xsl:element>
    </xsl:template>

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!--
		Output a single element with name
		
		param inElementName the name of the element to be output.
	-->

    <xsl:template name="render-element-name">
        <xsl:param name="inElementName"/>

        <xsl:element name="div">
            <xsl:attribute name="class">ruleTag</xsl:attribute>
            <xsl:element name="span">
                <xsl:attribute name="class">element-name</xsl:attribute>
                <xsl:value-of select="local-name(.)"/>
            </xsl:element>

            <xsl:text>:&#160;</xsl:text>
            <xsl:value-of select="$inElementName"/>
        </xsl:element>
    </xsl:template>

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
    <!--
		Output a single element with name
		
		param inElementName the name of the element to be output.
	-->

    <xsl:template name="render-declare-name">
        <xsl:element name="div">
            <xsl:attribute name="class">ruleTag</xsl:attribute>
            <xsl:element name="span">
                <xsl:attribute name="class">element-name</xsl:attribute>
                <xsl:value-of select="local-name(.)"/>
            </xsl:element>
        </xsl:element>
    </xsl:template>

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

    <xsl:template name="render-id-attrib">
        <xsl:if test="@id">
            <xsl:element name="xhtml:span">
                <xsl:attribute name="class">keyword-def</xsl:attribute>
                <xsl:value-of select="@id"/>
            </xsl:element>
        </xsl:if>
    </xsl:template>

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

    <xsl:template name="render-element-attrib-name">
        <xsl:param name="inElementName"/>
        <xsl:param name="inAttribName"/>

        <xsl:element name="div">
            <xsl:attribute name="class">ruleTag</xsl:attribute>
            <xsl:element name="span">
                <xsl:attribute name="class">element-name</xsl:attribute>
                <xsl:value-of select="local-name(.)"/>
            </xsl:element>

            <xsl:text>:&#160;</xsl:text>

            <xsl:element name="span">
                <xsl:attribute name="class">keyword</xsl:attribute>

                <xsl:value-of select="$inAttribName"/>
            </xsl:element>
        </xsl:element>
    </xsl:template>

    <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

    <xsl:template name="render-namespace-attrib">
        <xsl:if test="@namespace">&#160;<xhtml:span class="namespace">{xmlns:<xsl:value-of select="@namespace"
            />}</xhtml:span></xsl:if>
    </xsl:template>
</xsl:stylesheet>
