<?xml version="1.0" encoding="ISO-8859-1" ?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--

	DSD-2 to HTML Pretty Printer

	This XSLT style sheet pretty prints a DSD-2 schema. It has been tested
	on the current Xalan processor and renders to most browsers (Safari, IE, 
	Mozilla, Netscape etc). It was inspire by the DSD-1 pretty printer written
	by Nils Klarlund for the original DSD-1. Note that the DSD documentation
	that is processed is not in HTML but a personal XML format - this could
	be changed if anyone cares to. The actual format is relatively easy to
	understand if you look at this file and some of my DSD schemas.

	Author:
		Name  : Hugh Field-Richards.
		Email : hsfr@hsfr.org.uk
	
-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

   Version    Date                    Changes
   ==========================================================================

   2.00       September 2022          Complete rehash to cope with new syntaxes etc.

   LICENSE:
   
   This software is free software; you can redistribute it
   and/or modify it under the terms of the GNU Lesser General
   Public License as published by the Free Software Foundation;
   either version 2.1 of the License, or (at your option) any
   later version.
   
   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this software; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:dsd="http://www.brics.dk/DSD/2.0"
	xmlns:xi="http://www.w3.org/2001/XInclude" xmlns:m="http://www.brics.dk/DSD/2.0/meta"
	xmlns:doc="http://www.paloose.org/schemas/DSD/DSDs/doc" xmlns:xhtml="http://www.w3.org/1999/xhtml"
	xmlns:a="http://relaxng.org/ns/annotation/1.0" xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:map="http://apache.org/cocoon/sitemap/1.0" version="1.0">

	<xsl:output version="1.0" encoding="UTF-8"/>

	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-* SITEMAP PARAMETERS -*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->

	<xsl:param name="stylesDir"/>
	<xsl:param name="scriptsDir"/>
	<xsl:param name="jQueryScriptsDir"/>

	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-* GLOBAL VARIABLES -*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->

	<xsl:variable name="gCSSFilesDir" select="$stylesDir"/>
	<xsl:variable name="gCSSFiles" select="'prettyDSD.css'"/>

	<xsl:variable name="gScriptFilesDir" select="$scriptsDir"/>
	<xsl:variable name="gScriptFiles" select="'dsd.js'"/>

	<xsl:variable name="gJQueryScriptFilesDir" select="$jQueryScriptsDir"/>
	<xsl:variable name="gJQueryScriptFiles" select="'jquery.min.js;jquery-ui-1.8.16.custom.min.js'"/>

	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- INCLUDED XSL FILES *-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

	<xsl:include href="dsd2xhtml-buildHeader.xsl"/>
	<xsl:include href="dsd2xhtml-rules.xsl"/>
	<xsl:include href="dsd2xhtml-definitions.xsl"/>
	<xsl:include href="dsd2xhtml-declarations.xsl"/>
	<xsl:include href="dsd2xhtml-boolexp.xsl"/>
	<xsl:include href="dsd2xhtml-regexp.xsl"/>
	<xsl:include href="dsd2xhtml-utilities.xsl"/>

	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* PROCESS FILE -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

	<xsl:template match="/">
		<xsl:element name="html">
			<xsl:call-template name="output.header"/>
			<xsl:call-template name="output.body"/>
		</xsl:element>
	</xsl:template>

	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* OUTPUT HEADER *-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

	<xsl:template name="output.header">
		<xsl:element name="head">
			<xsl:call-template name="buildHeader.htmlHead">
				<xsl:with-param name="inTitle">
					<xsl:choose>
						<xsl:when test="//doc:title">
							<xsl:value-of select="//doc:title"/>
						</xsl:when>
						<xsl:otherwise>Untitled</xsl:otherwise>
						<!-- Necessary for Safari -->
					</xsl:choose>
				</xsl:with-param>
				<xsl:with-param name="inStylesList" select="$gCSSFiles"/>
				<xsl:with-param name="inStylesDir" select="$gCSSFilesDir"/>
				<xsl:with-param name="inScriptsList" select="$gScriptFiles"/>
				<xsl:with-param name="inScriptsDir" select="$gScriptFilesDir"/>
				<xsl:with-param name="inJQueryScriptsList" select="$gJQueryScriptFiles"/>
				<xsl:with-param name="inJQueryScriptsDir" select="$gJQueryScriptFilesDir"/>
			</xsl:call-template>

		</xsl:element>
	</xsl:template>

	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!--  
    	Process the meta-data. This is held in the first document block.
    -->

	<xsl:template match="//m:doc[position() = 1]">
		<xsl:element name="div">
			<xsl:attribute name="class">mainDescription</xsl:attribute>
			<xsl:apply-templates select="./*" mode="header"/>
		</xsl:element>
	</xsl:template>

	<xsl:template match="doc:title" mode="header">
		<xsl:element name="div">
			<xsl:attribute name="id">title</xsl:attribute>
			<xsl:value-of select="//doc:title"/>
		</xsl:element>
	</xsl:template>

	<xsl:template match="doc:creator" mode="header">
		<xsl:element name="div">
			<xsl:attribute name="id">creator</xsl:attribute>
			<xsl:text>Author: </xsl:text>
			<xsl:value-of select="//doc:creator"/>
		</xsl:element>
	</xsl:template>

	<xsl:template match="doc:date" mode="header">
		<xsl:element name="div">
			<xsl:attribute name="id">date</xsl:attribute>
			<xsl:text>Date: </xsl:text>
			<xsl:value-of select="//doc:date"/>
		</xsl:element>
	</xsl:template>

	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- OUTPUT BODY -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- 
	   SCHEMA ::= <dsd ( root="PENAME" )? >
                       ( RULE  |  DEFINITION  |  SCHEMA )*
                  </dsd>
	 -->

	<xsl:template name="output.body">
		<xsl:element name="body">
			<xsl:apply-templates/>
		</xsl:element>
	</xsl:template>

	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!--
		Output  the document blocks (not the first which goes at the top after the title.
     -->

	<xsl:template match="//m:doc[position() > 1]">
		<xsl:apply-templates select="./*" mode="body-documentation"/>
	</xsl:template>

	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!--
     -->

	<xsl:template match="@* | node()" mode="body-documentation">
		<xsl:copy>
			<xsl:apply-templates select="@* | node()" mode="body-documentation"/>
		</xsl:copy>
	</xsl:template>

	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!--
     -->

	<xsl:template match="dsd:import">
		<xsl:element name="div">
			<xsl:attribute name="class">importedFile</xsl:attribute>
			<xsl:element name="p">
				<xsl:text>Imported file: </xsl:text>
				<xsl:element name="a">
					<xsl:attribute name="href">
						<xsl:value-of select="@href"/>
					</xsl:attribute>
					<xsl:value-of select="@href"/>
				</xsl:element>
			</xsl:element>
		</xsl:element>
	</xsl:template>

	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*- 3.7 Uniqueness and Pointers -*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- 
        Uniqueness and pointer rules specify that certain combinations of values in the
        instance document must be unique or must uniquely identify other parts of the document:

        UNIQUE ::= <unique ( key="VALUE" )? >
                      ( BOOLEXP FIELD* | ( <select> BOOLEXP FIELD* </select> )* )
                   </unique>

        POINTER ::= <pointer ( key="VALUE" )? > BOOLEXP? FIELD* </pointer>

        FIELD ::= <attributefield name="PANAME" ( type="ATTRTYPE" )? > BOOLEXP? </attributefield>
	            | <chardatafield ( type="ATTRTYPE" )? > BOOLEXP? </chardatafield>

        Additional syntactic restrictions: each unique, pointer, and select must have at
        least one FIELD descendant. 
	-->

	<xsl:template name="unique-rule">
		
		<xsl:element name="div">
			<xsl:attribute name="class">primaryRule</xsl:attribute>
			<xsl:call-template name="outputRuleNameWithButton">
				<xsl:with-param name="inElementName" select="local-name(.)"/>
			</xsl:call-template>
			
			<xsl:element name="div">
				<xsl:attribute name="class">codeBlock</xsl:attribute>
				<xsl:for-each select="*[not(self::m:doc)]">
					<xsl:choose>
						<xsl:when test="position() = 1">
							<xsl:call-template name="boolexp">
								<xsl:with-param name="inIsConditionBlock" select="true()"/>
							</xsl:call-template>
						</xsl:when>
						
						<xsl:when test="not(self::m:doc)">
							<xsl:call-template name="field"/>
						</xsl:when>
					</xsl:choose>
				</xsl:for-each>
			</xsl:element>
			<xsl:call-template name="outputRawXML"/>
			
		</xsl:element>
	</xsl:template>
	
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	
	<xsl:template name="pointer-rule">
		
		<xsl:element name="div">
			<xsl:attribute name="class">indentedBlock</xsl:attribute>

			<xsl:call-template name="outputDefinitionAndValue">
				<xsl:with-param name="inElementName" select="local-name(.)"/>
				<xsl:with-param name="inValue" select="@key"/>
			</xsl:call-template>
			
			<xsl:element name="div">
				<xsl:attribute name="class">codeBlock</xsl:attribute>
				<xsl:for-each select="*[not(self::m:doc)]">
					<xsl:choose>
						<xsl:when test="position() = 1">
							<xsl:call-template name="boolexp">
								<xsl:with-param name="inIsConditionBlock" select="true()"/>
							</xsl:call-template>
						</xsl:when>
						
						<xsl:when test="not(self::m:doc)">
							<xsl:call-template name="field"/>
						</xsl:when>
					</xsl:choose>
				</xsl:for-each>
			</xsl:element>
				
		</xsl:element>
	</xsl:template>
	
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	
	<xsl:template name="field">
		<xsl:element name="div">
			<xsl:attribute name="class">indentedBlock</xsl:attribute>

			<xsl:call-template name="outputDefinitionAndValue">
				<xsl:with-param name="inElementName" select="local-name(.)"/>
				<xsl:with-param name="inValue" select="@name"/>
			</xsl:call-template>

			<xsl:if test="@type">
				<xsl:element name="span">
					<xsl:attribute name="class">leyword</xsl:attribute>
					
				    <xsl:value-of select="concat( '{', @type, '}' )"/>
				</xsl:element>
			</xsl:if>

			<xsl:for-each select="*">
				<xsl:call-template name="boolexp"/>
			</xsl:for-each>
		</xsl:element>
	</xsl:template>

	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- OUTPUT RAW XML *-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
	<!-- 
	   Output the raw XML block that is hidden intially for rules and definitions.
	-->

	<xsl:template name="outputRawXML">
		<xsl:element name="div">
			<xsl:attribute name="class">rawXML</xsl:attribute>
			<xsl:element name="pre">
				<xsl:apply-templates select="." mode="cdata">
					<xsl:with-param name="inSpaces"/>
				</xsl:apply-templates>
			</xsl:element>
		</xsl:element>
	</xsl:template>

	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

	<xsl:template match="node()" mode="cdata">
		<xsl:param name="inSpaces" select="''"/>

		<xsl:variable name="spaces" select="$inSpaces"/>

		<xsl:choose>
			<xsl:when test="count(*) > 0">
				<xsl:value-of select="$spaces"/>
				<xsl:text>&lt;</xsl:text>
				<xsl:value-of select="name()"/>
				<xsl:apply-templates select="@*" mode="cdata"/>
				<xsl:text>&gt;&#10;</xsl:text>
				<xsl:apply-templates select="node()" mode="cdata">
					<xsl:with-param name="inSpaces" select="concat($spaces, '   ')"/>
				</xsl:apply-templates>
				<xsl:value-of select="$spaces"/>
				<xsl:text>&lt;/</xsl:text>
				<xsl:value-of select="name()"/>
				<xsl:text>&gt;&#10;</xsl:text>
			</xsl:when>
			<xsl:when test="text()">
				<xsl:variable name="attribs">
					<xsl:apply-templates select="@*" mode="cdata"/>
				</xsl:variable>
				<xsl:value-of select="concat($spaces, '&lt;', name(), $attribs, '&gt;')"/>
				<xsl:value-of select="concat(normalize-space(.), '&lt;/', name(), '&gt;&#10;')"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$spaces"/>
				<xsl:text>&lt;</xsl:text>
				<xsl:value-of select="name()"/>
				<xsl:apply-templates select="@* | node()" mode="cdata"/>
				<xsl:text>/&gt;&#10;</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

	<xsl:template match="@*" mode="cdata">
		<xsl:text> </xsl:text>
		<xsl:value-of select="name()"/>
		<xsl:text>="</xsl:text>
		<xsl:value-of select="."/>
		<xsl:text>"</xsl:text>
		<xsl:apply-templates select="@* | node()" mode="cdata"/>
	</xsl:template>

	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

	<xsl:template match="text()" mode="cdata">
		<xsl:apply-templates select="@* | node()" mode="cdata"/>
	</xsl:template>



</xsl:stylesheet>
