<?xml version="1.0"?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--
	
	Error Page to HTML Transform
	
	Author:
	Name  : Hugh Field-Richards
	Email : hsfr@hsfr.org.uk
	
	-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
	-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
	
	Version   Date                   Who    Changes
	==========================================================================
	
	0.00-0    15th May 2006          HSFR   Created
	
	-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- Copyright -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
	
	This software is published under the terms of the LGPL License
	a copy of which has been included with this distribution in the LICENSE file.
	
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:graphic="http://www.hsfr.org.uk/Schema/Graphic"
   xmlns:list="http://www.hsfr.org.uk/Schema/List" xmlns:link="http://www.hsfr.org.uk/Schema/Link"
   xmlns:text="http://www.hsfr.org.uk/Schema/Text" xmlns:news="http://www.hsfr.org.uk/Schema/News"
   xmlns:page="http://www.hsfr.org.uk/Schema/Page" version="1.0">

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Add any parameters from the sitemap here. For example
   
      <map:transform src="context://resources/transforms/page2html.xsl">
         <map:parameter name="page" value="{1}"/>
      </map:transform>
   -->

   <xsl:param name="page"/>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
		Global variables
	-->

   <xsl:variable name="gPage" select="$page"/>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- 

      <root __status="-1" __file="f9686ebb6ce6356822cc77c8a2c107d5">
         <menus xmlns:link="http://www.hsfr.org.uk/Schema/Link" xmlns:list="http://www.hsfr.org.uk/Schema/List" xmlns:page="http://www.hsfr.org.uk/Schema/Page">
            <page:content>
               <list:list type="ordered" id="nav-menu"> ... </list:list>
            </page:content>
         </menus>
         <content xmlns:link="http://www.hsfr.org.uk/Schema/Link" xmlns:t="http://www.hsfr.org.uk/Schema/Text" xmlns:paloose="http://www.paloose.org/schemas/Paloose/1.0" xmlns:page="http://www.hsfr.org.uk/Schema/Page">
            <page:meta>
               <page:title>Paloose — Home Page</page:title>
               <page:copyright>Copyright 2005 – 2010 Hugh Field-Richards. All Rights Reserved.</page:copyright>
               <paloose:page-hit>741</paloose:page-hit>
            </page:meta>
            <page:content>
               ...
            </page:content>
         </content>
      </root>
   -->

   <xsl:template match="/page:page">
      <xsl:element name="root">
         <xsl:attribute name="__status">
            <xsl:value-of select="/page:page/@__status"/>
         </xsl:attribute>
         <xsl:attribute name="__file">
            <xsl:value-of select="/page:page/@__file"/>
         </xsl:attribute>
         <xsl:element name="menus">
            <xsl:apply-templates select="document('../../content/menus.xml')//page:content"/>
         </xsl:element>
         <xsl:element name="content">
            <xsl:apply-templates select="//page:meta"/>
            <xsl:apply-templates select="//page:content"/>
         </xsl:element>
      </xsl:element>
   </xsl:template>


   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- 
		Soak up any remaining elements not processed by the above
	-->

   <xsl:template match="node()|@*" priority="-1">
      <xsl:copy>
         <xsl:apply-templates select="@*"/>
         <xsl:apply-templates/>
      </xsl:copy>
   </xsl:template>

</xsl:stylesheet>
