<?xml version="1.0"?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--
   
   Expand Version List Transformer
   ===============================
   
   Author:
   Name  : Hugh Field-Richards
   Email : hsfr@hsfr.org.uk
   
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- Copyright -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   
   All copyright in this software is the property of Hugh Field-Richards.
   The software is published under the terms of the LGPL License a copy of
   which has been included with this distribution in the LICENSE file.
   
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:dir="http://apache.org/cocoon/directory/2.0"
   xmlns:list="http://www.hsfr.org.uk/Schema/List" xmlns:link="http://www.hsfr.org.uk/Schema/Link"
   xmlns:t="http://www.hsfr.org.uk/Schema/Text" version="1.0">

   <xsl:template match="t:group[ @label = 'directoryList' ]">
      <xsl:variable name="dirId" select="@id"/>
      <xsl:element name="list:list">
         <xsl:attribute name="type">unordered</xsl:attribute>
         <xsl:for-each select="//*[ local-name() = $dirId  ]/dir:file">
            <xsl:variable name="dirName" select="substring($dirId, 1, string-length($dirId)-3)"/>
            <xsl:variable name="fileName" select="substring(@name, 1, string-length(@name)-4)"/>
            <xsl:element name="list:item">
               <xsl:element name="link:link">
                  <xsl:attribute name="ref">
                     <xsl:value-of select="concat( '/{ant:siteName}/', $dirName, '/', $fileName, '-raw.html' )"/>
                  </xsl:attribute>
                  <xsl:attribute name="target">new</xsl:attribute>
                  <xsl:attribute name="type">uri</xsl:attribute>
                  <xsl:value-of select="@name"/>
               </xsl:element>
            </xsl:element>
         </xsl:for-each>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- 
		Soak up any remaining elements not processed by the above
	-->

   <xsl:template match="node()|@*" priority="-1">
      <xsl:copy>
         <xsl:apply-templates select="@*"/>
         <xsl:apply-templates/>
      </xsl:copy>
   </xsl:template>

</xsl:stylesheet>
