<?xml version="1.0"?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--
   
   Expand Version List Transformer
   ===============================
   
   Author:
   Name  : Hugh Field-Richards
   Email : hsfr@hsfr.org.uk
   
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   
   Version   Date                   Who    Changes
   ==========================================================================
   
   0.0.0    15th June 2006          HSFR   Created
   0.0.1    12th September 2006     HSFR   Added version item tag
   
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- Copyright -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   
   All copyright in this software is the property of Hugh Field-Richards.
   The software is published under the terms of the LGPL License a copy of
   which has been included with this distribution in the LICENSE file.
   
-->

<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:paloose="http://www.paloose.org/schemas/Paloose/1.0"
   xmlns:list="http://www.hsfr.org.uk/Schema/List"
   version="1.0">
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Passed in parameters
   -->
   
   <xsl:param name="locale"/>
   
   <!-- Main processing for all "content" text -->
   <xsl:include href="text2html.xsl"/>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--

      XML In
      ===============================================
      <paloose:versions>
         <paloose:version>
            <paloose:version-date><i18n:date pattern="%e %B %G" value="2006-06-15"/></paloose:version-date>
            <paloose:version-number>0.1.0</paloose:version-number>
            <paloose:version-file>downloads/paloose-0.1.0.gz</paloose:version-file>
            <paloose:version-description>First issue</paloose:version-description>
         </paloose:version>
      </paloose:versions>

      XML Out
      ===============================================
      <table>
         <tr>
            <td>0.1.0</td>
            <td>download</td>
            <td> - First issue</td>
         <tr>
      </table>
      
-->   
   
   <xsl:template match="/">
      <xsl:apply-templates mode="processVersions"/>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="paloose:versions" mode="processVersions">
      <xsl:element name="table">
         <xsl:attribute name="width">100%</xsl:attribute>
         <xsl:apply-templates mode="processVersions"/>
      </xsl:element>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="paloose:version-item" mode="processVersions">
      &#x2022;<xsl:apply-templates mode="inline-text" select="."/>
      <xsl:element name="br"/>
   </xsl:template>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="paloose:version" mode="processVersions">
      <xsl:element name="tr">
         <xsl:attribute name="valign">top</xsl:attribute>
         <xsl:element name="td">
            <xsl:attribute name="width">80px</xsl:attribute>
            <xsl:element name="a">
               <xsl:attribute name="href"><xsl:value-of select="paloose:version-file"/></xsl:attribute>
               <xsl:value-of select="paloose:version-number"/>
            </xsl:element>
         </xsl:element>
         <xsl:element name="td">
            <xsl:attribute name="width">110px</xsl:attribute>
            <xsl:value-of select="paloose:version-date"/>
         </xsl:element>
         <xsl:element name="td">
            <xsl:apply-templates  select="paloose:version-description" mode="processVersions"/>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- 
      Pass through all other tags
   -->
   
   <xsl:template match="node()|@*" mode="processVersions" >
      <xsl:copy>
         <xsl:apply-templates select="@*" mode="processVersions" />
         <xsl:apply-templates mode="processVersions" />
      </xsl:copy>
   </xsl:template>
   
</xsl:stylesheet>
