<?xml version="1.0"?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--

                            Language Transform

 Author:
	Name  : Hugh Field-Richards
	Email : hsfr@hsfr.org.uk

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

   Version   Date                   Who    Changes
   ==========================================================================

   0.00-0    24th January 2006      HSFR   Created

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- Copyright -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

   All copyright, database rights and other intellectual property in this
   software is the property of Hugh Field-Richards. The software is being
   released free of charge for use in accordance with the terms of open
   source initiative GNU General Public Licence.
      
-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* Disclaimer -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

   Hugh Field-Richards does not verify or warrant the accuracy,  completeness or
   suitability of this software for any particular purpose. Any use of this
   software whatsoever is entirely at the user's own risk and Hugh Field-Richards
   accepts no liability in relation thereto.
                  
-->

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:i18n="http://apache.org/cocoon/i18n/2.1"
  xmlns:graphic="http://www.hsfr.org.uk/Schema/Graphic"
  xmlns:list="http://www.hsfr.org.uk/Schema/List"
  xmlns:link="http://www.hsfr.org.uk/Schema/Link"
  xmlns:text="http://www.hsfr.org.uk/Schema/Text" 
	xmlns:page="http://www.hsfr.org.uk/Schema/Page" 
	xmlns:work="http://www.hsfr.org.uk/Schema/Work" 
	xmlns:scraps="http://www.hsfr.org.uk/Schema/Scraps" 
	version="1.0">

  <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
  <!--
    Passed in parameters
  -->
  
	<xsl:param name="lang"/>
	<xsl:param name="page"/>
	<xsl:param name="langFileName"/>
	
  <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
  <!--
      Global variables
  -->
  
  <xsl:variable name="gLangFileName">
    <xsl:value-of select=" $langFileName " />
  </xsl:variable>
  
  <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
  <!--
  -->
   
	<xsl:template match="/*">
		<xsl:element name="page:page">
			<xsl:attribute name="lang">
				<xsl:value-of select="$lang"/>
			</xsl:attribute>
			<xsl:attribute name="page">
				<xsl:value-of select="$page"/>
			</xsl:attribute>
			<xsl:attribute name="i18nPage">
				<xsl:value-of select="$gLangFileName"/>
			</xsl:attribute>
			<xsl:apply-templates/>
		</xsl:element>
	</xsl:template>
	
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
  <!-- 
    This processes all the language chunks
  -->
  
  <xsl:template match="i18n:text">
    <xsl:variable name="key">
      <xsl:value-of select="@i18n:key"/>
    </xsl:variable>
  	<!-- Check to see whether the tag exists in the translation file. If it does not then we just pass
  		everything through. This allows us to have multiple translations in the pipeline. -->
   	
  	<xsl:choose>
    	<xsl:when test="document( $gLangFileName )//scraps:item[ @id = $key ]">
    		<xsl:apply-templates  mode="processScrap" select="document( $gLangFileName )//scraps:item[ @id = $key ]"/>
      </xsl:when>
      <xsl:otherwise>
      	<xsl:apply-templates  mode="processScrap" select="."/>
      </xsl:otherwise>
    </xsl:choose>
    
  </xsl:template>
  
  <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
  <!-- 
    Lose the item tag when we process each one
  -->
  
	<xsl:template match="scraps:item" mode="processScrap">
		<xsl:apply-templates mode="processScrap"/>
	</xsl:template>
	
	<xsl:template match="node()|@*" mode="processScrap">
		<xsl:copy>
			<xsl:apply-templates select="@*" mode="processScrap"/>
			<xsl:apply-templates mode="processScrap"/>
		</xsl:copy>
	</xsl:template>
	
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
  <!-- 
    Soak up any remaining elements not processed by the above
  -->
  
  <xsl:template match="node()|@*" priority="-1">
   <xsl:copy>
      <xsl:apply-templates select="@*"/>
      <xsl:apply-templates/>
    </xsl:copy>
  </xsl:template>
  
</xsl:stylesheet>
