<?xml version="1.0"?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--

   Common Local Templates

   Author:
	   Name  : Hugh Field-Richards
	   Email : hsfr@hsfr.org.uk

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

   Version   Date                   Who    Changes
   ==========================================================================

   0.00-0    17th February 2006     HSFR   Created

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- Copyright -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

   All copyright, database rights and other intellectual property in this
   software is the property of Hugh Field-Richards. The software is being
   released free of charge for use in accordance with the terms of open
   source initiative GNU General Public Licence.
      
-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* Disclaimer -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

   Hugh Field-Richards does not verify or warrant the accuracy,  completeness or
   suitability of this software for any particular purpose. Any use of this
   software whatsoever is entirely at the user's own risk and Hugh Field-Richards
   accepts no liability in relation thereto.
                  
-->

<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:graphic="http://www.hsfr.org.uk/Schema/Graphic"
   xmlns:list="http://www.hsfr.org.uk/Schema/List"
   xmlns:link="http://www.hsfr.org.uk/Schema/Link"
   xmlns:text="http://www.hsfr.org.uk/Schema/Text" 
	xmlns:news="http://www.hsfr.org.uk/Schema/News" 
	xmlns:page="http://www.hsfr.org.uk/Schema/Page" 
   xmlns:paloose="http://www.paloose.org/schemas/Paloose/1.0"
   version="1.0">
   

	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
	<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
	
	<xsl:template name="processDate">
	   <xsl:param name="inDate"/>
	   <xsl:param name="inLocale"/>
	   <xsl:variable name="year">
			<xsl:value-of select="substring-before( $inDate, '-' )"/>
		</xsl:variable>
		<xsl:variable name="monthDay">
			<xsl:value-of select="substring-after( $inDate, '-' )"/>
		</xsl:variable>
		<xsl:variable name="month">
			<xsl:value-of select="substring-before( $monthDay, '-' )"/>
		</xsl:variable>
		<xsl:variable name="monthString">
			<xsl:value-of select="//list:list[@id='longMonths']/list:item[@id=$month]"/>
		</xsl:variable>
		<xsl:variable name="dayString">
			<xsl:value-of select="substring-after( $monthDay, '-' )"/>
		</xsl:variable>
		<xsl:variable name="day">
			<xsl:choose>
				<xsl:when test="starts-with( $dayString, '0' )">
					<xsl:value-of select="substring-after( $dayString, '0' )"/>
				</xsl:when>
				<xsl:otherwise><xsl:value-of select="$dayString"/></xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		
		<xsl:choose>
		   <xsl:when test="$inLocale = 'de'">
				<xsl:value-of select="concat( $day, '. ', $monthString, ' ', $year )"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="concat( $day, ' ', $monthString, ' ', $year )"/>
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>
	
</xsl:stylesheet>
