<?xml version="1.0"?>
   
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:t="http://www.hsfr.org.uk/Schema/Text"
   xmlns:page="http://www.hsfr.org.uk/Schema/Page" xmlns:sql="http://apache.org/cocoon/SQL/2.0"
   xmlns:pf="http://www.paloose.org/schemas/Forms/1.0" version="1.0">

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->

   <xsl:template match="sql:row-set[ @name = 'selectDeleteComposer' ]">
      <xsl:element name="pf:select1">
         <xsl:attribute name="appearance">full</xsl:attribute>
         <xsl:attribute name="ref">
            <xsl:value-of select="@name"/>
         </xsl:attribute>
         <xsl:element name="pf:violations"/>
         <xsl:element name="pf:choices">
            <xsl:for-each select="sql:row">
               <xsl:element name="pf:item">
                  <xsl:element name="pf:label">
                     <xsl:value-of select="sql:name"/>
                     <xsl:text>, </xsl:text>
                     <xsl:value-of select="sql:forenames"/>
                  </xsl:element>
                  <xsl:element name="pf:value">
                     <xsl:value-of select="sql:name"/>
                  </xsl:element>
               </xsl:element>
            </xsl:for-each>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->

   <xsl:template match="sql:row-set[ @name = 'confirmDeleteComposer' ]">
      <xsl:element name="pf:output">
         <xsl:attribute name="appearance">full</xsl:attribute>
         <xsl:attribute name="ref">
            <xsl:value-of select="@name"/>
         </xsl:attribute>
         <xsl:element name="pf:label">Composer name:</xsl:element>
         <xsl:element name="pf:value">
            <xsl:value-of select="sql:row/sql:name"/>
            <xsl:text>, </xsl:text>
            <xsl:value-of select="sql:row/sql:forenames"/>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->

   <xsl:template match="sql:row-set[ @name = 'getComposerId' ]">
      <xsl:element name="pf:hidden">
         <xsl:attribute name="ref">composerId</xsl:attribute>
         <xsl:element name="pf:value">
            <xsl:value-of select="sql:row/sql:id"/>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->

   <xsl:template match="node()|@*" priority="-1">
      <xsl:copy>
         <xsl:apply-templates select="@*"/>
         <xsl:apply-templates/>
      </xsl:copy>
   </xsl:template>

</xsl:stylesheet>
