<?xml version="1.0" encoding="UTF-8"?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--

	SQL Example Transform

	 Author:
		Name  : Hugh Field-Richards
		Email : hsfr@hsfr.org.uk

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

   Date                   Who    Changes
   ==========================================================================

   3rd December 2009      HSFR   Created
   
-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- Copyright -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   
   LICENSE:
   
   This software is free software; you can redistribute it and/or modify it
   under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation; either version 2.1 of the License, or (at
   your option) any later version.
   
   This library is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
   details.
   
   COPYRIGHT:
   
   Copyright 2006, 2007 Hugh Field-Richards.
   
-->

<xsl:stylesheet 
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:list="http://www.hsfr.org.uk/Schema/List" 
   xmlns:t="http://www.hsfr.org.uk/Schema/Text"
   xmlns:sql="http://apache.org/cocoon/SQL/2.0" 
   version="1.0">

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Parameters brought in from sitemap
   -->

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Global variables
   -->

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- 
     <default:row-set nrofrows="8" name="music" xmlns="http://apache.org/cocoon/SQL/2.0">
        <default:row>
           <default:name>Mozart</default:name>
           <default:forenames>Wolfgang Amadeus</default:forenames>
           <default:birth>1756-01-27</default:birth>
           <default:death>1791-12-05</default:death>
        </default:row>
        ...
     </default:row-set>
   -->

   <xsl:template match="sql:row-set[ @name = 'displayAll' ]">
      <xsl:element name="list:list">
         <xsl:attribute name="type">unordered</xsl:attribute>
         <xsl:for-each select="sql:row">
            <xsl:element name="list:item">
               <xsl:value-of select="sql:name"/>
               <xsl:text>, </xsl:text>
               <xsl:value-of select="sql:forenames"/>

               <xsl:choose>
                  <xsl:when test="not( sql:birth='' and sql:death='' )">
                     <xsl:text> (</xsl:text>
                     <xsl:value-of select="sql:birth"/>
                     <xsl:text> &#x2013; </xsl:text>
                     <xsl:value-of select="sql:death"/>
                     <xsl:text>)</xsl:text>
                  </xsl:when>
                  <xsl:when test="not( sql:birth='' )">
                     <xsl:text> (b.</xsl:text>
                     <xsl:value-of select="sql:birth"/>
                     <xsl:text>)</xsl:text>
                  </xsl:when>
                  <xsl:when test="not( sql:death='' )">
                     <xsl:text> (d.</xsl:text>
                     <xsl:value-of select="sql:death"/>
                     <xsl:text>)</xsl:text>
                  </xsl:when>
               </xsl:choose>
            </xsl:element>
         </xsl:for-each>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->

   <xsl:template match="sql:result[ . = 'true' ]">
      <xsl:element name="t:p">
         <xsl:text>Operation complete!</xsl:text>
      </xsl:element>
   </xsl:template>

   <xsl:template match="sql:result">
      <xsl:element name="t:p">
         <xsl:text>Problem with operation: </xsl:text>
         <xsl:value-of select="."/>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- 
		Soak up any remaining elements not processed by the above
	-->

   <xsl:template match="node()|@*" priority="-1">
      <xsl:copy>
         <xsl:apply-templates select="@*"/>
         <xsl:apply-templates/>
      </xsl:copy>
   </xsl:template>

</xsl:stylesheet>
