<?xml version="1.0" encoding="UTF-8"?>

<!DOCTYPE xsl:stylesheet [
   <!ENTITY lt			"&#38;#60;" >		<!-- less-than sign -->
   <!ENTITY gt			"&#62;" >			<!-- greater-than sign -->
	<!ENTITY ndash		"&#x2013;" >		<!-- en dash -->
	<!ENTITY mdash		"&#x2014;" >		<!-- em dash -->
	<!ENTITY ldquo  	"&#x201c;">			<!-- Left Double Quote -->
   <!ENTITY rdquo  	"&#x201d;">			<!-- Right Double Quote -->
   <!ENTITY lsquo  	"&#x2018;">			<!-- Left Single Quote -->
   <!ENTITY rsquo  	"&#x2019;">			<!-- Right Single Quote -->
   <!ENTITY nbsp		"&#160;" >			<!-- no break (required) space -->
   <!ENTITY apos		"&#39;" >			<!-- apostrophe -->
] >

<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
   xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl"
   xmlns:php="http://php.net/xsl"
   exclude-result-prefixes="xd"
   xmlns:xi="http://www.w3.org/2001/XInclude"
   xmlns:paloose="http://www.paloose.org/schemas/Paloose/1.0" 
   xmlns:pcms="http://www.paloose.org/schemas/CMS/1.0"
   version="1.0">

   <xd:doc scope="stylesheet">
      <xd:desc>
         <xd:p>
            <xd:b>Strip Comments Transform</xd:b>
         </xd:p>
         <xd:p><xd:b>Created on:</xd:b>21st September 2011</xd:p>
         <xd:p><xd:b>Author:</xd:b> Hugh Field-Richards (hsfr@hsfr.org.uk)</xd:p>
         <xd:p><xd:b>License:</xd:b> This software is free software; you can redistribute it and/or modify it under the terms of the GNU
            Lesser General Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your
            option) any later version. This software is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
            even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for
            more details.</xd:p>

         <xd:p>This stylesheet takes an XML file and removes the comments.</xd:p>
      </xd:desc>
   </xd:doc>
   
   <xsl:output
      method="xml"
      version="1.0"
      encoding="UTF-8"
      omit-xml-declaration="no"
      standalone="yes"
      indent="yes"
      media-type="text/xml"/>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   
   <xsl:template match="comment()"/>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->

  <xsl:template match="node()|@*" priority="-1">
      <xsl:copy>
         <xsl:apply-templates select="@*"/>
         <xsl:apply-templates/>
      </xsl:copy>
   </xsl:template>



</xsl:stylesheet>
