<?xml version="1.0"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

   <xsl:template match="/">
      <xsl:apply-templates/>
   </xsl:template>

   <xsl:template match="b">
      <xsl:text>b (original):</xsl:text>
      <xsl:value-of select="."/>
      <xsl:text>
b (translated):</xsl:text>
      <xsl:variable name="str-1">
         <xsl:call-template name="replace">
            <xsl:with-param name="string" select="."/>
            <xsl:with-param name="pattern">
               <xsl:text>"</xsl:text>
            </xsl:with-param>
            <xsl:with-param name="replacement">
               <xsl:text>''</xsl:text>
            </xsl:with-param>
         </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="str-2">
         <xsl:call-template name="replace">
            <xsl:with-param name="string" select="$str-1"/>
            <xsl:with-param name="pattern">
               <xsl:text>&#x2014;</xsl:text>
            </xsl:with-param>
            <xsl:with-param name="replacement">
               <xsl:text>---</xsl:text>
            </xsl:with-param>
         </xsl:call-template>
      </xsl:variable>
      <xsl:value-of select="$str-2"/>
   </xsl:template>

   <xsl:template name="replace">
      <xsl:param name="string" select="''"/>
      <xsl:param name="pattern" select="''"/>
      <xsl:param name="replacement" select="''"/>
      <xsl:choose>
         <xsl:when test="$pattern != '' and $string != '' and contains($string, $pattern)">
            <xsl:value-of select="substring-before($string, $pattern)"/>
            <xsl:copy-of select="$replacement"/>
            <xsl:call-template name="replace">
               <xsl:with-param name="string" select="substring-after($string, $pattern)"/>
               <xsl:with-param name="pattern" select="$pattern"/>
               <xsl:with-param name="replacement" select="$replacement"/>
            </xsl:call-template>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$string"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>


</xsl:stylesheet>
