<?xml version="1.0"?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--
   
   RSS Transform
   =============
   
   Author:
      Name  : Hugh Field-Richards
      Email : hsfr@hsfr.org.uk
   
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   
   Version   Date                   Who    Changes
   ==========================================================================
   
   0.00-0    15th May 2006          HSFR   Created
   
   -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- Copyright -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
   
   This software is published under the terms of the LGPL License
   a copy of which has been included with this distribution in the LICENSE file.
   
-->

<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:graphic="http://www.hsfr.org.uk/Schema/Graphic"
   xmlns:list="http://www.hsfr.org.uk/Schema/List"
   xmlns:link="http://www.hsfr.org.uk/Schema/Link"
   xmlns:text="http://www.hsfr.org.uk/Schema/Text" 
   xmlns:news="http://www.hsfr.org.uk/Schema/News" 
   xmlns:page="http://www.hsfr.org.uk/Schema/Page" 
   version="1.0">
   
   <xsl:param name="locale"/>
   <xsl:variable name="gLanguage">
      <xsl:choose>
         <xsl:when test="string-length($locale) > 0">
            <xsl:value-of select="$locale"/>
         </xsl:when>
         <xsl:otherwise>en</xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- 
      <news:channel id="20060605">
      <news:date>2006-06-05</news:date>
      <news:title>Arrival</news:title>
      <news:link></news:link>
      <news:description>First edition released.</news:description>
      <news:language>English</news:language>
      <news:text>First edition of the Paloose engine issued.</news:text>
      </news:channel>
   -->   

   <xsl:template match="/">
      <xsl:element name="rss">
         <xsl:attribute name="version">2.0</xsl:attribute>
         <xsl:element name="channel">
            <xsl:element name="title">Paloose News</xsl:element>
            <xsl:element name="link">http://www.paloose.org/</xsl:element>
            <xsl:element name="description">What is happening to the Paloose Program</xsl:element>
            <xsl:element name="language"><xsl:value-of select="$gLanguage"/></xsl:element>
            <xsl:element name="copyright">Copyrght 2006 Hugh Field-Richards</xsl:element>
            <xsl:for-each select="//news:channel">
               <xsl:element name="item">
                  <xsl:element name="title"><xsl:value-of select="news:title"/></xsl:element>
                  <xsl:element name="description"><xsl:value-of select="news:text"/></xsl:element>
                  <xsl:element name="link">http://www.paloose.org/</xsl:element>
                  <xsl:element name="pubdata"><xsl:value-of select="news:date"/></xsl:element>
               </xsl:element>
            </xsl:for-each>
         </xsl:element>
      </xsl:element>
   </xsl:template>
   
</xsl:stylesheet>

