<?xml version="1.0" encoding="UTF-8"?>

<!--
  Copyright 1999-2004 The Apache Software Foundation

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

      http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
-->

<!--+
    | XSLT REC Compliant Version of IE5 Default Stylesheet
    |
    | Original version by Jonathan Marsh (jmarsh@microsoft.com)
    | Conversion to XSLT 1.0 REC Syntax by Steve Muench (smuench@oracle.com)
    | Added script support by Andrew Timberlake (andrew@timberlake.co.za)
    | Cleaned up and ported to standard DOM by Stefano Mazzocchi (stefano@apache.org)
    | More cleansing by Hugh Field-Richards (hsfr@hsfr.org.uk)
    |
    | CVS $Id: xml2html.xslt,v 1.10 2004/05/01 13:20:55 joerg Exp $
    +-->
    
<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
   xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl"
   exclude-result-prefixes="xd"
   version="1.0">

   <xd:doc scope="stylesheet">
      <xd:desc>
         <xd:p><xd:b>Created on:</xd:b> Sep 30, 2010</xd:p>
         <xd:p><xd:b>Author:</xd:b> Hugh Field-Richards</xd:p>
         <xd:p/>
      </xd:desc>
   </xd:doc>
   
   <xsl:output encoding="UTF-8" indent="no"/>

   <xsl:strip-space elements="*"/>

   <xsl:template match="/">
      <html>
         <xsl:call-template name="head"/>
         <body>
            <xsl:apply-templates/>
         </body>
      </html>
   </xsl:template>

   <xsl:template name="head">
      <head>
         <style>
            body {
               background-color: white;
               color: black;
               font-family: monospace;
            }
            
            .b {
               cursor: pointer;
               color: red;
               font-weight: bold;
               text-decoration: none;
               padding-right: 2px;
            }
            
            .e {
               border: 0px;
               padding: 0px;
               margin: 0px 0px 0px 2em;
               text-indent: -1em;
            }
            
            .emptyElement {
               border: 0px;
               padding: 0px;
               margin: 0px 0px 0px 2em;
               text-indent: -1em;
            }
            
            .elementWithText {
               border: 0px;
               padding: 0px;
               margin: 0px 0px 0px 2em;
               text-indent: -1em;
            }
            
            .element {
               border: 0px;
               padding: 0px;
               margin: 0px 0px 0px 2em;
               text-indent: -1em;
            }
            
            .elementName {
               color: #000088;
               font-weight: bold;
            }
            
            .attributeName {
            color: #880000
            }
            
            .attributeValue {
            color: #888888
            }
            
            .c {
            color: #008800
            }
            
            .t {
            color: black
            }
            
            .text {
            color: black
            }
            
            .m {
            color: navy
            }
            
            .processingInstruction {
            color: red
            }
            
            pre {
               margin: 0px;
            display: inline
            }
            
            div {
               border: 0;
               padding: 0;
               margin: 0;
            }</style>
         <script><xsl:comment><![CDATA[
function click(event) {

    var mark = event.target;
    while ((mark.className != "b") && (mark.nodeName != "BODY")) {
        mark = mark.parentNode
    }

    var e = mark;
    while ((e.className != "e") && (e.nodeName != "BODY")) {
        e = e.parentNode
    }

    if (mark.childNodes[0].nodeValue == "+") {
        mark.childNodes[0].nodeValue = "-";
        for (var i = 2; i < e.childNodes.length; i++) {
            var name = e.childNodes[i].nodeName;
            if (name != "#text") {
                if (name == "pre" || name == "span") {
                   window.status = "inline";
                   e.childNodes[i].style.display = "inline";
                } else {
                   e.childNodes[i].style.display = "block";
                }
            }
        }
    } else if (mark.childNodes[0].nodeValue == "-") {
        mark.childNodes[0].nodeValue = "+";
        for (var i = 2; i < e.childNodes.length; i++) {
            if (e.childNodes[i].nodeName != "#text") {
                e.childNodes[i].style.display = "none";
            }
        }
    }
}  
]]></xsl:comment>
            </script>
      </head>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Match processing instructions
   -->

   <xsl:template match="processing-instruction()">
      <xsl:element name="div">
         <xsl:attribute name="class">e</xsl:attribute>
         <xsl:element name="span">
            <xsl:attribute name="class">m</xsl:attribute>
            <xsl:text>&lt;?</xsl:text>
         </xsl:element>
         <xsl:element name="span">
            <xsl:attribute name="class">processingInstruction</xsl:attribute>
            <xsl:value-of select="name(.)"/>
            <xsl:text> </xsl:text>
            <xsl:value-of select="."/>
         </xsl:element>
         <xsl:element name="span">
            <xsl:attribute name="class">m</xsl:attribute>
            <xsl:text>?&gt;</xsl:text>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Match text
   -->

   <xsl:template match="text()">
      <xsl:element name="div">
         <xsl:attribute name="class">e</xsl:attribute>
         <xsl:element name="span">
            <xsl:attribute name="class">t</xsl:attribute>
            <xsl:value-of select="."/>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Match comments
   -->

   <xsl:template match="comment()">
      <xsl:element name="div">
         <xsl:attribute name="class">e</xsl:attribute>
         <xsl:element name="span">
            <xsl:attribute name="class">b</xsl:attribute>
            <xsl:attribute name="onclick">click(event)</xsl:attribute>
            <xsl:text>-</xsl:text>
         </xsl:element>
         <xsl:element name="span">
            <xsl:attribute name="class">m</xsl:attribute>
            <xsl:text>&lt;!--</xsl:text>
         </xsl:element>
         <xsl:element name="span">
            <xsl:attribute name="class">c</xsl:attribute>
            <xsl:element name="pre">
               <xsl:value-of select="."/>
            </xsl:element>
         </xsl:element>
         <xsl:element name="span">
            <xsl:attribute name="class">m</xsl:attribute>
            <xsl:text>--></xsl:text>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Match attributes
   -->

   <xsl:template match="@*">
      <xsl:element name="span">
         <xsl:attribute name="class">attributeName</xsl:attribute>
         <xsl:value-of select="name(.)"/>
      </xsl:element>
      <xsl:element name="span">
         <xsl:attribute name="class">m</xsl:attribute>
         <xsl:text>="</xsl:text>
      </xsl:element>
      <xsl:element name="span">
         <xsl:attribute name="class">attributeValue</xsl:attribute>
         <xsl:value-of select="."/>
      </xsl:element>
      <xsl:element name="span">
         <xsl:attribute name="class">m</xsl:attribute>
         <xsl:text>"</xsl:text>
      </xsl:element>
      <xsl:if test="position()!=last()">&#160;</xsl:if>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Match empty elements
   -->

   <xsl:template match="*[not(node())]">
      <xsl:element name="div">
         <xsl:attribute name="class">emptyElement</xsl:attribute>
         <xsl:element name="span">
            <xsl:attribute name="class">m</xsl:attribute>
            <xsl:text>&lt;</xsl:text>
         </xsl:element>
         <xsl:element name="span">
            <xsl:attribute name="class">elementName</xsl:attribute>
            <xsl:value-of select="name(.)"/>
         </xsl:element>
         <xsl:if test="@*">&#160;</xsl:if>
         <xsl:apply-templates select="@*"/>
         <xsl:apply-templates select="." mode="namespace"/>
         <xsl:element name="span">
            <xsl:attribute name="class">m</xsl:attribute>
            <xsl:text>/&gt;</xsl:text>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Match elements with only text(), they are not closeable
   -->

   <xsl:template match="*[text()][not(* or comment() or processing-instruction())]" priority="10">
      <xsl:element name="div">
         <xsl:attribute name="class">elementWithText</xsl:attribute>
         <xsl:element name="span">
            <xsl:attribute name="class">m</xsl:attribute>
            <xsl:text>&lt;</xsl:text>
         </xsl:element>
         <xsl:element name="span">
            <xsl:attribute name="class">elementName</xsl:attribute>
            <xsl:value-of select="name(.)"/>
         </xsl:element>
         <xsl:if test="@*">
            <xsl:text>&#160;</xsl:text>
            <xsl:apply-templates select="@*"/>
         </xsl:if>
         <xsl:apply-templates select="." mode="namespace"/>
         <xsl:element name="span">
            <xsl:attribute name="class">m</xsl:attribute>
            <xsl:text>&gt;</xsl:text>
         </xsl:element>
         <!-- Output the text in this element -->
         <xsl:element name="span">
            <xsl:attribute name="class">text</xsl:attribute>
            <xsl:value-of select="."/>
         </xsl:element>
         <!-- Output closing tag -->
         <xsl:element name="span">
            <xsl:attribute name="class">m</xsl:attribute>
            <xsl:text>&lt;/</xsl:text>
         </xsl:element>
         <xsl:element name="span">
            <xsl:attribute name="class">elementName</xsl:attribute>
            <xsl:value-of select="name(.)"/>
         </xsl:element>
         <xsl:element name="span">
            <xsl:attribute name="class">m</xsl:attribute>
            <xsl:text>&gt;</xsl:text>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Match all other elements
   -->

   <xsl:template match="*[node()]">
      <xsl:element name="div">
         <xsl:attribute name="class">element</xsl:attribute>
         <xsl:element name="div">
            <xsl:element name="span">
               <xsl:attribute name="class">b</xsl:attribute>
               <xsl:attribute name="onclick">click(event)</xsl:attribute>
               <xsl:text>-</xsl:text>
            </xsl:element>
            <xsl:element name="span">
               <xsl:attribute name="class">m</xsl:attribute>
               <xsl:text>&lt;</xsl:text>
            </xsl:element>
            <xsl:element name="span">
               <xsl:attribute name="class">elementName</xsl:attribute>
               <xsl:value-of select="name(.)"/>
            </xsl:element>
            <xsl:if test="@*">&#160;</xsl:if>
            <xsl:apply-templates select="@*"/>
            <xsl:apply-templates select="." mode="namespace"/>
            <xsl:element name="span">
               <xsl:attribute name="class">m</xsl:attribute>
               <xsl:text>&gt;</xsl:text>
            </xsl:element>
         </xsl:element>
         <xsl:element name="div">
            <xsl:apply-templates/>
            <!-- closing element tag -->
            <xsl:element name="div">
               <xsl:element name="span">
                  <xsl:attribute name="class">m</xsl:attribute>
                  <xsl:text>&lt;/</xsl:text>
               </xsl:element>
               <xsl:element name="span">
                  <xsl:attribute name="class">elementName</xsl:attribute>
                  <xsl:value-of select="name(.)"/>
               </xsl:element>
               <xsl:element name="span">
                  <xsl:attribute name="class">m</xsl:attribute>
                  <xsl:text>&gt;</xsl:text>
               </xsl:element>
            </xsl:element>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->

   <xsl:template match="*" mode="namespace">
      <xsl:variable name="context" select="."/>
      <xsl:for-each select="namespace::node()">
         <xsl:variable name="nsuri" select="."/>
         <xsl:variable name="nsprefix" select="name()"/>
         <xsl:choose>
            <xsl:when test="$nsprefix = 'xml'">
               <!-- xml namespace -->
            </xsl:when>
            <xsl:when test="$context/../namespace::node()[name() = $nsprefix and . = $nsuri]">
               <!-- namespace already declared on the parent -->
            </xsl:when>
            <xsl:otherwise>
               <xsl:text>&#160;</xsl:text>
               <xsl:element name="span">
                  <xsl:attribute name="class">attributeName</xsl:attribute>
                  <xsl:text>xmlns</xsl:text>
                  <xsl:if test="$nsprefix">
                     <xsl:text>:</xsl:text>
                     <xsl:value-of select="$nsprefix"/>
                  </xsl:if>
               </xsl:element>
               <xsl:element name="span">
                  <xsl:attribute name="class">m</xsl:attribute>
                  <xsl:text>="</xsl:text>
               </xsl:element>
               <xsl:element name="span">
                  <xsl:attribute name="class">attributeValue</xsl:attribute>
                  <xsl:value-of select="."/>
               </xsl:element>
               <xsl:element name="span">
                  <xsl:attribute name="class">m</xsl:attribute>
                  <xsl:text>"</xsl:text>
               </xsl:element>
            </xsl:otherwise>
         </xsl:choose>
      </xsl:for-each>
   </xsl:template>

</xsl:stylesheet>
