<?xml version="1.0" encoding="UTF-8"?>

<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
<!--
	
	XSL to XHTML Pretty Printer
	
	This XSLT style sheet pretty prints a RELAX NG schema. It has been tested
	on the current Xalan processor and renders to most browsers (Safari, IE, Mozilla,
	Netscape etc). It was inspired by the DSD-1 Schema pretty printer written by Nils
	Klarlund for the original DSD-1, and mine for the DSD-2 Schema language - the
	best (unknown) schema language there is.
	
	Schematron inserts are also fully supported.
	
	Author:
   	Name  : Hugh Field-Richards.
   	Email : hsfr@hsfr.org.uk
	
	-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
	-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
	
	Date                   Who    Changes
	==========================================================================

   9th February 2005      HSFR   Created
	15th February 2005     HSFR   Issued
	8th March 2006         HSFR   Corrected nsName problem (not present)
	17th November 2009     HSFR   Major cleaning up
	
   LICENSE:
   
   This software is free software; you can redistribute it
   and/or modify it under the terms of the GNU Lesser General
   Public License as published by the Free Software Foundation;
   either version 2.1 of the License, or (at your option) any
   later version.
   
   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this software; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
	
-->
    
<!DOCTYPE xsl:stylesheet [
   <!ENTITY lt         "&#38;#60;" >     <!-- less-than sign -->
   <!ENTITY gt         "&#62;" >         <!-- greater-than sign -->
   <!ENTITY ndash      "&#x2013;" >      <!-- en dash -->
   <!ENTITY mdash      "&#x2014;" >      <!-- em dash -->
   <!ENTITY ldquo      "&#x201c;">       <!-- Left Double Quote -->
   <!ENTITY rdquo      "&#x201d;">       <!-- Right Double Quote -->
   <!ENTITY lsquo      "&#x2018;">       <!-- Left Single Quote -->
   <!ENTITY rsquo      "&#x2019;">       <!-- Right Single Quote -->
   <!ENTITY nbsp       "&#160;" >        <!-- no break (required) space -->
   <!ENTITY apos       "&#39;" >         <!-- apostrophe -->
   <!ENTITY agrave     "&#224;" >        <!-- small a, grave accent -->   
   <!ENTITY aacute     "&#225;" >        <!-- small a, acute accent -->
   <!ENTITY acirc      "&#226;" >        <!-- small a, circumflex accent -->
   <!ENTITY auml       "&#228;" >        <!-- small a, dieresis or umlaut mark -->
   <!ENTITY ouml       "&#246;" >        <!-- small o, dieresis or umlaut mark -->
   <!ENTITY ocirc      "&#244;" >        <!-- small o, circumflex accent -->
   <!ENTITY egrave     "&#232;" >        <!-- small e, grave accent -->
   <!ENTITY eacute     "&#233;" >        <!-- small e, acute accent -->
   <!ENTITY ecirc      "&#234;" >        <!-- small e, circumflex accent -->
   <!ENTITY euml       "&#235;" >        <!-- small e, dieresis or umlaut mark -->
   <!ENTITY uuml       "&#252;" >        <!-- small u, dieresis or umlaut mark -->
   <!ENTITY frac14     "&#188;" >        <!-- fraction one-quarter -->
   <!ENTITY rcaron     "&#x159;" >       <!-- small r, caron -->
   <!ENTITY ntilde     "&#241;" >        <!-- small n, tilde -->
   <!ENTITY szlig      "&#223;" >        <!-- small sharp s, German (sz ligature) -->
   <!ENTITY larr       "&#x2190;" >      <!-- left arrow -->
   <!ENTITY rarr       "&#x2192;" >      <!-- right arrow -->
   <!ENTITY uarr       "&#x2191;" >      <!-- up arrow -->
   <!ENTITY darr       "&#x2193;" >      <!-- downward arrow -->
   <!ENTITY copy       "&#169;" >        <!--=copyright sign -->
] >
    
<xsl:stylesheet 
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
   xmlns="http://relaxng.org/ns/structure/1.0"
   xmlns:rng="http://relaxng.org/ns/structure/1.0" 
   xmlns:a="http://relaxng.org/ns/annotation/1.0"
   xmlns:dc="http://purl.org/dc/elements/1.1/" 
   xmlns:xhtml="http://www.w3.org/1999/xhtml" 
   xmlns:sch="http://www.ascc.net/xml/schematron"
   version="1.0" xml:lang="en" id="rng-html">

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Parameters brought in from sitemap
   -->

   <xsl:param name="stylesDir"/>

   <xsl:strip-space elements="*"/>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Comma separated list of style files. Semicolon for style files - don't ask.
   -->

   <xsl:variable name="gCSSFilesDir" select="'/pp/resources/styles/'"/>
   <xsl:variable name="gCSSFiles" select="'prettyXSL.css,prettyXML.css'"/>

   <xsl:variable name="gScriptFilesDir" select="'/pp/resources/scripts/'"/>
   <xsl:variable name="gScriptFiles" select="'jquery.js;prettyXML.js'"/>

   <xsl:variable name="gPageTitle" select="'XSL'"/>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

   <xsl:template match="/">
      <xsl:element name="html">
         <xsl:attribute name="lang">en</xsl:attribute>
         <xsl:call-template name="output.header"/>
         <xsl:call-template name="output.body"/>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
	   Any external XSL files to be included go here. These go at the end to make sure
	   the above override them.
   -->

   <xsl:include href="buildHeader.xsl"/>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

   <xsl:template name="output.header">
      <xsl:element name="head">
         <xsl:call-template name="buildHeader.htmlHead">
            <xsl:with-param name="inTitle" select="$gPageTitle"/>
            <xsl:with-param name="inStylesList" select="$gCSSFiles"/>
            <xsl:with-param name="inStylesDir" select="$gCSSFilesDir"/>
            <xsl:with-param name="inScriptsList" select="$gScriptFiles"/>
            <xsl:with-param name="inScriptsDir" select="$gScriptFilesDir"/>
         </xsl:call-template>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

   <xsl:template name="output.body">
      <xsl:element name="body">
         <xsl:apply-templates/>
         <!-- xsl:element name="div">
            <xsl:attribute name="class">globalParametersBlock</xsl:attribute>
            <xsl:apply-templates mode="parameters" select="/xsl:stylesheet/xsl:param"/>
         </xsl:element>
         <xsl:element name="div">
            <xsl:attribute name="class">globalVariablesBlock</xsl:attribute>
            <xsl:apply-templates select="/xsl:stylesheet/xsl:variable" mode="variables"/>
         </xsl:element>
         <xsl:element name="div">
            <xsl:attribute name="class">templatesBlock</xsl:attribute>
            <xsl:apply-templates select="/xsl:stylesheet/xsl:template" mode="templates"/>
         </xsl:element>
-->
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

   <xsl:template match="xsl:param">
      <xsl:variable name="parameterName" select="@name"/>
      <xsl:variable name="parameterNameString" select="string( @name )"/>
      <xsl:variable name="uniqueId" select="generate-id()"/>

      <xsl:element name="a">
         <xsl:attribute name="name">
            <xsl:value-of select="$uniqueId"/>
         </xsl:attribute>
      </xsl:element>

      <xsl:element name="div">
         <xsl:attribute name="class">parameterBlock</xsl:attribute>

         <!-- xsl:element name="div">
            <xsl:attribute name="class">parameterDescription</xsl:attribute>
            <xsl:element name="span">
               <xsl:attribute name="class">parameterDescription</xsl:attribute>
               <xsl:value-of select="preceding-sibling::*[1]"/>
            </xsl:element>
         </xsl:element -->

         <xsl:element name="table">
            <xsl:attribute name="class">parameterBlock</xsl:attribute>

            <xsl:element name="tr">
               <xsl:attribute name="class">varDefinition</xsl:attribute>
               <xsl:attribute name="valign">top</xsl:attribute>

               <xsl:element name="td">
                  <xsl:attribute name="class">parameterName</xsl:attribute>
                  <xsl:element name="div">
                     <xsl:attribute name="class">parameterName</xsl:attribute>

                     <xsl:value-of select="$parameterName"/>
                  </xsl:element>
               </xsl:element>

               <xsl:element name="td">
                  <xsl:attribute name="class">parameterEquals</xsl:attribute>
                  <xsl:element name="div">
                     <xsl:attribute name="class">parameterEquals</xsl:attribute>
                     <xsl:text>=</xsl:text>
                  </xsl:element>
               </xsl:element>

               <xsl:element name="td">
                  <xsl:attribute name="class">parameterValue</xsl:attribute>
                  <xsl:choose>
                     <xsl:when test="child::*">
                        <xsl:element name="div">
                           <xsl:attribute name="class">parameterCode</xsl:attribute>
                           <xsl:apply-templates select="child::*" mode="code"/>
                        </xsl:element>
                     </xsl:when>
                     <xsl:when test="@select">
                        <xsl:element name="div">
                           <xsl:attribute name="class">parameterValue</xsl:attribute>
                           <xsl:value-of select="@select"/>
                        </xsl:element>
                     </xsl:when>
                     <xsl:otherwise>
                        <xsl:text>No default/select value</xsl:text>
                     </xsl:otherwise>
                  </xsl:choose>
               </xsl:element>
            </xsl:element>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

   <xsl:template match="xsl:include">
      <xsl:variable name="fileName" select="@href"/>
      <xsl:variable name="parameterNameString" select="string( @name )"/>

      <xsl:element name="table">
         <xsl:attribute name="class">parameterBlock</xsl:attribute>

         <xsl:element name="tr">
            <xsl:attribute name="class">varDefinition</xsl:attribute>
            <xsl:attribute name="valign">top</xsl:attribute>
            <xsl:element name="td">
               <xsl:attribute name="class">parameterName</xsl:attribute>
               <xsl:element name="div">
                  <xsl:attribute name="class">parameterName</xsl:attribute>

                  <xsl:value-of select="$fileName"/>
               </xsl:element>
            </xsl:element>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

   <xsl:template match="xsl:variable">
      <xsl:variable name="variableName" select="@name"/>
      <xsl:variable name="parameterNameString" select="string( @name )"/>
      <xsl:variable name="uniqueId" select="generate-id()"/>

      <xsl:element name="a">
         <xsl:attribute name="name">
            <xsl:value-of select="$uniqueId"/>
         </xsl:attribute>
      </xsl:element>
      <xsl:element name="div">
         <xsl:attribute name="class">variableBlock</xsl:attribute>

         <xsl:element name="table">
            <xsl:attribute name="class">variableBlock</xsl:attribute>

            <xsl:element name="tr">
               <xsl:attribute name="class">variableDefinition</xsl:attribute>
               <xsl:attribute name="valign">top</xsl:attribute>

               <xsl:element name="td">
                  <xsl:attribute name="class">variableName</xsl:attribute>
                  <xsl:element name="div">
                     <xsl:attribute name="class">variableName</xsl:attribute>
                     <xsl:value-of select="$variableName"/>
                  </xsl:element>
               </xsl:element>

               <xsl:element name="td">
                  <xsl:attribute name="class">variableEquals</xsl:attribute>
                  <xsl:element name="div">
                     <xsl:attribute name="class">variableEquals</xsl:attribute>
                     <xsl:text>=</xsl:text>
                  </xsl:element>
               </xsl:element>

               <xsl:element name="td">
                  <xsl:attribute name="class">variableValue</xsl:attribute>
                  <xsl:choose>
                     <xsl:when test="child::*">
                        <xsl:element name="div">
                           <xsl:attribute name="class">variableCode</xsl:attribute>
                           <xsl:apply-templates select="child::*" mode="code"/>
                        </xsl:element>
                     </xsl:when>
                     <xsl:when test="@select">
                        <xsl:element name="div">
                           <xsl:attribute name="class">variableValue</xsl:attribute>
                           <xsl:call-template name="addVariableLink">
                              <xsl:with-param name="inputString" select="@select"/>
                           </xsl:call-template>
                        </xsl:element>
                     </xsl:when>
                     <xsl:otherwise>
                        <xsl:text>No default/select value</xsl:text>
                     </xsl:otherwise>
                  </xsl:choose>
               </xsl:element>
            </xsl:element>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- -->

   <xsl:template match="xsl:template">
      <xsl:variable name="matchExpression" select="string( @match )"/>
      <xsl:variable name="nameExpression" select="string( @name )"/>
      <xsl:variable name="modeString" select="string( @mode )"/>
      <xsl:variable name="uniqueId" select="generate-id()"/>

      <xsl:element name="a">
         <xsl:attribute name="name">
            <xsl:value-of select="$uniqueId"/>
         </xsl:attribute>
      </xsl:element>
      <xsl:element name="div">
         <xsl:attribute name="class">variableBlock</xsl:attribute>

         <xsl:element name="table">
            <xsl:attribute name="class">variableBlock</xsl:attribute>

            <xsl:element name="tr">
               <xsl:attribute name="class">variableDefinition</xsl:attribute>
               <xsl:attribute name="valign">top</xsl:attribute>

               <xsl:element name="td">
                  <xsl:attribute name="class">variableName</xsl:attribute>
                  <xsl:element name="div">
                     <xsl:attribute name="class">variableName</xsl:attribute>
                     <xsl:value-of select="$matchExpression"/>
                  </xsl:element>
               </xsl:element>

               <xsl:element name="td">
                  <xsl:attribute name="class">variableEquals</xsl:attribute>
                  <xsl:element name="div">
                     <xsl:attribute name="class">variableEquals</xsl:attribute>
                     <xsl:text>=</xsl:text>
                  </xsl:element>
               </xsl:element>

               <xsl:element name="td">
                  <xsl:attribute name="class">variableValue</xsl:attribute>
                  <xsl:choose>
                     <xsl:when test="child::*">
                        <xsl:element name="div">
                           <xsl:attribute name="class">variableCode</xsl:attribute>
                           <xsl:apply-templates select="child::*" mode="code"/>
                        </xsl:element>
                     </xsl:when>
                     <xsl:when test="@select">
                        <xsl:element name="div">
                           <xsl:attribute name="class">variableValue</xsl:attribute>
                           <xsl:call-template name="addVariableLink">
                              <xsl:with-param name="inputString" select="@select"/>
                           </xsl:call-template>
                        </xsl:element>
                     </xsl:when>
                     <xsl:otherwise>
                        <xsl:text>No default/select value</xsl:text>
                     </xsl:otherwise>
                  </xsl:choose>
               </xsl:element>
            </xsl:element>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* TEXT TEMPLATES -*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- 
      Detecting variables in strings
   -->

   <xsl:template name="addVariableLink">
      <xsl:param name="inputString" select="."/>

      <xsl:choose>
         <xsl:when test="contains($inputString, '$')">
            <xsl:variable name="textBefore" select="substring-before($inputString, '$')"/>
            <xsl:variable name="textAfter" select="concat( '$', substring-after($inputString, '$') )"/>
            <xsl:variable name="theVarName">
               <xsl:call-template name="extractVariable">
                  <xsl:with-param name="inputString" select="$textAfter"/>
               </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="variableNameLength" select="string-length( $theVarName )"/>
            <xsl:variable name="textTail" select="substring( $textAfter, $variableNameLength + 1 )"/>
            <xsl:variable name="rawName" select="substring( $theVarName, 2 )"/>
            <xsl:variable name="variableRef" select="generate-id()"/>
            <xsl:variable name="varLink" select="concat( '#', $variableRef )"/>

            <xsl:value-of select="$textBefore"/>
            <xsl:element name="a">
               <xsl:attribute name="href">
                  <xsl:value-of select="$varLink"/>
               </xsl:attribute>
               <xsl:value-of select="$theVarName"/>
            </xsl:element>

            <xsl:call-template name="addVariableLink">
               <xsl:with-param name="inputString" select="$textTail"/>
            </xsl:call-template>
         </xsl:when>
         <xsl:otherwise>
            <!-- Nothing to expand -->
            <xsl:value-of select="$inputString"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Extract a variable from an inputted string
      -->

   <xsl:template name="extractVariable">
      <xsl:param name="inputString"/>
      <xsl:variable name="d-quote">"</xsl:variable>
      <xsl:variable name="s-quote">'</xsl:variable>
      <xsl:variable name="delimitChars" select="concat( ',;. ', $s-quote, $d-quote )"/>

      <xsl:choose>
         <xsl:when test="string-length($inputString) &gt;= 2">
            <xsl:variable name="firstChar" select="substring( $inputString, 1, 1)"/>
            <xsl:variable name="remainingChars" select="substring( $inputString, 2 )"/>
            <xsl:choose>
               <xsl:when test="not( contains( $delimitChars, $firstChar ) )">
                  <!-- Still in variable -->
                  <xsl:variable name="n">
                     <xsl:call-template name="extractVariable">
                        <xsl:with-param name="inputString" select="$remainingChars"/>
                     </xsl:call-template>
                  </xsl:variable>
                  <xsl:value-of select="concat( $firstChar, $n )"/>
               </xsl:when>
            </xsl:choose>
         </xsl:when>
         <xsl:when test="string-length($inputString) = 1">
            <xsl:variable name="firstChar" select="$inputString"/>
            <xsl:value-of select="$firstChar"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="''"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* CODE TEMPLATES -*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Match attributes
   -->

   <xsl:template match="@*" mode="code">
      <xsl:element name="span">
         <xsl:attribute name="class">attributeName</xsl:attribute>
         <xsl:value-of select="name(.)"/>
      </xsl:element>
      <xsl:element name="span">
         <xsl:attribute name="class">attributeDelimiter</xsl:attribute>
         <xsl:text>="</xsl:text>
      </xsl:element>
      <xsl:element name="span">
         <xsl:attribute name="class">attributeValue</xsl:attribute>
         <xsl:value-of select="."/>
      </xsl:element>
      <xsl:element name="span">
         <xsl:attribute name="class">attributeDelimiter</xsl:attribute>
         <xsl:text>"</xsl:text>
      </xsl:element>
      <xsl:if test="position()!=last()"> </xsl:if>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Match empty elements
   -->

   <xsl:template match="*[not(node())]" mode="code">
      <xsl:element name="div">
         <xsl:attribute name="class">emptyElement</xsl:attribute>
         <xsl:element name="span">
            <xsl:attribute name="class">tagDelimiter</xsl:attribute>
            <xsl:text>&lt;</xsl:text>
         </xsl:element>
         <xsl:element name="span">
            <xsl:attribute name="class">elementName</xsl:attribute>
            <xsl:value-of select="name(.)"/>
         </xsl:element>
         <xsl:if test="@*">
            <xsl:text> </xsl:text>
         </xsl:if>
         <xsl:apply-templates select="@*" mode="code"/>
         <xsl:apply-templates select="." mode="namespace"/>
         <xsl:element name="span">
            <xsl:attribute name="class">tagDelimiter</xsl:attribute>
            <xsl:text>/&gt;</xsl:text>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Match elements with only text(), they are not closeable
   -->

   <xsl:template match="*[text()][not(* or comment() or processing-instruction())]" priority="10" mode="code">
      <xsl:element name="div">
         <xsl:attribute name="class">elementWithText</xsl:attribute>
         <xsl:element name="span">
            <xsl:attribute name="class">m</xsl:attribute>
            <xsl:text>&lt;</xsl:text>
         </xsl:element>
         <xsl:element name="span">
            <xsl:attribute name="class">elementName</xsl:attribute>
            <xsl:value-of select="name(.)"/>
         </xsl:element>
         <xsl:if test="@*">
            <xsl:text> </xsl:text>
            <xsl:apply-templates select="@*" mode="code"/>
         </xsl:if>
         <xsl:apply-templates select="." mode="namespace"/>
         <xsl:element name="span">
            <xsl:attribute name="class">m</xsl:attribute>
            <xsl:text>&gt;</xsl:text>
         </xsl:element>
         <!-- Output the text in this element -->
         <xsl:element name="span">
            <xsl:attribute name="class">text</xsl:attribute>
            <xsl:value-of select="."/>
         </xsl:element>
         <!-- Output closing tag -->
         <xsl:element name="span">
            <xsl:attribute name="class">m</xsl:attribute>
            <xsl:text>&lt;/</xsl:text>
         </xsl:element>
         <xsl:element name="span">
            <xsl:attribute name="class">elementName</xsl:attribute>
            <xsl:value-of select="name(.)"/>
         </xsl:element>
         <xsl:element name="span">
            <xsl:attribute name="class">m</xsl:attribute>
            <xsl:text>&gt;</xsl:text>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
      Match all other elements. All collapsable elements have a hidden form that it will
      collapse to using the jquery code.
   -->

   <xsl:template match="*[node()]" mode="code">
      <xsl:variable name="uniqueId" select="generate-id()"/>

      <xsl:element name="div">
         <xsl:attribute name="class">elementHidden</xsl:attribute>
         <xsl:attribute name="id">
            <xsl:value-of select="$uniqueId"/>
         </xsl:attribute>
         <xsl:element name="span">
            <xsl:attribute name="class">tagDelimiter</xsl:attribute>
            <xsl:text>&lt;</xsl:text>
         </xsl:element>
         <xsl:element name="a">
            <xsl:attribute name="href">#</xsl:attribute>
            <xsl:attribute name="class">elementName</xsl:attribute>
            <xsl:value-of select="name(.)"/>
         </xsl:element>
         <xsl:if test="@*">
            <xsl:text> </xsl:text>
         </xsl:if>
         <xsl:apply-templates select="@*" mode="code"/>
         <xsl:element name="span">
            <xsl:attribute name="class">tagDelimiter</xsl:attribute>
            <xsl:text>&gt;</xsl:text>
         </xsl:element>
         <xsl:element name="span">
            <xsl:attribute name="class">text</xsl:attribute>
            <xsl:text>......</xsl:text>
         </xsl:element>
         <!-- closing element tag -->
         <xsl:element name="span">
            <xsl:attribute name="class">tagDelimiter</xsl:attribute>
            <xsl:text>&lt;/</xsl:text>
         </xsl:element>
         <xsl:element name="span">
            <xsl:attribute name="class">elementName</xsl:attribute>
            <xsl:value-of select="name(.)"/>
         </xsl:element>
         <xsl:element name="span">
            <xsl:attribute name="class">tagDelimiter</xsl:attribute>
            <xsl:text>&gt;</xsl:text>
         </xsl:element>
      </xsl:element>


      <xsl:element name="div">
         <xsl:attribute name="class">element</xsl:attribute>
         <xsl:attribute name="id">
            <xsl:value-of select="$uniqueId"/>
         </xsl:attribute>
         <xsl:element name="span">
            <xsl:attribute name="class">tagDelimiter</xsl:attribute>
            <xsl:text>&lt;</xsl:text>
         </xsl:element>
         <xsl:element name="a">
            <xsl:attribute name="href">#</xsl:attribute>
            <xsl:attribute name="class">elementName</xsl:attribute>
            <xsl:value-of select="name(.)"/>
         </xsl:element>
         <xsl:if test="@*"> </xsl:if>
         <xsl:apply-templates select="@*" mode="code"/>
         <xsl:apply-templates select="." mode="namespace"/>
         <xsl:element name="span">
            <xsl:attribute name="class">tagDelimiter</xsl:attribute>
            <xsl:text>&gt;</xsl:text>
         </xsl:element>
         <xsl:element name="div">
            <xsl:apply-templates mode="code"/>
            <!-- closing element tag -->
            <xsl:element name="div">
               <xsl:element name="span">
                  <xsl:attribute name="class">tagDelimiter</xsl:attribute>
                  <xsl:text>&lt;/</xsl:text>
               </xsl:element>
               <xsl:element name="span">
                  <xsl:attribute name="class">elementName</xsl:attribute>
                  <xsl:value-of select="name(.)"/>
               </xsl:element>
               <xsl:element name="span">
                  <xsl:attribute name="class">tagDelimiter</xsl:attribute>
                  <xsl:text>&gt;</xsl:text>
               </xsl:element>
            </xsl:element>
         </xsl:element>
      </xsl:element>
   </xsl:template>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->

   <xsl:template match="*" mode="namespace">
      <xsl:variable name="context" select="."/>
      <xsl:for-each select="namespace::node()">
         <xsl:variable name="nsuri" select="."/>
         <xsl:variable name="nsprefix" select="name()"/>
         <xsl:choose>
            <xsl:when test="$nsprefix = 'xml'">
               <!-- xml namespace -->
            </xsl:when>
            <xsl:when test="$context/../namespace::node()[name() = $nsprefix and . = $nsuri]">
               <!-- namespace already declared on the parent -->
            </xsl:when>
            <xsl:otherwise>
               <xsl:text> </xsl:text>
               <xsl:element name="span">
                  <xsl:attribute name="class">attributeName</xsl:attribute>
                  <xsl:text>xmlns</xsl:text>
                  <xsl:if test="$nsprefix">
                     <xsl:text>:</xsl:text>
                     <xsl:value-of select="$nsprefix"/>
                  </xsl:if>
               </xsl:element>
               <xsl:element name="span">
                  <xsl:attribute name="class">m</xsl:attribute>
                  <xsl:text>="</xsl:text>
               </xsl:element>
               <xsl:element name="span">
                  <xsl:attribute name="class">attributeValue</xsl:attribute>
                  <xsl:value-of select="."/>
               </xsl:element>
               <xsl:element name="span">
                  <xsl:attribute name="class">m</xsl:attribute>
                  <xsl:text>"</xsl:text>
               </xsl:element>
            </xsl:otherwise>
         </xsl:choose>
      </xsl:for-each>
   </xsl:template>



   <!-- Make sure that we eat all the Dublin core and XHTML when processing the header
		and grammar. How I hate this language :-( -->

   <xsl:template match="*[namespace-uri() = 'http://www.w3.org/1999/xhtml']">
      <xsl:element name="{local-name()}">
         <xsl:attribute name="class">html</xsl:attribute>
         <xsl:apply-templates mode="htmlDocumentation" select="."/>
      </xsl:element>
   </xsl:template>

   <xsl:template match="a:documentation" mode="parameters"/>

   <xsl:template match="xsl:template" mode="parameters"/>

   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!-- -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
   <!--
    	Pass through any that aren't eaten by the above. This is for things
    	like the XHTML documentation
    -->

   <xsl:template match="@*|node()" mode="grammar">
      <xsl:copy>
         <xsl:apply-templates select="@*|node()" mode="grammar"/>
      </xsl:copy>
   </xsl:template>

   <xsl:template match="@*|node()" mode="htmlDocumentation">
      <xsl:copy>
         <xsl:apply-templates select="@*|node()" mode="htmlDocumentation"/>
      </xsl:copy>
   </xsl:template>


</xsl:stylesheet>
